
/*
  Natjecanje timova studenata informaticara hrvatskih sveucilista 2005
  Prvo natjecanje - Zadatak RUPE

  Opis algoritma:
  Zadatak rjesavamo dinamickim programiranjem. Pretpostavimo da su nam svi 
  brojevi razliciti od nule iz prvog (odnosno drugog) reda pohranjeni u niz s1 
  (odnosno s2). Definiramo broj B[m][i][j] kao najvecu mogucu sumu odgovarajucih 
  umnozaka ako imamo m stupaca na raspolaganju, tako da u prvi red idu brojevi 
  niza s1[i..l1], a u drugi red brojevi niza s2[j..l2].
  Problem svodimo na manje probleme istog tipa tako da razmatramo tri slucaja: 
  1. u prvi stupac stavljamo s1[i] i nulu, 2. u prvi stupac stavljamo nulu i 
  s2[j], 3. u prvi stupac stavljamo s1[i] i s2[j].
  Rjesenje zadatka je broj B[n][0][0].
*/

#include <iostream>

using namespace std;

const int MAXN=400;
const int NINF=-(1<<30);

int n;
int l1;
int l2;
int s1[MAXN];
int s2[MAXN];
int B[2][MAXN+1][MAXN+1];

void citaj_ulaz (void)
{
        cin >> n;
        l1=0;
        for (int i=0; i<n; i++)
        {
                cin >> s1[l1];
                if (s1[l1]!=0) l1++;
        }
        l2=0;
        for (int i=0; i<n; i++)
        {
                cin >> s2[l2];
                if (s2[l2]!=0) l2++;
        }
}

int rijesi (void)
{
        for (int m=0; m<=n; m++)
                for (int i=0; i<=l1; i++)
                        for (int j=0; j<=l2; j++)
                        {
                                int& s=B[m%2][i][j];
                                if ((l1-i)>m || (l2-j)>m) s=NINF;
                                else if (i==l1 || j==l2) s=0;
                                else s=max(max(B[(m+1)%2][i+1][j],
                                               B[(m+1)%2][i][j+1]),
                                           B[(m+1)%2][i+1][j+1]+s1[i]*s2[j]);
                        }
        return B[n%2][0][0];
}

int main (void)
{
        citaj_ulaz();
        cout << rijesi() << endl;
        return 0;
}
