
/*
  Natjecanje timova studenata informaticara hrvatskih sveucilista 2005
  Prvo natjecanje - Zadatak SWAP

  Opis algoritma:
  Za rjesavanje zadatka potrebno je primjetiti da sa jednom zamjenom mozemo 
  smanjiti ukupan broj grupa za najvise dva. Dakle rjesenje koje svakom zamjenom 
  smanji broj grupa za dva, kad god je to moguce, mora biti optimalno. Jedan 
  nacin da se ovo postigne je da se u svakom koraku zamjene grupe 3i-1 i 3i-2, 
  za sve prirodne brojeve i=1..min(k,n/2).
  Da bi rjesenje bilo dovoljno efikasno potrebno je koristiti strukturu podataka 
  koja omogucuje efikasnu setnju kroz grupe, mjenjanje broja elemenata u grupi, 
  te brisanje grupa.
  Donje rjesenje koristi polje koje se obilazi unazad tako da se grupe mogu 
  izbrisati jednostavno i efikasno.
*/

#include <stdio.h>

#define MAXN 100000
#define MIN(A, B)  ((A)<(B)?(A):(B))

int n, k;

int ngrupa;
int broj[MAXN];
int boja[MAXN];

void citaj_ulaz(void)
{
        int i;
        int a;

        scanf("%d %d", &n, &k);
        scanf("%d", &a);

        boja[0]=a;
        broj[0]=1;
        ngrupa=1;

	for (i=1; i<n; i++)
	{
                scanf("%d", &a);
                if (a==boja[ngrupa-1]) broj[ngrupa-1]++;
                else
                {
                        boja[ngrupa]=a;
                        broj[ngrupa]=1;
                        ngrupa++;
                }
	}
}

void rijesi (void)
{
        int koliko;
        int start;
        int noving;
        int pozicija;
        int i, tmp;

	while (ngrupa>2)
	{
		koliko=MIN(ngrupa/3, k);
                start=ngrupa-koliko*3;
                pozicija=n;

                printf("%d", koliko);

                /* Zamijeni grupe */
                for (i=ngrupa-3; i>=start; i-=3)
                {
                        pozicija-=(broj[i]+broj[i+1]+broj[i+2]);
                        printf(" %d", pozicija+1);
                        tmp=boja[i]; boja[i]=boja[i+1]; boja[i+1]=tmp;
                        tmp=broj[i]; broj[i]=broj[i+1]; broj[i+1]=tmp;
                }

                /* Spoji nove grupe i izbrisi stare */
                noving=start;
                if (noving==0) noving=start=1;
                for (i=start; i<ngrupa; i++)
                        if (boja[i]==boja[noving-1]) broj[noving-1]+=broj[i];
                        else
                        {
                                boja[noving]=boja[i];
                                broj[noving]=broj[i];
                                noving++;
                        }

                ngrupa=noving;
                printf("\n");
	}
        printf("0\n");
}

int main (void)
{
        citaj_ulaz();
        rijesi();

	return 0;
}
