
/*
  Natjecanje timova studenata informaticara hrvatskih sveucilista 2005
  Drugo natjecanje - Zadatak KOCKA

  Opis algoritma:
  Zadatak rjesavamo tako da crtamo kocku po kocku, pazeci pri tome da su prije 
  crtanja odredjene kocke vec nacrtane sve kocke koje ona mozda zaklanja.
  Jedan nacin da to osiguramo je da crtamo redak po redak od najdaljeg prema 
  najblizem. U retku crtamo tornjeve slijeva na desno, a svaki toranj odozdo 
  prema gore. Sirina i visina ispisa se lako izracuna iz dimenzija i sadrzaja 
  matrice.
*/

#include <stdio.h>

#define REDAKA_U_STRANICI 4
#define STUPACA_U_STRANICI 5
#define DUBINA_KOCKE 2
#define MAX_DIMENZIJE 50

char prikaz_kocke[REDAKA_U_STRANICI + DUBINA_KOCKE]
                 [STUPACA_U_STRANICI + DUBINA_KOCKE + 1] =
     { "..+---+",
       "./   /|",
       "+---+ |",
       "|   | +",
       "|   |/.",
       "+---+.." };

int broj_redaka,broj_stupaca;
int visine[MAX_DIMENZIJE][MAX_DIMENZIJE];

int redaka_u_rjesenju,stupaca_u_rjesenju;
char rjesenje[500][500];

void ucitaj(void)
{
  int i,j;
  int temp_redaka_u_rjesenju;

  scanf("%d%d",&broj_redaka,&broj_stupaca);
  stupaca_u_rjesenju = broj_stupaca * (STUPACA_U_STRANICI - 1) + 1 +
                       broj_redaka * DUBINA_KOCKE;

  for (i = 0;i < broj_redaka;++i)
    for (j = 0;j < broj_stupaca;++j)
    {
      scanf("%d",&visine[i][j]);
      temp_redaka_u_rjesenju = (broj_redaka - i - 1) * DUBINA_KOCKE +
                               visine[i][j] * (REDAKA_U_STRANICI - 1) + 1 +
                               DUBINA_KOCKE;
      if (temp_redaka_u_rjesenju > redaka_u_rjesenju)
        redaka_u_rjesenju = temp_redaka_u_rjesenju;
    }
}

void crtaj(int redak,int stupac)
{
  int i,j;

  for (i = 0;i < REDAKA_U_STRANICI + DUBINA_KOCKE;++i)
    for (j = 0;j < STUPACA_U_STRANICI + DUBINA_KOCKE;++j)
      if (prikaz_kocke[i][j] != '.')
        rjesenje[redak + i][stupac + j] = prikaz_kocke[i][j];
}

void rijesi(void)
{
  int i,j,k;
  int redak,stupac;

  for (i = 0;i < redaka_u_rjesenju;++i)
    for (j = 0;j < stupaca_u_rjesenju;++j)
      rjesenje[i][j] = '.';

  for (i = 0;i < broj_redaka;++i)
    for (j = 0;j < broj_stupaca;++j)
      for (k = 1;k <= visine[i][j];++k)
      {
        redak = redaka_u_rjesenju -
                ((broj_redaka - i - 1) * DUBINA_KOCKE +
                 (k - 1) * (REDAKA_U_STRANICI - 1) + REDAKA_U_STRANICI +
                 DUBINA_KOCKE);
        stupac = j * (STUPACA_U_STRANICI - 1) +
                 (broj_redaka - i - 1) * DUBINA_KOCKE;
        crtaj(redak,stupac);
      }
}

void ispisi(void)
{
  int i;

  for (i = 0;i < redaka_u_rjesenju;++i)
  {
    rjesenje[i][stupaca_u_rjesenju] = '\0';
    printf("%s\n",rjesenje[i]);
  }
}

int main(void)
{
  ucitaj();
  rijesi();
  ispisi();

  return 0;
}
