
/*
  Natjecanje studenata informaticara hrvatskih sveucilista 2005
  Zadatak JANJE

  Opis algoritma:
  Zadatak rjesavamo dinamickim programiranjem. Neka nam N[k][l1][l2][l3][l4]
  oznacava minimalno vrijeme potrebno da se pojede jos k kila janjetine ako je
  posljednju minutu jela osoba l1, neposredno prije nje osoba l2, itd. Pritom
  brojevi l1, l2, l3 i l4 mogu imati i vrijednost n cije je znacenje da nitko
  nije jeo u toj minuti.
  Problem svodimo na manje podprobleme istog tipa tako da razmatramo n+1 slucaj,
  gdje slucaj i (i=0,...,n) odgovara scenariju kada i-ta osoba sljedeca jede.
  Potrebno je jedino provjeriti da li i-ta osoba odgovara jednoj od osoba l1,
  l2, l3, l4 i, ako je to slucaj, da li se je dovoljno odmorila da ponovo jede.
*/

#include <stdio.h>
#include <string.h>

#define MAXM 100
#define MAXN 10

int m, n;
int a[MAXN];
int b[MAXN];
short int N[MAXM+1][MAXN+1][MAXN+1][MAXN+1][MAXN+1];

void citaj_ulaz (void)
{
        int i;

        scanf("%d %d", &m, &n);
        for (i=0; i<n; i++)
                scanf("%d %d", &a[i], &b[i]);
}

int najbolje (int k, int l1, int l2, int l3, int l4)
{
        int i;
        int naj=1<<30;
        int temp;

        if (k<=0) return 0;
        if (N[k][l1][l2][l3][l4]!=-1) return N[k][l1][l2][l3][l4];
        for (i=0; i<n; i++)
        {
                if (i==l1 && b[i]>=1) continue ;
                if (i==l2 && b[i]>=2) continue ;
                if (i==l3 && b[i]>=3) continue ;
                if (i==l4 && b[i]>=4) continue ;
                if (a[i]==0) continue ;
                temp=1+najbolje(k-a[i], i, l1, l2, l3);
                if (temp<naj) naj=temp;

        }
        if (l1!=n || l2!=n || l3!=n || l4!=n)
        {
                temp=1+najbolje(k, n, l1, l2, l3);
                if (temp<naj) naj=temp;
        }
        return N[k][l1][l2][l3][l4]=naj;
}

int main (void)
{
        memset(N, -1, sizeof N);
        citaj_ulaz();
        printf("%d\n", najbolje(m, n, n, n, n));
        return 0;
}
