
/*
  Natjecanje studenata informaticara hrvatskih sveucilista 2005
  Zadatak KINEZ

  Opis algoritma:
  Da bi se zadatak rjesio, potrebno je primjetiti sljedece: ako je moguce da,
  krecuci se najkracim putem od stanice a do stanice b, prodjemo kroz stanicu c
  tada mora vrijediti  D[a, b]=D[a, c]+D[c, b], gdje je sa D[x, y] oznacena
  duljina najkraceg puta od stanice x do stanice y.
  Zadatak rjesavamo tako da za sve moguce stanice s provjerimo da li gornji
  uvjet zadovoljen. Kako je garantirano da uvijek postoji rjesenje, potrebno je
  samo provjeriti da li najkraci put od prve zadane stanice do s moze voditi
  kroz zadnju zadanu stanicu.
  Najkraci put od neke stanice do svih ostalih stanica racunamo pretrazivanjem u
  sirinu (bfs).
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXN      200
#define MAXK      200
#define MAXM      100
#define MAXBROJ   MAXN*MAXK
#define MAXOZNAKA 1000001

struct veza
{
        int pocetak;
        int kraj;
};

int n;
int k[MAXN];
int l[MAXN][MAXK];

int m;
int g[MAXM];

int brojveza=0;
struct veza v[2*MAXBROJ];
int prva[MAXBROJ];

int broj=0;
int I[MAXOZNAKA];
int R[MAXBROJ];

int d[MAXM][MAXBROJ];
int rjesenje[MAXBROJ];

int q[MAXBROJ];
int head, tail;

void citaj_ulaz (void)
{
        int i, j;

        scanf("%d", &n);
        for (i=0; i<n; i++)
        {
                scanf("%d", &k[i]);
                for (j=0; j<k[i]; j++)
                        scanf("%d", &l[i][j]);
        }
        scanf("%d", &m);
        for (i=0; i<m; i++)
                scanf("%d", &g[i]);
}


int indeks (int a)
{
        if (I[a]!=-1) return I[a];
        I[a]=broj;
        R[broj]=a;
        return broj++;
}

int cmp (const void *a, const void *b)
{
        struct veza *aa=(struct veza *)a;
        struct veza *bb=(struct veza *)b;
        if (aa->pocetak<bb->pocetak) return -1;
        if (aa->pocetak>bb->pocetak) return 1;
        return 0;
}

void napravi_graf (void)
{
        int i, j;

        for (i=0; i<n; i++)
                for (j=0; j<k[i]-1; j++)
                {
                        v[brojveza].pocetak=indeks(l[i][j]);
                        v[brojveza].kraj=indeks(l[i][j+1]);
                        v[brojveza+1].pocetak=indeks(l[i][j+1]);
                        v[brojveza+1].kraj=indeks(l[i][j]);
                        brojveza+=2;
                }
        qsort(v, brojveza, sizeof(v[0]), cmp);

        for (i=brojveza-1; i>=0; i--)
                prva[v[i].pocetak]=i;
}

void init (void) { head=tail=0; }
int empty (void) { return head==tail; }
void push (int a) { q[head]=a; head=(head+1)%MAXBROJ; }
int front (void) { return q[tail]; }
void pop (void) { tail=(tail+1)%MAXBROJ; }

void bfs (int a)
{
        int x, i;

        init();
        memset(d[a], -1, sizeof d[a]);
        push(indeks(g[a]));
        d[a][indeks(g[a])]=0;
        while (!empty())
        {
                x=front();
                pop();
                for (i=prva[x]; i<brojveza && v[i].pocetak==x; i++)
                        if (d[a][v[i].kraj]==-1)
                        {
                                d[a][v[i].kraj]=d[a][x]+1;
                                push(v[i].kraj);
                        }
        }
}

void rijesi (void)
{
        int a, c;

        bfs(0);
        bfs(m-1);
        a=indeks(g[m-1]);

        memset(rjesenje, -1, sizeof rjesenje);
        for (c=0; c<broj; c++)
        {
                if (d[0][a]==-1) rjesenje[c]=0;
                if (d[m-1][c]==-1) rjesenje[c]=0;
                if (d[0][c]==-1) rjesenje[c]=0;
                if (d[0][a]+d[m-1][c]!=d[0][c]) rjesenje[c]=0;
        }
}

void ispisi_rjesenje (void)
{
        int i;

        for (i=0; i<MAXOZNAKA; i++)
                if (I[i]!=-1 && rjesenje[I[i]])
                        printf("%d\n", i);
}

int main (void)
{
        memset(I, -1, sizeof I);
        memset(R, -1, sizeof R);

        citaj_ulaz();
        napravi_graf();
        rijesi();
        ispisi_rjesenje();

        return 0;
}
