
/*
  Natjecanje studenata informaticara hrvatskih sveucilista 2005
  Zadatak PUZZLE

  Opis algoritma:
  Zadatak rjesavamo rekurzivnim ispitivanjem svih mogucih nacina postaljanja
  puzzli. U svakom koraku, jednu puzzlu pokusavamo dodati svaku mogucu poziciju
  unutar ploce.
  Kako su broj puzzli i dimenzije ploce mali, nije potrebno optimizirati
  rjesenje.
*/

#include <stdio.h>
#include <stdlib.h>

#define MAX_PUZZLI 5
#define STRANICA_KVADRATA 4

int broj_puzzli;

struct {
         int broj_redaka,broj_stupaca;
         char izgled[STRANICA_KVADRATA][STRANICA_KVADRATA + 1];
       } puzzle[MAX_PUZZLI];

char polje[STRANICA_KVADRATA][STRANICA_KVADRATA];

void ucitaj(void)
{
  int i,j;

  scanf("%d",&broj_puzzli);
  for (i = 0;i < broj_puzzli;++i)
  {
    scanf("%d%d",&puzzle[i].broj_redaka,&puzzle[i].broj_stupaca);
    for (j = 0;j < puzzle[i].broj_redaka;++j)
      scanf("%s",puzzle[i].izgled[j]);
  }
}

int provjeri(void)
{
  int i,j;

  for (i = 0;i < STRANICA_KVADRATA;++i)
    for (j = 0;j < STRANICA_KVADRATA;++j)
      if (polje[i][j] == '0')
        return 0;

  return 1;
}

int moze(int puzzla,int redak,int stupac)
{
  int i,j;

  if (redak + puzzle[puzzla].broj_redaka > STRANICA_KVADRATA)
    return 0;
  if (stupac + puzzle[puzzla].broj_stupaca > STRANICA_KVADRATA)
    return 0;

  for (i = 0;i < puzzle[puzzla].broj_redaka;++i)
    for (j = 0;j < puzzle[puzzla].broj_stupaca;++j)
      if (puzzle[puzzla].izgled[i][j] == '1' &&
          polje[redak + i][stupac + j] != '0')
        return 0;

  return 1;
}

void popuni_ili_isprazni(int puzzla,int redak,int stupac,int sto)
{
  int i,j;

  for (i = 0;i < puzzle[puzzla].broj_redaka;++i)
    for (j = 0;j < puzzle[puzzla].broj_stupaca;++j)
      if (puzzle[puzzla].izgled[i][j] == '1')
      {
        if (sto == 1)
          polje[redak + i][stupac + j] = '1' + puzzla;
        else
          polje[redak + i][stupac + j] = '0';
      }
}

void ispisi(void)
{
  int i,j;

  for (i = 0;i < STRANICA_KVADRATA;++i)
  {
    for (j = 0;j < STRANICA_KVADRATA;++j)
      printf("%c",polje[i][j]);
    printf("\n");
  }
}

void radi(int puzzla)
{
  int i,j;

  if (puzzla == broj_puzzli && provjeri())
  {
    ispisi();
    exit(0);
  }

  for (i = 0;i < STRANICA_KVADRATA;++i)
    for (j = 0;j < STRANICA_KVADRATA;++j)
      if (moze(puzzla,i,j))
      {
        popuni_ili_isprazni(puzzla,i,j,1);
        radi(puzzla + 1);
        popuni_ili_isprazni(puzzla,i,j,2);
      }
}

void rijesi(void)
{
  int i,j;

  for (i = 0;i < STRANICA_KVADRATA;++i)
    for (j = 0;j < STRANICA_KVADRATA;++j)
      polje[i][j] = '0';

  radi(0);
}

int main(void)
{
  ucitaj();
  rijesi();
  printf("NE\n");

  return 0;
}
