
/*
  Natjecanje studenata informaticara hrvatskih sveucilista 2005
  Zadatak PUZZLE

  Opis algoritma:
  Zadatak rjesavamo rekurzivnim ispitivanjem svih mogucih nacina postaljanja
  puzzli. U svakom koraku, na prvo prazno polje pokusavamo dodati svaku od jos
  dosad neiskoristenih puzzli.
  Kako su broj puzzli i dimenzije ploce mali, nije potrebno optimizirati
  rjesenje.
*/

#include <iostream>
#include <vector>
#include <cstdlib>

using namespace std;

const int S=4;
const int MAXP=5;

typedef pair<int, int> P;

int n;
int d[S][S];
int g[MAXP];
vector<P> p[MAXP];

void citaj_ulaz (void)
{
        cin >> n;
        for (int i=0; i<n; i++)
        {
                int a, b;
                cin >> a >> b;
                for (int j=0; j<a; j++)
                        for (int k=0; k<b; k++)
                        {
                                char c;
                                cin >> ws >> c;
                                if (c=='1') p[i].push_back(P(j, k));
                        }
                sort(p[i].begin(), p[i].end());
                for (int j=1; j<(int)p[i].size(); j++)
                        p[i][j].first-=p[i][0].first, p[i][j].second-=p[i][0].second;
                p[i][0]=P(0, 0);
        }
}

int moze (int k, int x, int y)
{
        for (int i=0; i<(int)p[k].size(); i++)
        {
                int xx=p[k][i].first+x;
                int yy=p[k][i].second+y;
                if (xx<0 || xx>=S || yy<0 || yy>=S) return 0;
                if (d[xx][yy]!=0) return 0;
        }
        return 1;
}

void stavi (int k, int x, int y)
{
        for (int i=0; i<(int)p[k].size(); i++)
        {
                int xx=p[k][i].first+x;
                int yy=p[k][i].second+y;
                d[xx][yy]=k+1;
        }
}

void makni (int k, int x, int y)
{
        for (int i=0; i<(int)p[k].size(); i++)
        {
                int xx=p[k][i].first+x;
                int yy=p[k][i].second+y;
                d[xx][yy]=0;
        }
}

void ispisi (void)
{
        for (int i=0; i<S; i++, cout << endl)
                for (int j=0; j<S; j++)
                        cout << d[i][j];
        exit(0);
}

void rijesi (int k, int x, int y)
{
        while (x<S && d[x][y]!=0)
        {
                y++;
                if (y==S) y=0, x++;
        }
        if (x>=S && k==n) ispisi();
        if (x>=S) return ;
        for (int i=0; i<n; i++)
        {
                if (g[i]) continue ;
                if (!moze(i, x, y)) continue ;
                g[i]=1;
                stavi(i, x, y);
                rijesi(k+1, x, y);
                makni(i, x, y);
                g[i]=0;
        }
}

int main (void)
{
        citaj_ulaz();
        memset(d, 0, sizeof d);
        memset(g, 0, sizeof g);
        rijesi(0, 0, 0);
        cout << "NE" << endl;
        return 0;
}
