#include <cstdio>

const int max_n = 1000;

int n;
bool edge[max_n][max_n];
int bcc[max_n][max_n];
int visited[max_n];
int color[max_n];
struct {
  int i, j;
} stack[max_n * max_n + 1];
int cur_bcc, cur_time, stack_idx;
int begin[max_n];
bool good[max_n];
bool result[max_n];

int search(int v) {
  int result = visited[v] = cur_time++;
  for (int i = 0; i < n; ++i)
   if (edge[v][i] && !bcc[v][i]) {
    stack[stack_idx].i = v;
    stack[stack_idx].j = i;
    ++stack_idx;
    bcc[i][v] = -1;
    int r = visited[i] ? visited[i] : search(i);
    if (r >= visited[v]) {
      do {
        --stack_idx;
        int a = stack[stack_idx].i, b = stack[stack_idx].j;
        bcc[a][b] = bcc[b][a] = cur_bcc;
      }
      while (stack[stack_idx].i != v || stack[stack_idx].j != i);
      begin[cur_bcc] = v;
      ++cur_bcc;
    }
    result <?= r;
  }
  return result;
}

bool search1(int v, int c, int bc) {
  color[v] = c;
  for (int i = 0; i < n; ++i)
   if (edge[v][i] && bcc[v][i] == bc) {
    if (color[i] == c) return true;
    else if (!color[i] && search1(i, 3 - c, bc)) return true;
  }
  return false;
}

int main() {
  for (;;) {
    int m;
    scanf("%d%d", &n, &m);
    if (n == 0 && m == 0) return 0;
    for (int i = 0; i < n; ++i)
     for (int j = 0; j < n; ++j) {
      edge[i][j] = i != j;
      bcc[i][j] = 0;
    }
    for (; m; --m) {
      int a, b;
      scanf("%d%d", &a, &b);
      edge[a - 1][b - 1] = edge[b - 1][a - 1] = false;
    }
    for (int i = 0; i < n; ++i) {
      color[i] = visited[i] = 0;
      result[i] = true;
    }
    cur_bcc = cur_time = 1;
    stack_idx = 0;
    for (int i = 0; i < n; ++i)
     if (!visited[i]) search(i);
    for (int i = 1; i < cur_bcc; ++i) {
      for (int j = 0; j < n; ++j) color[j] = 0;
      good[i] = search1(begin[i], 1, i);
    }
    for (int i = 0; i < n; ++i)
     for (int j = 0; j < n; ++j)
     if (edge[i][j] && good[bcc[i][j]]) {
      result[i] = false;
      break;
    }
    int r = 0;
    for (int i = 0; i < n; ++i)
     if (result[i]) ++r;
    printf("%d\n", r);
  }
}
