{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $01000000}

// (C) Timofey S. Chistyakov 2005

{$apptype console}

uses
  Math, Types;

var
  n, m: integer;
  d: array of TByteDynArray;
  colors, repr: TIntegerDynArray;
  cnt: array [0..3] of integer;
  fi, fo: textfile;


procedure dfs(Color, Prior, From: integer);
var
  i: integer;
begin
  colors[From] := Color;
  for i := 0 to n - 1 do
    if (i <> Prior) and (d[From, i] <> 0) then begin
      if (colors[i] = -1) then begin
        colors[i] := Color;
        dfs(Color, From, i);
      end
      else begin
        d[From, i] := 2;  // remove this
        d[i, From] := 2;
      end;
    end;
end;

procedure print(Idx: integer);
var
  i, j: integer;
begin
  WriteLn(fo, cnt[Idx]);
  for i := 0 to n - 1 do
    for j := i + 1 to n - 1 do
      if d[i, j] = Idx then
        Write(fo, i + 1, ' ', j + 1, ' ');
  Writeln(fo);
end;

var
  i, j, a, b, c: integer;
begin
  AssignFile(fi, 'input.txt');
  Reset(fi);
  AssignFile(fo, 'output.txt');
  Rewrite(fo);

  Read(fi, n, m);
  Assert(InRange(n, 1, 1000));
  Assert(InRange(m, 0, 1000000));

  SetLength(d, n, n);
  for i := 0 to High(d) do
    FillChar(d[i, 0], SizeOf(d[0, 0]) * n, 0);

  for i := 1 to m do begin
    Read(fi, a, b);
    Assert(InRange(a, 1, n));
    Assert(InRange(b, 1, n));
    Assert(a <> b);
    d[a - 1, b - 1] := 1;
    d[b - 1, a - 1] := 1;
  end;

  SetLength(colors, n);
  SetLength(repr, n);
  for i := 0 to n - 1 do begin
    colors[i] := -1;
    repr[i] := -1;
  end;

  c := 0;
  for i := 0 to n - 1 do
    if colors[i] = -1 then begin
      dfs(c, -1, i);
      repr[c] := i;
      Inc(c);
    end;

  for i := 1 to c - 1 do begin
    d[repr[0], repr[i]] := 3;
    d[repr[i], repr[0]] := 3;
  end;
    
  for i := 0 to n - 1 do
    for j := i + 1 to n - 1 do
      Inc(cnt[d[i, j]]);

  print(1);
  print(3);

  CloseFile(fi);
  CloseFile(fo);
end.
