{$apptype console}

// (C) Timofey S. Chistyakov 2005

{$O-}
{$R+}

uses
  SysUtils, Math, Types;

const
  MAXN = 10;
  MAXN1 = MAXN + 1;
  MAXN3 = MAXN1 * MAXN1 * MAXN1;
  MAXT = 1000;

var
  n, t: integer;
  aa: array of array [1..4] of shortint;
  m: array [0..MAXN3, 0..MAXN3] of boolean;


function StateIdx(A1, A2, A3: shortint): integer;
begin
  Result := A1 * MAXN1 * MAXN1 + A2 * MAXN1 + A3;
end;


procedure DecodeState(State: integer; out A1, A2, A3: shortint);
begin
  A3 := State mod MAXN1;
  A2 := (State div MAXN1) mod 11;
  A1 := (State div (MAXN1 * MAXN1)) mod 11;
end;


function Possible(A1, A2, A3, B1, B2, B3: shortint): boolean;
var
  aa, bb: array [1..4] of shortint;
  i, j: integer;
  d: shortint;
  ok: boolean;
begin
  Result := false;
  aa[1] := A1; aa[2] := A2; aa[3] := A3; aa[4] := n - (A1 + A2 + A3);
  bb[1] := B1; bb[2] := B2; bb[3] := B3; bb[4] := n - (B1 + B2 + B3);

  if (aa[4] < 0) or (bb[4] < 0) then
    Exit;

  // i -- - ,   1  2 ( --  2  1)
  for i := -n to n do begin
    d := i;
    ok := true;
    for j := 2 to 4 do begin
      if (aa[j] + d < 0) then begin
        ok := false;
        Break;
      end;
      if aa[j] < (aa[j] + d) - bb[j] then begin
        ok := false;
        Break;
      end;
      d := (aa[j] + d) - bb[j];
    end;
    if
      ok and (aa[1] - Max(i, 0) - Max(-d, 0) >= 0) and
      ((aa[1] - i + d) = bb[1])
    then begin
      Result := true;
      Exit;
    end;
  end;
end;


var
  fi, fo: textfile;
  i, j: integer;
  a, b, c, d, e, f: shortint;
  bestT: integer;
  res: array [1..MAXT] of integer;
  state: integer;
  rc, nrc: integer;
  prior: array [0..MAXT - 1, 0..MAXN3] of integer;
  reached, nreached: array [0..MAXN3] of integer;
  nrflags: array [0..MAXN3] of boolean;
begin
  try
    AssignFile(fi, 'input.txt');
    AssignFile(fo, 'output.txt');
    Reset(fi);
    Rewrite(fo);

    Read(fi, n, t);
    Assert(InRange(n, 1, MAXN));
    Assert(InRange(t, 1, MAXT));
    SetLength(aa, t);
    for i := 0 to t - 1 do
      for j := 1 to 4 do begin
        Read(fi, aa[i, j]);
        Assert(InRange(aa[i, j], 0, n));
      end;

    FillChar(prior, SizeOf(prior), 0);
    rc := 0;
    for a := 0 to n do
      for b := 0 to n - a do
        for c := 0 to n - (a + b) do begin
          if (n - a - b - c >= 0) then begin
            reached[rc] := StateIdx(a, b, c);
            Inc(rc);
          end;
          for d := 0 to n do
            for e := 0 to n - d do
              for f := 0 to n - (d + e) do
                m[StateIdx(a, b, c), StateIdx(d, e, f)] :=
                  Possible(a, b, c, d, e, f);
        end;

    bestT := T;
    for i := 0 to T - 1 do begin
      nrc := 0;
      FillChar(nrflags, SizeOf(nrflags), false);
      for j := 0 to rc - 1 do begin
        for a := 0 to n do                                 
          for b := 0 to n - a do
            for c := 0 to n - (a + b) do
              if
                not nrflags[StateIdx(a, b, c)] and
                (a >= aa[i, 1]) and (b >= aa[i, 2]) and
                (c >= aa[i, 3]) and (n - a - b - c >= aa[i, 4]) and
                m[reached[j], StateIdx(a, b, c)]
              then begin
                nrflags[StateIdx(a, b, c)] := true;
                prior[i, StateIdx(a, b, c)] := reached[j];  
                nreached[nrc] := StateIdx(a, b, c);
                Inc(nrc);
              end;
      end;
      if (nrc = 0) then begin
        bestT := i;
        Break;
      end;
      rc := nrc;
      for j := 0 to rc - 1 do
        reached[j] := nreached[j];
    end;

    WriteLn(fo, bestT);
    state := reached[0];
    for i := 0 to bestT - 1 do begin
      res[bestT - i] :=  state;
      state := prior[bestT - 1 - i, state];
    end;

    for i := 1 to bestT do begin
      DecodeState(res[i], a, b, c);
      WriteLn(fo, a, ' ', b, ' ', c, ' ', n - a - b - c); 
    end;
      
    
    CloseFile(fo);
    CloseFile(fi);
  except
    on E: Exception do begin
      WriteLn(E.Message);
      Halt(1);
    end;
  end;
end.
