{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem A. Astronomy                                          }
{                                                               }
{ Original idea         Pavel Mavrin                            }
{ Problem statement     Pavel Mavrin                            }
{ Testset               Pavel Mavrin                            }
{---------------------------------------------------------------}
{ Solution                                                      }
{                                                               }
{ Author:           Andrew Lopatin                              }
{---------------------------------------------------------------}

{$o-,q+,r+}
uses SysUtils;

const MaxN=1000;
      MaxT=10000;
      MaxL=4000;
      Base=10;

type long=array [1..MaxL] of integer;

procedure muls (var a, b:long; c:integer);
var i, cy:integer;
begin
  cy:=0;
  for i:=1 to MaxL do begin
    inc (cy, b[i]*c);
    a[i]:=cy mod Base; cy:=cy div Base
  end;
end;


procedure writel (var a:long);
var i, j, k:integer;
begin
  k:=0; for i:=MaxL downto 1 do if a[i]<>0 then begin k:=i; break end;
  if k=0 then write (0) else for j:=k downto 1 do write (a[j]);
end;


procedure readr (var x:integer; a, b:integer);
begin
  assert (not seekeoln); read (x); assert ((a<=x) and (x<=b));
end;


procedure readl;
begin
  assert (seekeoln); assert (not eof); readln
end;


function gcd (a, b:integer):integer;
begin
  if b=0 then gcd:=a else gcd:=gcd (b, a mod b);
end;


var f:array [1..MaxT] of boolean;
    p, Z:array [1..MaxT] of integer;
    pc:integer;


type sacre=procedure (p, d:integer);

procedure sacmax (p, d:integer);
begin
  if d>Z[p] then Z[p]:=d;
end;


procedure sacdec (p, d:integer);
begin
  dec (Z[p], d);
end;

procedure sacrifice (x:integer; sac:sacre);
var j, d:integer;
begin
  for j:=1 to pc do begin
    if p[j]*p[j]>x then break;
    if x mod p[j]=0 then begin
      d:=0; 
      repeat
        inc (d);
        x:=x div p[j];
      until x mod p[j]<>0;
      sac (p[j], d);
    end;
  end;
  if x>1 then sac (x, 1);
end;

var i, j, k, q, n, G, tmp:integer;
    a, b:long;
    t:array [1..MaxN] of integer;

begin
  reset (input, 'astronomy.in'); rewrite (output, 'astronomy.out');
  readr (n, 2, MaxN); readl;
  for i:=1 to n do readr (t[i], 1, MaxT);
  tmp:=0; for i:=1 to n-1 do inc (tmp, ord (t[i]=t[i+1]));
  assert (tmp<n-1);
  readl; assert (eof);
  for i:=2 to MaxT do if not f[i] then begin
    q:=2*i; while q<=MaxT do begin
      f[q]:=true; inc (q, i);
    end;
    inc (pc); p[pc]:=i
  end;
  for i:=1 to n do sacrifice (t[i], sacmax);
  G:=0;
  for i:=2 to n do
    G:=gcd (G, abs (t[i]-t[1]));
  sacrifice (2*G, sacdec);
  A[1]:=1; for j:=1 to MaxT do if Z[j]>0 then 
    for k:=1 to Z[j] do muls (A, A, j);
  writel (A); write (' ');
  B[1]:=1; for j:=1 to MaxT do if Z[j]<0 then 
    for k:=1 to -Z[j] do muls (B, B, j);
  writel (B);
end.