/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem A. Astronomy                                        */
/*                                                             */
/* Original idea         Pavel Mavrin                          */
/* Problem statement     Pavel Mavrin                          */
/* Testset               Pavel Mavrin                          */
/*-------------------------------------------------------------*/
/* Solution                                                    */
/*                                                             */
/* Author                Georgiy Korneev                       */
/*-------------------------------------------------------------*/

import java.io.*;
import java.math.*;
import java.util.*;

class astronomy_gk {
    private static final int MAX_T = 10000;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);

        Scanner scanner = new Scanner(new File("astronomy.in"));
        PrintWriter writer = new PrintWriter(new FileOutputStream("astronomy.out"));


        int[] p = new int[MAX_T];
        boolean[] u = new boolean[2 * MAX_T + 1];

        int cp = 0;
        for (int i = 2; i <= 2 * MAX_T; i++) {
            if (!u[i]) {
                p[cp++] = i;
                for (int j = 2 * i; j <= 2 * MAX_T; j += i) {
                    u[j] = true;
                }
            }
        }

        int n = scanner.nextInt();

        int[] t = new int[n];
        for (int i = 0; i < n; i++) {
            t[i] = scanner.nextInt();
        }

        int[] ans = new int[cp];

        boolean flag = false;
        for (int i = 1; i < n; i++) {
            if (t[i] != t[0]) {
                int v1 = 2 * Math.abs(t[i] - t[0]);
                int v2 = t[0];
                int v3 = t[i];

                for (int j = 0; j < cp; j++) {
                    int f = 0;
                    while (v1 % p[j] == 0) {
                        v1 /= p[j];
                        f--;
                    }
                    while (v2 % p[j] == 0) {
                        v2 /= p[j];
                        f++;
                    }
                    while (v3 % p[j] == 0) {
                        v3 /= p[j];
                        f++;
                    }
                    if (flag) {
                        ans[j] = Math.max(ans[j], f);
                    } else {
                        ans[j] = f;
                    }
                }
                flag = true;
            }
        }

        BigInteger nom = BigInteger.ONE;
        BigInteger den = BigInteger.ONE;

        for (int i = 0; i < cp; i++) {
            for (int j = 0; j < ans[i]; j++) {
                nom = nom.multiply(BigInteger.valueOf(p[i]));
            }
            for (int j = 0; j > ans[i]; j--) {
                den = den.multiply(BigInteger.valueOf(p[i]));
            }
        }

        writer.println(nom.toString() + " " + den.toString());

        writer.close();
    }
}