{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem B. Bee Garden                                         }
{                                                               }
{ Original idea         Georgiy Korneev                         }
{ Problem statement     Andrew Stankevich                       }
{ Testset               Georgiy Korneev                         }
{---------------------------------------------------------------}
{ Solution with test checker                                    }
{                                                               }
{ Author:               Georgiy Korneev                         }
{---------------------------------------------------------------}

uses
    math;
const
    max_n = 200;
    max_c = 10000;

type
    plist = ^tlist;
    tlist = record
        next: plist;
        val: longint;
    end;

procedure add(var list: plist; val: longint);
var
    p: plist;
begin
    new(p);
    p.next := list;
    p.val := val;
    list := p;
end;

function between(a, x, b: longint): boolean;
begin
    between := (a <= x) and (x <= b) or (b <= x) and (x <= a);
end;

var
    i, j, k, n: longint;
    x, y: array [0..max_n] of longint;
    a: array [0..max_n, 0..max_n] of double;
    v1, v2: longint;
    f: boolean;
    r: array [0..max_n] of plist;
    u: array [0..max_n] of boolean;
    la, lb, lc: longint;
    best: double;
    besti, bestj: longint;

procedure dfs(i, j: longint; l: double);
var
    p: plist;
begin
    u[j] := true;

    a[i][j] := l;
    p := r[j];
    while p <> nil do begin
        if not u[p.val] then begin
            dfs(i, p.val, l + hypot(x[j] - x[p.val], y[j] - y[p.val]));
        end;
        p := p.next;
    end;
end;

begin
    assign(input, 'bee.in'); reset(input);
    assign(output, 'bee.out'); rewrite(output);

    read(n);
    assert((1 <= n) and (n <= max_n));
    for i := 1 to n do begin
        read(x[i], y[i]);
        assert(abs(x[i]) <= max_c);
        assert(abs(y[i]) <= max_c);
    end;

    x[0] := 0;
    y[0] := 0;

    for i := 1 to n do begin
        read(v1, v2);
        add(r[v1], v2);
        add(r[v2], v1);
    end;

    for i := 0 to n do begin
        fillchar(u, sizeof(u), 0);
        dfs(i, i, 0);
    end;

    best := 0;
    besti := 0;
    bestj := 0;
    for i := 0 to n do begin
        for j := i + 1 to n do begin
            la := y[i] - y[j];
            lb := x[j] - x[i];
            lc := la * x[i] + lb * y[i];

            f := false;
            for k := 0 to n do if (k <> i) and (k <> j) then begin
                if x[k] * la + y[k] * lb = lc then begin
                    if between(x[i], x[k], x[j]) and between(y[i], y[k], y[j]) then begin
                        f := true;
                    end;
                end;
            end;
            
            if not f then begin
                if a[i][j] - hypot(x[i] - x[j], y[i] - y[j]) > best then begin
                    best := a[i][j] - hypot(x[i] - x[j], y[i] - y[j]);
                    besti := i;
                    bestj := j;
                end;
            end;
        end;
    end;

    if (best > 1e-8) then begin
        writeln(besti, ' ', bestj);
    end else begin
        writeln(-1);
    end;

    close(input);
    close(output);
end.