/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem D. Drying                                           */
/*                                                             */
/* Original idea         Pavel Mavrin                          */
/* Problem statement     Andrew Lopatin                        */
/* Testset               Andrew Lopatin                        */
/*-------------------------------------------------------------*/
/* Model solution (Java)                                       */
/*                                                             */
/* Author                Georgiy Korneev                       */
/*-------------------------------------------------------------*/

import java.io.*;
import java.util.*;

class drying_gk {
    private static StreamTokenizer t;

    private static int nextInt() throws IOException {
        t.nextToken();
        return (int) t.nval;
    }

    public static void main(String args[]) throws IOException {
        Locale.setDefault(Locale.US);

        t = new StreamTokenizer(new BufferedReader(new FileReader("drying.in")));
        PrintWriter writer = new PrintWriter(new FileOutputStream("drying.out"));

        int n = nextInt();
        int a[] = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }

        int k = nextInt() - 1;
        int r = 0;
        for(int i1 = 0; i1 < n; i1++) {
            r = Math.max(r, a[i1]);
        }

        int l = 0;
        if(k > 0) {
            while (l + 1 < r) {
                int m = (l + r) / 2;
                long t = 0L;

                for (int i = 0; i < n; i++) {
                    if (a[i] > m) {
                        t += (((a[i] - m) + k) - 1) / k;
                    }
                }

                if (t <= m) {
                    r = m;
                } else {
                    l = m;
                }
            }
        }

        writer.println(r);

        writer.close();
    }
}
