{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem D. Drying                                             }
{                                                               }
{ Original idea         Pavel Mavrin                            }
{ Problem statement     Andrew Lopatin                          }
{ Testset               Andrew Lopatin                          }
{---------------------------------------------------------------}
{ Solution with test checker                                    }
{                                                               }
{ Author                Georgiy Korneev                         }
{---------------------------------------------------------------}

uses
    math;

const
    max_n = 100000;
    max_a = 1000000000;
    max_k = 1000000000;
var
    i, k, n: longint;
    a: array [1..max_n] of longint;
    l, r, m: longint;
    t: int64;
begin
    assign(input, 'drying.in'); reset(input);
    assign(output, 'drying.out'); rewrite(output);

    read(n);
    assert((1 <= n) and (n <= max_n));

    for i := 1 to n do begin    
        read(a[i]);
        assert((1 <= a[i]) and (a[i] <= max_a));
    end;

    read(k);
    assert((1 <= k) and (k <= max_k));
    dec(k);

    l := 0;
    r := 0;
    for i := 1 to n do begin
        r := max(r, a[i]);
    end;

    if k <> 0 then begin
        while (l + 1 < r) do begin
            m := (l + r) div 2;
            t := 0;
            for i := 1 to n do begin
                if a[i] > m then begin
                    t := t + (a[i] - m + k - 1) div k;
                end;
            end;
            if t <= m then begin
                r := m;
            end else begin
                l := m;
            end;
        end;
    end;     

    writeln(r);

    close(input);
    close(output);
end.