{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem F. Flip and Turn                                      }
{                                                               }
{ Original idea         Georgiy Korneev                         }
{ Problem statement     Georgiy Korneev                         }
{ Testset               Georgiy Korneev                         }
{---------------------------------------------------------------}
{ Model solution (Delphi)                                       }
{                                                               }
{ Author                Georgiy Korneev                         }
{---------------------------------------------------------------}

{$q-,r-,o+}
const
    max_n = 1000;
    max_s = 100000;

var
    n, m, i, j: longint;
    a, b: array [1..max_n, 1..max_n] of char;
    ch: char;
    s: array [1..max_s * 8] of char;
    top: longint;

procedure add1(ch: char);
begin
    if (top = 0) or (s[top] <> ch) then begin
        inc(top);
        s[top] := ch;
    end else begin
        dec(top);
    end;
end;

procedure add(s: string);
var
    i: longint;
begin
    for i := 1 to length(s) do begin
        add1(s[i]);
    end;
end;

procedure t();
var
    i, j, t: longint;
begin
    for i := 1 to n do begin
        for j := 1 to m do begin
            b[j][i] := a[i][j];
        end;
    end;
    a := b;
    t := n; n := m; m := t;
end;

procedure f();
var
    i, j: longint;
begin
    for i := 1 to n do begin
        for j := 1 to m do begin
            b[n - i + 1][j] := a[i][j];
        end;
    end;
    a := b;
end;

begin
    assign(input, 'flip.in'); reset(input);
    assign(output, 'flip.out'); rewrite(output);

    readln(n, m);

    for i := 1 to n do begin
        for j := 1 to m do begin
            read(a[i][j]);
        end;
        readln;
    end;

    top := 0;

    while not seekeof do begin
        read(ch);
        case ch of 
            '1': add('t');
            '2': add('ftf');
            'V': add('tft');
            'H': add('f');
            'A': add('ft');
            'B': add('ftft');
            'C': add('ftftft');
            'X': add('ftftft');
            'Y': add('ftft');
            'Z': add('ft');
            else assert(false);
        end;
    end;

    for i := 1 to top mod 8 do begin
        if s[i] = 't' then begin
            t();
        end else begin
            f();
        end;
    end;

    writeln(n, ' ', m);

    for i := 1 to n do begin
        for j := 1 to m do begin
            write(a[i][j]);
        end;
        writeln;
    end;

    close(input);
    close(output);
end.