{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem J. Jenny's First Exams                                }
{                                                               }
{ Original idea         Pavel Mavrin                            }
{ Problem statement     Pavel Mavrin                            }
{ Testset               Pavel Mavrin                            }
{---------------------------------------------------------------}
{ Solution                                                      }
{                                                               }
{ Author                Georgiy Korneev                         }
{---------------------------------------------------------------}

uses
    sysutils;

const
    max_n = 50000;

type 
    theap = record
        n: longint;
        v: array [1..max_n] of longint;
        i: array [1..max_n] of longint;
    end;

procedure siftup(var h: tHeap; i: longint);
var
    t: longint;
begin
    if (i <> 1) then begin
        if h.v[i div 2] < h.v[i] then begin
            t := h.v[i]; h.v[i] := h.v[i div 2]; h.v[i div 2] := t;
            t := h.i[i]; h.i[i] := h.i[i div 2]; h.i[i div 2] := t;
            siftup(h, i div 2);
        end;
    end;
end;

procedure insert(var h: tHeap; v, i: longint);
begin
    inc(h.n);
    h.v[h.n] := v;
    h.i[h.n] := i;
    siftup(h, h.n);
end;

procedure siftdown(var h: tHeap; i: longint);
var
    mi: longint;
    t: longint;
begin
    mi := i;
    if (2 * i <= h.n) and (h.v[mi] < h.v[2 * i]) then mi := 2 * i;
    if (2 * i + 1 <= h.n) and (h.v[mi] < h.v[2 * i + 1]) then mi := 2 * i + 1;
    if i <> mi then begin
        t := h.v[i]; h.v[i] := h.v[mi]; h.v[mi] := t;
        t := h.i[i]; h.i[i] := h.i[mi]; h.i[mi] := t;
        siftdown(h, mi);
    end;
end;

procedure remove(var h: tHeap);
begin
    h.v[1] := h.v[h.n];
    h.i[1] := h.i[h.n];
    dec(h.n);
    siftdown(h, 1);
end;

function toDay(s: string): longint;
begin
    toDay := round(strToDate(s));
end;

function toDate(d: longint): string;
begin
    toDate := dateToStr(d);
end;

var
    i, j, q, n, t: longint;
    caption: array [1..max_n] of string;
    day, dl, p: array [1..max_n] of longint;
    hend, hbegin: tHeap;
    s: string;
    ok: boolean;
begin    
    dateSeparator := '.';
    ShortDateFormat  := 'dd.mm.yyyy';

    assign(input, 'jenny.in'); reset(input);
    assign(output, 'jenny.out'); rewrite(output);

    readln(n);
    for i := 1 to n do begin
        readln(caption[i]);
        readln(s);
        day[i] := toDay(s);
        readln(t);
        dl[i] := day[i] - t;
    end;

    for i := 1 to n do begin
        insert(hend, day[i], i);
    end;

    q := n;
    ok := true;
    i := toDay('31.12.2100');
    while (hend.n > 0) or (hbegin.n > 0) do begin
        if (hend.n > 0) and (hend.v[1] = i) then begin
            j := hend.i[1];
            remove(hend);
            insert(hbegin, dl[j], j);
        end else if (hbegin.n > 0) then begin
            j := hbegin.i[1];
            remove(hbegin);
            if (dl[j] > i) then begin
                ok := false;
                break;
            end;
            p[q] := j;
            dec(q);
        end;
        dec(i);
    end;
    

    if ok then begin
        writeln(toDate(i - hbegin.n + 1));
    end else begin
        writeln('Impossible');
    end;

    close(input);
    close(output);
end.