{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem K. K Best                                             }
{                                                               }
{ Original idea         Dmitri Pavlov                           }
{ Problem statement     Andrew Stankevich                       }
{ Testset               Andrew Stankevich                       }
{---------------------------------------------------------------}
{ Model solution (Delphi)                                       }
{                                                               }
{ Author                Georgiy Korneev                         }
{---------------------------------------------------------------}

{$q-,r-}
uses
    sysutils;
const
    max_n = 100000;
    eps = 1e-8;

var
    i, n, k: longint;
    v, w, p, q: array [1..max_n] of longint;
    a: array [1..max_n] of double;
    l, r, m, s: double;

procedure kth(l, r, k: longint);
var
    i, j, q: longint;
    x, t: double;
begin
    x := a[(l + r) div 2];
    i := l;
    j := r;

    while (i <= j) do begin
        while (a[i] > x) do inc(i);
        while (a[j] < x) do dec(j);
        if (i <= j) then begin
            t := a[i]; a[i] := a[j]; a[j] := t;
            q := p[i]; p[i] := p[j]; p[j] := q;
            inc(i);
            dec(j);
        end;
    end;

    if (k <= j) then begin
        kth(l, j, k);
    end else if (i <= k) then begin
        kth(i, r, k);
    end;
end;

begin
    assign(input, 'k.in'); reset(input);
    assign(output, 'k.out'); rewrite(output);

    read(n, k);
    for i := 1 to n do begin
        read(v[i], w[i]);
    end;

    l := -1;
    r := 1e7;

    while true do begin
        m := (l + r) / 2;
        if (l = m) or (r = m) or (abs(l) + abs(r) < eps) then break;
        for i := 1 to n do begin
            p[i] := i;
            a[i] := v[i] - m * w[i];
        end;
        kth(1, n, k);

        s := 0;
        for i := 1 to k do begin
            s := s + a[i];
        end;

        if s >= 0 then begin
            l := m;
            q := p;
        end else begin
            r := m;
        end;
    end;

    for i := 1 to k do begin
        writeln(q[i]);
    end;

    close(input);
    close(output);
end.