#include <stdio.h>
#include <string.h>

#define NSTATES 19683

int win[NSTATES], pow3[10];
int i, j, k;

char victory(char b[3][3])
{
	char i;

	if (b[0][0] == b[0][1] && b[0][1] == b[0][2] && (b[0][2] == 'x' || b[0][2] == 'o'))
		return b[0][0];

	if (b[1][0] == b[1][1] && b[1][1] == b[1][2] && (b[1][2] == 'x' || b[1][2] == 'o'))
		return b[1][0];

	if (b[2][0] == b[2][1] && b[2][1] == b[2][2] && (b[2][2] == 'x' || b[2][2] == 'o'))
		return b[2][0];

	if (b[0][0] == b[1][0] && b[1][0] == b[2][0] && (b[2][0] == 'x' || b[2][0] == 'o'))
		return b[0][0];

	if (b[0][1] == b[1][1] && b[1][1] == b[2][1] && (b[2][1] == 'x' || b[2][1] == 'o'))
		return b[0][1];

	if (b[0][2] == b[1][2] && b[1][2] == b[2][2] && (b[2][2] == 'x' || b[2][2] == 'o'))
		return b[0][2];

	if (b[0][0] == b[1][1] && b[1][1] == b[2][2] && (b[2][2] == 'x' || b[2][2] == 'o'))
		return b[0][0];

	if (b[0][2] == b[1][1] && b[1][1] == b[2][0] && (b[2][0] == 'x' || b[2][0] == 'o'))
		return b[0][2];

	return ' ';
}

int compute(int state)
{
	char b[3][3], t, nx = 0, no = 0;
	int i, j, x, y;

	if (win[state] != -1)
		return win[state];

	x = state;

	for (i = 0; i < 3; i++)
		for (j = 0; j < 3; j++)
		{
			y = x % 3;
			x /= 3;

			if (y == 0)
				b[i][j] = ' ';
			else
			if (y == 1)
				b[i][j] = 'x', nx++;
			else
			if (y == 2)
				b[i][j] = 'o', no++;
		}

	t = victory(b);

	if (t == 'x' && nx == no + 1)
		win[state] = 1;
	else
	if (t == 'o' && nx == no)
		win[state] = 2;
	else
	if (nx == 5 && no == 4)
		win[state] = 0;
	else
	if (nx == no) // muta x-ul
	{
		win[state] = 2;

		for (i = 0; i < 3; i++)
			for (j = 0; j < 3; j++)
				if (b[i][j] == ' ')
				{
					x = compute(state + pow3[i * 3 + j]);

					if (x == 1)
						win[state] = 1;
					else
					if (x == 0 && win[state] == 2)
						win[state] = 0;
				}
	}
	else
	if (nx == no + 1) // muta 0-ul
	{
		win[state] = 1;

		for (i = 0; i < 3; i++)
			for (j = 0; j < 3; j++)
				if (b[i][j] == ' ')
				{
					x = compute(state + 2 * pow3[i * 3 + j]);

					if (x == 2)
						win[state] = 2;
					else
					if (x == 0 && win[state] == 1)
						win[state] = 0;
				}
	}
	/*
	else
		fprintf(stderr, "%d : wrong\n", state);
	*/

	//fprintf(stderr, "%d : %d\n", state, win[state]);

	return win[state];
}

int main()
{
	int i, j, k;
	char b[3][6];

	for (i = 0; i < NSTATES; i++)
		win[i] = -1;

	pow3[0] = 1;
	for (i = 1; i < 10; i++)
		pow3[i] = pow3[i - 1] * 3;


	//freopen("c.in", "r", stdin);
	//freopen("c.out", "w", stderr);

	compute(0);

	do
	{
		scanf("%s", b[0]);

		if (!strcmp(b[0], "Qc"))
			break;

		for (i = 1; i < 3; i++)
			scanf("%s", b[i]);

		k = 0;

		for (i = 0; i < 3; i++)
			for (j = 0; j < 3; j++)
				if (b[i][j] == 'X')
					k += pow3[i * 3 + j];
				else
				if (b[i][j] == '0')
					k += 2 * pow3[i * 3 + j];

		//compute(k);

		if (win[k] == -1)
			printf("Illegal position.\n");
		else
		if (win[k] == 0)
			printf("Game is a draw.\n");
		else
		if (win[k] == 1)
			printf("X wins.\n");
		else
			printf("0 wins.\n");
	}
	while (1);

	return 0;
}