{
                 XV ᨩ᪠   ଠ⨪
    : 5
    襭: ࠭殢 ३ <andreyvit@nvkz.net>
}
{! $DEFINE DEBUG}
{$UNDEF DEBUG}
{$IFDEF DEBUG}{$R+,Q+,I+,S+}{$ELSE}{$R-,Q-,I-,S-}{$ENDIF}
program S0705_5;
uses
	SysUtils, Math;
const
    infile = 'glass.in';
    outfile = 'glass.out';
type
    integer = longint;
    natural = cardinal;

const
    MAX = 2200;
type
    Point = record x, y : integer end;
    Piece = record
        pt : array [0..2] of Point;
    end;
var
    N : longint;
    pieces, pieces_h, pieces_v : array [1..MAX] of Piece;

procedure readPoint (var p : point);
begin
	read (p.x, p.y);
end;

procedure writePoint (const pt : point);
begin
	write (pt.x, ' ', pt.y, ' ');
end;

function isVertical (const p1, p2 : point) : boolean;
begin
    isVertical := (p1.x = p2.x);
end;

function isHorizontal (const p1, p2 : point) : boolean;
begin
    isHorizontal := (p1.y = p2.y);
end;

function findHorSide (const p : piece) : integer;
var
	i : integer;
begin
    for i := 0 to 2 do
		if isHorizontal (p.pt [i], p.pt [(i+1) mod 3]) then begin
            findHorSide := i;
            exit;
        end;
	findHorSide := -1;
end;

function findVertSide (const p : piece) : integer;
var
	i : integer;
begin
    for i := 0 to 2 do
		if isVertical (p.pt [i], p.pt [(i+1) mod 3]) then begin
            findVertSide := i;
            exit;
        end;
	findVertSide := -1;
end;

procedure copyPoint (var pt : piece; const ps : piece;
        ds, ss : integer);
begin
	pt.pt [ds mod 3] := ps.pt [ss mod 3];		
end;

procedure subtractPoint (var pt : point; const sub : point);
begin
    pt.x := pt.x - sub.x;
    pt.y := pt.y - sub.y;
end;

function alignHor (var p : piece) : boolean;
var
    idx : integer;
begin
    idx := findHorSide (p);
    if idx < 0 then
        alignHor := false
    else begin
    	alignHor := true;
        subtractPoint (p.pt [idx mod 3], p.pt [(idx + 2) mod 3]);
        subtractPoint (p.pt [(idx + 1) mod 3], p.pt [(idx + 2) mod 3]);
        subtractPoint (p.pt [(idx + 2) mod 3], p.pt [(idx + 2) mod 3]);
    end;
end;

function alignVert (var p : piece) : boolean;
var
    idx : integer;
begin
    idx := findVertSide (p);
    if idx < 0 then
        alignVert := false
    else begin
    	alignVert := true;
        subtractPoint (p.pt [idx mod 3], p.pt [(idx + 2) mod 3]);
        subtractPoint (p.pt [(idx + 1) mod 3], p.pt [(idx + 2) mod 3]);
        subtractPoint (p.pt [(idx + 2) mod 3], p.pt [(idx + 2) mod 3]);
    end;
end;

function dblsquare (const p1, p2, p3 : point; var zf : boolean) : integer;
begin
    dblsquare := abs ((p1.x-p3.x)*(p2.y-p3.y) - (p1.y-p3.y)*(p2.x-p3.x));
    if dblsquare = 0 then
    	zf := true;
end;

function ptEqual (const p1, p2 : point) : boolean;
begin
    ptEqual := (p1.x = p2.x) and (p1.y = p2.y);
end;

function ptintriangle (const pt, p1, p2, p3 : point) : boolean;
var
	zf : boolean;
begin
	zf := false;
    ptintriangle :=
            dblsquare (p1, p2, p3, zf) =
    		dblsquare (pt, p2, p3, zf) +
    		dblsquare (p1, pt, p3, zf) +
            dblsquare (p1, p2, pt, zf);
    if zf and (ptEqual (pt, p1) or ptEqual (pt, p2) or ptEqual (pt, p3)) then
    	ptintriangle := false;
end;

function triangleInTriangle (const p1, p2 : piece) : boolean;
begin
    triangleInTriangle :=
    	ptInTriangle (p1.pt [0], p2.pt [0], p2.pt [1], p2.pt [2]) or
    	ptInTriangle (p1.pt [1], p2.pt [0], p2.pt [1], p2.pt [2]) or
    	ptInTriangle (p1.pt [2], p2.pt [0], p2.pt [1], p2.pt [2]);
end;

function trianglesIntersect (const p1, p2 : piece) : boolean;
begin
    trianglesIntersect :=
        triangleInTriangle (p1, p2) or triangleInTriangle (p2, p1);
end;

function findIntersections : boolean;
var
    i, j : integer;
begin
    for i := 1 to N-1 do
        for j := i+1 to N do
            if trianglesIntersect (pieces [i], pieces [j]) then begin
                findIntersections := true;
                exit;
            end;
    findIntersections := false;
end;
    	
procedure setToMinPoint (var pmin : point; const pt : point);
begin
    if pt.x < pmin.x then pmin.x := pt.x;
    if pt.y < pmin.y then pmin.y := pt.y;
end;

procedure piecesAligned;
var
	i, j : integer;
    bottom_left : point;
begin
    if findIntersections then
        exit;

    bottom_left.x := 10001;
    bottom_left.y := 10001;

    for i := 1 to N do
	    for j := 0 to 2 do
			setToMinPoint (bottom_left, pieces [i]. pt [j]);

    for i := 1 to N do
        for j := 0 to 2 do
        	subtractPoint (pieces [i].pt [j], bottom_left);

    for i := 1 to N do begin
        for j := 0 to 2 do
            writePoint (pieces [i].pt [j]);
        writeln;
    end;

    close (input);
    close (output);
    halt;
end;

procedure alignPiece (idx : integer);
var
	hor, vert : boolean;
begin
    if idx > N then
        piecesAligned
    else begin
        pieces_h [idx] := pieces [idx];
        pieces_v [idx] := pieces [idx];
        hor := alignHor (pieces_h [idx]);
        vert := alignVert (pieces_v [idx]);
        if not (hor or vert) then
            exit
        else begin
            if hor then begin
                pieces [idx] := pieces_h [idx];
                alignPiece (idx+1);
            end;
            if vert then begin
                pieces [idx] := pieces_v [idx];
                alignPiece (idx+1);
            end;
        end;
    end;
end;

var
    i, j : longint;
begin
	assign (input, infile); reset (input);
    {$IFNDEF DEBUG}assign (output, outfile); rewrite (output);{$ENDIF}

    {$IFDEF DEBUG}writeln;{$ENDIF}

    readln (N);
    for i := 1 to N do begin
        for j := 0 to 2 do
            readPoint (pieces [i].pt [j]);
        readln;
    end;

    alignPiece (1);

    writeln ('NO');

    close (input);
    close (output);
end.
