{$I-,S-,R-}
Const
  FIn='glass.in';
  FOut='glass.out';
{----------------------------------------------------------------------------}
Var input,output:text;
Procedure Init;
begin
  Assign(input,FIn);
  Assign(output,FOut);
  Reset(Input);
  Rewrite(output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{----------------------------------------------------------------------------}
Const
  MaxN=2100;
  Eps=1E-7;

Type
  TPixel=Record
    X,Y:Real;
  end;
  TLine=Record
    A,B,C:Real;
  end;
  TMas=Record
    A,B,C:TPixel;
    L1,L2,L3:TLine;
    S:Byte;
  end;

Var
  N:LongInt;
  Mas:array[1..MaxN]of TMas;
  {}
  Ans:array[1..MaxN]of Word;
  CCC:Word;
  Start,P1,P2,P3,R,R1,R2:LongInt;
  A1,B1,A2,B2:TPixel;
  Gr:array[1..MaxN]of Record
    Col:Word;
    Mas:array[1..MaxN]of Word;
  end;
  Mark:array[1..MaxN]of Boolean;

Function Cmp(A,B:Real):Boolean;
begin
  Cmp:=abs(A-B)<=Eps;
end;

Procedure Line(P1,P2:TPixel; Var L:TLine);
Var N:Real;
begin
  L.A:=P2.Y-P1.Y;
  L.B:=P1.X-P2.X;
  L.C:=-L.A*P1.X-L.B*P1.Y;
  N:=Sqrt(Sqr(L.A)+Sqr(L.B));
  If L.A<0 then N:=-1*N;
  L.A:=L.A/N;
  L.B:=L.B/N;
  L.C:=L.C/N;
end;

Function Dist(P1,P2:TPixel):Real;
begin
  Dist:=Sqrt(Sqr(P1.X-P2.X)+Sqr(P1.Y-P2.Y));
end;

Function DistL(L:TLine; P:TPixel):Real;
begin
  DistL:=(L.A*P.X+L.B*P.Y+L.C)/Sqrt(sqr(L.A)+sqr(L.B));
end;

Function Check(L:TLine; P:TPixel):Byte; {1-up 2-down 3-left 4-right}
Var R:Real;
begin
  If Cmp(L.A,0) then
  begin
    If DistL(L,P)<0 then Check:=2 else Check:=1;
  end else
  If Cmp(L.B,0) then
  begin
    If DistL(L,P)<0 then Check:=4 else Check:=3;
  end else Check:=5;
end;

Function SSS(L1,L2:TLine; A1,B1,A2,B2:TPixel):Boolean;
var D1,D2:Real;
begin
  D1:=Dist(A1,B1);
  D2:=Dist(A2,B2);
  SSS:=Cmp(D1,D2)and(Cmp(L1.A,L2.A) and Cmp(L1.B,L2.B));
end;

Function Sovm(N1,N2:LongInt; Var A1,B1,A2,B2:TPixel):Boolean;
Var S:Boolean;
begin
  Sovm:=True;
  S:=SSS(Mas[N1].L1,Mas[N2].L1,Mas[N1].A,Mas[N1].B,Mas[N2].A,Mas[N2].B);
  If S then begin A1:=Mas[N1].A; B1:=Mas[N1].B; A2:=Mas[N2].A; B2:=Mas[N2].B; exit end;
  S:=SSS(Mas[N1].L1,Mas[N2].L2,Mas[N1].A,Mas[N1].B,Mas[N2].B,Mas[N2].C);
  If S then begin A1:=Mas[N1].A; B1:=Mas[N1].B; A2:=Mas[N2].B; B2:=Mas[N2].C; exit end;
  S:=SSS(Mas[N1].L1,Mas[N2].L3,Mas[N1].A,Mas[N1].B,Mas[N2].A,Mas[N2].C);
  If S then begin A1:=Mas[N1].A; B1:=Mas[N1].B; A2:=Mas[N2].A; B2:=Mas[N2].C; exit end;

  S:=SSS(Mas[N1].L2,Mas[N2].L1,Mas[N1].B,Mas[N1].C,Mas[N2].A,Mas[N2].B);
  If S then begin A1:=Mas[N1].B; B1:=Mas[N1].C; A2:=Mas[N2].A; B2:=Mas[N2].B; exit end;
  S:=SSS(Mas[N1].L2,Mas[N2].L2,Mas[N1].B,Mas[N1].C,Mas[N2].B,Mas[N2].C);
  If S then begin A1:=Mas[N1].B; B1:=Mas[N1].C; A2:=Mas[N2].B; B2:=Mas[N2].C; exit end;
  S:=SSS(Mas[N1].L2,Mas[N2].L3,Mas[N1].B,Mas[N1].C,Mas[N2].A,Mas[N2].C);
  If S then begin A1:=Mas[N1].B; B1:=Mas[N1].C; A2:=Mas[N2].A; B2:=Mas[N2].C; exit end;

  S:=SSS(Mas[N1].L3,Mas[N2].L1,Mas[N1].A,Mas[N1].C,Mas[N2].A,Mas[N2].B);
  If S then begin A1:=Mas[N1].A; B1:=Mas[N1].C; A2:=Mas[N2].A; B2:=Mas[N2].B; exit end;
  S:=SSS(Mas[N1].L3,Mas[N2].L2,Mas[N1].A,Mas[N1].C,Mas[N2].B,Mas[N2].C);
  If S then begin A1:=Mas[N1].A; B1:=Mas[N1].C; A2:=Mas[N2].B; B2:=Mas[N2].C; exit end;
  S:=SSS(Mas[N1].L3,Mas[N2].L3,Mas[N1].A,Mas[N1].C,Mas[N2].A,Mas[N2].C);
  If S then begin A1:=Mas[N1].A; B1:=Mas[N1].C; A2:=Mas[N2].A; B2:=Mas[N2].C; exit end;
  Sovm:=false;
end;

Function Correct(A1,A2,B1,B2:TPixel; Var SX,SY:Real):Boolean;
begin
  SX:=A1.X-A2.X;
  SY:=A1.Y-A2.Y;
  Correct:=(Cmp(B2.X+SX,B1.X))and(Cmp(B2.Y+SY,B1.Y)) and
           (Cmp(A2.X+SX,A1.X))and(Cmp(A2.Y+SY,A1.Y));
end;

Function CmpP(A,B:TPixel):Boolean;
begin
  CmpP:=Cmp(A.X,B.X) and Cmp(A.Y,B.Y);
end;

Procedure SM(Var P:TPixel; SX,SY:Real);
begin
  P.X:=P.X+SX;
  P.Y:=P.Y+SY;
end;

Function _Min(A,B:Byte):Byte;
begin
  If A<B then _Min:=A else _Min:=B;
end;

Function Min(A,B:Real):Real;
begin
  If A<B then Min:=A else Min:=B;
end;

Procedure Pril(A,B,C:TPixel; N2:LongInt; Var A1,B1,A2,B2:TPixel);
Var L:TLine; S:Boolean;
begin
  Line(A,C,L);
  A1:=A; B1:=C;
  S:=SSS(L,Mas[N2].L1,A,C,Mas[N2].A,Mas[N2].B);
  If S then begin A2:=Mas[N2].A; B2:=Mas[N2].B; exit; end;
  S:=SSS(L,Mas[N2].L2,A,C,Mas[N2].B,Mas[N2].C);
  If S then begin A2:=Mas[N2].B; B2:=Mas[N2].C; exit; end;
  S:=SSS(L,Mas[N2].L3,A,C,Mas[N2].A,Mas[N2].C);
  If S then begin A2:=Mas[N2].A; B2:=Mas[N2].C; exit; end;
  Line(A,B,L);
  A1:=A; B1:=B;
  S:=SSS(L,Mas[N2].L1,A,B,Mas[N2].A,Mas[N2].B);
  If S then begin A2:=Mas[N2].A; B2:=Mas[N2].B; exit; end;
  S:=SSS(L,Mas[N2].L2,A,B,Mas[N2].B,Mas[N2].C);
  If S then begin A2:=Mas[N2].B; B2:=Mas[N2].C; exit; end;
  S:=SSS(L,Mas[N2].L3,A,B,Mas[N2].A,Mas[N2].C);
  If S then begin A2:=Mas[N2].A; B2:=Mas[N2].C; exit; end;
end;

Procedure Out;
Var MinY,MinX:Real; SX,SY:Real; _A,_B,_C:TPixel;

  Procedure FindMin(A:TPixel);
  begin
    If (A.X<MinX)and(A.Y<MinY) then
    begin
      MinX:=A.X;
      MinY:=A.Y;
    end;
  end;

begin
  Sovm(Ans[1],Ans[2],A1,B1,A2,B2);
  SX:=0; SY:=0;
  With Mas[Ans[2]] do
    If (CmpP(A,A2))and(CmpP(B,B2)) then begin _A:=C; _B:=A; _C:=B; end else
    If (CmpP(A,A2))and(CmpP(C,B2)) then begin _A:=B; _B:=A; _C:=C; end else
    If (CmpP(B,A2))and(CmpP(A,B2)) then begin _A:=C; _B:=A; _C:=B; end else
    If (CmpP(B,A2))and(CmpP(C,B2)) then begin _A:=A; _B:=C; _C:=B; end else
    If (CmpP(C,A2))and(CmpP(A,B2)) then begin _A:=B; _B:=A; _C:=C; end else
    If (CmpP(C,A2))and(CmpP(B,B2)) then begin _A:=A; _B:=C; _C:=B; end;
  If Correct(A1,A2,B1,B2,SX,SY) then else Correct(A1,B2,B1,A2,SX,SY);
  SM(Mas[Ans[2]].A,SX,SY);
  SM(Mas[Ans[2]].B,SX,SY);
  SM(Mas[Ans[2]].C,SX,SY);
  SM(_A,SX,SY); SM(_B,SX,SY); SM(_C,SX,SY);
  {}
  For R:=3 to N do
  begin
    Pril(_A,_B,_C,Ans[R],A1,B1,A2,B2);
    With Mas[Ans[R]] do
      If (CmpP(A,A2))and(CmpP(B,B2)) then begin _A:=C; _B:=A; _C:=B; end else
      If (CmpP(A,A2))and(CmpP(C,B2)) then begin _A:=B; _B:=A; _C:=C; end else
      If (CmpP(B,A2))and(CmpP(A,B2)) then begin _A:=C; _B:=A; _C:=B; end else
      If (CmpP(B,A2))and(CmpP(C,B2)) then begin _A:=A; _B:=C; _C:=B; end else
      If (CmpP(C,A2))and(CmpP(A,B2)) then begin _A:=B; _B:=A; _C:=C; end else
      If (CmpP(C,A2))and(CmpP(B,B2)) then begin _A:=A; _B:=C; _C:=B; end;
    If Correct(A1,A2,B1,B2,SX,SY) then else Correct(A1,B2,B1,A2,SX,SY);
    SM(Mas[Ans[R]].A,SX,SY);
    SM(Mas[Ans[R]].B,SX,SY);
    SM(Mas[Ans[R]].C,SX,SY);
    SM(_A,SX,SY); SM(_B,SX,SY); SM(_C,SX,SY);
  end;

  MinX:=MaxLongInt;
  MinY:=MaxLongInt;
  For R:=1 to N do
  begin
    FindMin(Mas[R].A);
    FindMin(Mas[R].B);
    FindMin(Mas[R].C);
  end;
  SX:=-1*MinX; SY:=-1*MinY;
  For R:=1 to N do
    With Mas[R] do
    begin
      SM(A,SX,SY);
      SM(B,SX,SY);
      SM(C,SX,SY);
    end;
  For R:=1 to N do
    With Mas[R] do
      WriteLn(Output,A.X:0:0,' ',A.Y:0:0,' ',B.X:0:0,' ',B.Y:0:0,' ',C.X:0:0,' ',C.Y:0:0);
  Done;
end;

Procedure Go(Num:Word);
Var R:Word;
begin
  CCC:=CCC+1; Ans[CCC]:=Num;
  If CCC=N then
  begin
    For R:=1 to Gr[Num].Col do
      If Gr[Num].Mas[R]=Ans[1] then Out;
    CCC:=CCC-1;
    Exit;
  end;
  Mark[Num]:=True;
  For R:=1 to Gr[Num].Col do
    If Not Mark[Gr[Num].Mas[R]] then
      Go(Gr[Num].Mas[R]);
  Mark[Num]:=False;
  CCC:=CCC-1;
end;

Procedure Make(R1,R2:Word);
begin
  Inc(Gr[R1].Col);
  Gr[R1].Mas[Gr[R1].Col]:=R2;
end;

begin
  Init;
  {}
  ReadLn(Input,N);
  For R:=1 to N do
    With Mas[R] do
    begin
      ReadLn(Input,A.X,A.Y,B.X,B.Y,C.X,C.Y);
      Line(A,B,L1);
      Line(B,C,L2);
      Line(C,A,L3);
      P1:=Check(L1,C);
      P2:=Check(L2,A);
      P3:=Check(L3,B);
      S:=_Min(_Min(P1,P2),P3); {!!!}
    end;
  If N<=3 then 
  begin
    WriteLn(Output,'NO');
    Done;
  end;
  {}
  FillChar(Gr,SizeOf(Gr),0);
  For R1:=1 to N do
    For R2:=1 to N do
      If R1<>R2 then
      If Sovm(R1,R2,A1,B1,A2,B2) then
      begin
        If (Mas[R1].S=4)and(Mas[R2].S=2) then Make(R1,R2) else
        If (Mas[R1].S=3)and(Mas[R2].S=2) then Make(R1,R2) else
        If (Mas[R1].S=3)and(Mas[R2].S=1) then Make(R1,R2) else
        If (Mas[R1].S=4)and(Mas[R2].S=1) then Make(R1,R2) else
        If (Mas[R2].S=4)and(Mas[R1].S=2) then Make(R1,R2) else
        If (Mas[R2].S=3)and(Mas[R1].S=2) then begin Start:=R2; Make(R1,R2); end else
        If (Mas[R2].S=3)and(Mas[R1].S=1) then Make(R1,R2) else
        If (Mas[R2].S=4)and(Mas[R1].S=1) then Make(R1,R2) else
        If (Mas[R2].S=Mas[R1].S) then Make(R1,R2);
      end;
  {}
  FillChar(Mark,SizeOf(Mark),0);
  CCC:=0;
  {For R:=1 to N do} Go(Start);
  WriteLn(Output,'NO');
  {}
  Done;
end.