{.$define debug}

{$R-,Q-,S-,I-}

program template;
const
 h = 1100;
 maxk = 26;
 infinity = 1000000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 maxlen = 60;
 {$else}
 cinfile = 'chain.in';
 coutfile = 'chain.out';
 maxlen = 260;
 {$endif}
type
 int = longint;
 real = extended;
 str = string[12];
 tptr = ^tlist;
 tlist = record
  inf :int;
  w :int;
  num :int;
  next :tptr;
 end;
 tpointer = ^ttree;
 ttree = record
  inf :int;
  l,r :tpointer;
 end;
var
 n,m :int;
 words :array [1..h] of str;
 los :string;
 graph :array [0..maxk*maxlen] of tptr;
 d :array [0..maxk*maxlen] of int;
 prev :array [0..maxk*maxlen] of int;
 k :int;
 rb :array [0..maxk*maxlen] of int;
 used :array [0..maxk*maxlen] of int;
 tree :tpointer;
 g :int;
 wrd :array [0..maxk*maxlen] of int;

procedure init;
begin
 fillchar (words,sizeof(words),0);
 fillchar (graph,sizeof(graph),0);
 fillchar (d,sizeof(d),0);
 fillchar (rb,sizeof(rb),0);
 fillchar (used,sizeof(used),0);
 fillchar (prev,sizeof(prev),0);
 fillchar (wrd,sizeof(wrd),0);
 g := 0;
 tree := nil;
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (los);
 m := length(los);
 readln (n);
 for i := 1 to n do
  readln (words[i]);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := g downto 1 do
  writeln (words[wrd[i]]);
 close (output);
end;

procedure add (var list :tptr; value :int; w :int; number :int);
var x :tptr;
begin
 new(x);
 x^.inf := value;
 x^.w := w;
 x^.num := number;
 x^.next := list;
 list := x;
end;

function calc (pos :int; wrd :str):int;
var i,j :int;
begin
 for i := 2 to length(wrd) do
  begin
   if wrd[i] = los[pos+1] then
    inc(pos);
   if pos = m then
    break;
  end;
 calc := pos;
end;

procedure build (var node :tpointer; lo,hi :int);
begin
 new (node);
 if lo = hi then
  begin
   node^.inf := d[lo];
   node^.l := nil;
   node^.r := nil;
   exit;
  end;
 build (node^.l,lo,(lo+hi) shr 1);
 build (node^.r,(lo+hi) shr 1 + 1,hi);
 if node^.l^.inf < node^.r^.inf then
  node^.inf := node^.l^.inf
 else
  node^.inf := node^.r^.inf;
end;

function rec (node :tpointer; lo,hi :int):int;
begin
 if lo = hi then
  begin
   if d[lo] < infinity then
    rec := lo
   else
    rec := -1;
   used[lo] := d[lo];
   d[lo] := infinity;
   node^.inf := d[lo];
   exit;
  end;
 if node^.inf = node^.l^.inf then
  rec := rec (node^.l,lo,(lo+hi) shr 1)
 else
  rec := rec (node^.r,(lo+hi) shr 1 + 1,hi);
 if node^.l^.inf < node^.r^.inf then
  node^.inf := node^.l^.inf
 else
  node^.inf := node^.r^.inf;
end;

procedure relax (node :tpointer; lo,hi :int; pos :int; value :int);
begin
 if lo = hi then
  begin
   d[lo] := value;
   node^.inf := value;
   exit;
  end;
 if pos <= (lo+hi) shr 1 then
  relax (node^.l,lo,(lo+hi) shr 1,pos,value)
 else
  relax (node^.r,(lo+hi) shr 1 + 1,hi,pos,value);
 if node^.l^.inf < node^.r^.inf then
  node^.inf := node^.l^.inf
 else
  node^.inf := node^.r^.inf;
end;

procedure out0;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln ('?');
 close (output);
 halt;
end;

procedure solvemis1;
var i,j :int;
    res :int;
    cur :int;
begin
 cur := -1;
 res := infinity;
 for i := 1 to n do
  if pos(los,words[i]) > 0 then
   if length(words[i]) < res then
    begin
     res := length(words[i]);
     cur := i;
    end;
 if cur < 0 then
  out0;
 g := 1;
 wrd[1] := cur;
end;

procedure solve;
var i,j :int;
    c1,c2 :char;
    newd,res :int;
    start,finish,cur :int;
    x :tptr;
begin
 if m = 1 then
  begin
   solvemis1;
   exit;
  end;
 for i := 0 to m-1 do
  for j := 1 to n do
   begin
    c1 := words[j][1];
    c2 := words[j][length(words[j])];
    newd := calc(i,words[j]);
    if (i = 0) and (c1 = los[1]) then
     begin
      start := maxk + ord(c1) - ord('a');
      newd := calc(1,words[j]);
      finish := newd*maxk + ord(c2) - ord('a');
     end
    else
     begin
      start := i*maxk + ord(c1) - ord('a');
      finish := newd*maxk + ord(c2) - ord('a');
     end;
    if i = 0 then
     d[start] := 1;
    add (graph[start],finish,
         length(words[j])-1, j)
   end;
 k := 26*m + 25;
 for i := 0 to k do
  if d[i] = 0 then
   d[i] := infinity;
 for i := 0 to k do
  prev[i] := -1;
 build (tree,0,k);
 for i := 1 to k do
  begin
   cur := rec (tree,0,k);
   if cur = -1 then
    break;
   x := graph[cur];
   while not (x = nil) do
    begin
     if (used[x^.inf] = 0) and (d[x^.inf] > used[cur] + x^.w) then
      begin
{       d[x^.inf] := used[cur] + x^.w;}
       relax (tree,0,k,x^.inf,used[cur] + x^.w);
       prev[x^.inf] := cur;
       rb[x^.inf] := x^.num;
      end;
     x := x^.next;
    end;
  end;
 cur := -1;
 res := infinity;
 for i := 0 to maxk-1 do
  if (used[maxk*m + i] > 0) then
   if used[maxk*m + i] < res then
   begin
    res := used[maxk*m + i];
    cur := maxk*m + i;
   end;
 if cur = -1 then
  out0;
 while cur >= 0 do
  begin
   inc(g);
   wrd[g] := rb[cur];
   cur := prev[cur];
  end;
 while (g > 0) and (wrd[g] = 0) do
  dec (g);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.