Const
  MaxN = 2000;

Type
  Triangle = Record
    A: Array [1..3, 1..2] Of LongInt;
    R, N: Byte;
    Position: (Left, Up, Right, Down);
    Number: Word;
  End;

Const
  E: Array [1..4, 1..6] Of LongInt =
  (
    (0, 0, 20, -20, 20, 20),
    (0, 0, -20, 20, -20, -20),
    (0, 0, -20, 20, 20, 20),
    (-1, 0, 20, -20, -20, -20)
  );

Var
  I, J, N: LongInt;
  A: Array [1..MaxN] Of Triangle;

Procedure SetType(Var T: Triangle);
Var
  I, J, K: Byte;
Begin
  For I := 1 To 3 Do
    For J := 1 To 3 Do
      For K := 1 To 3 Do
        If (I <> J) And (J <> K) And
           (I <> K) And
           (T.A[I][2] = T.A[J][2]) Then
        Begin
          T.R := K;
          T.N := I;
          If T.A[I][2] > T.A[K][2] Then
            T.Position := Up
          Else
            T.Position := Down;
          Exit;
        End;
  For I := 1 To 3 Do
    For J := 1 To 3 Do
      For K := 1 To 3 Do
        If (I <> J) And (J <> K) And
           (I <> K) And
           (T.A[I][1] = T.A[J][1]) Then
        Begin
          T.R := K;
          T.N := I;
          If T.A[I][1] > T.A[K][1] Then
            T.Position := Left
          Else
            T.Position := Right;
          Exit;
        End;
End;

Procedure Center;
Var
  X, Y: LongInt;
Begin
  For I := 1 To N Do
  Begin
    X := -A[I].A[A[I].R][1];
    Y := -A[I].A[A[I].R][2];
    For J := 1 To 3 Do
    Begin
      A[I].A[J][1] := A[I].A[J][1] + X;
      A[I].A[J][2] := A[I].A[J][2] + Y;
    End;
  End;
End;

Procedure Correct;
Var
  X, Y: LongInt;
Begin
  X := MaxLongInt;
  Y := MaxLongInt;

  For I := 1 To N Do
    For J := 1 To 3 Do
      If (A[I].A[J][1] <= X) And
         (A[I].A[J][2] <= Y) Then
      Begin
        X := A[I].A[J][1];
        Y := A[I].A[J][2];
      End;

  For I := 1 To N Do
    For J := 1 To 3 Do
    Begin
      A[I].A[J][1] := A[I].A[J][1] - X;
      A[I].A[J][2] := A[I].A[J][2] - Y;
    End;
End;

Function Check: Boolean;
Var
  X, Y: LongInt;
  DownY, UpY, LeftX, RightX: LongInt;
  B: Boolean;
Begin
  Check := False;

  X := A[1].A[A[1].R][1];
  Y := A[1].A[A[1].R][2];
  For I := 1 To N Do
    If (A[I].A[A[I].R][1] <> X) Or
       (A[I].A[A[I].R][2] <> Y) Then
      Exit;

  For I := 1 To N Do
  Begin
    If A[I].Position = Up Then
      UpY := A[I].A[A[I].N][2]
    Else If A[I].Position = Down Then
      DownY := A[I].A[A[I].N][2]
    Else If A[I].Position = Left Then
      LeftX := A[I].A[A[I].N][1]
    Else If A[I].Position = Right Then
      RightX := A[I].A[A[I].N][1];
  End;

  For I := 1 To N Do
  Begin
    If A[I].Position = Up Then
    Begin
      If UpY <> A[I].A[A[I].N][2] Then
        Exit;
    End
    Else If A[I].Position = Down Then
    Begin
      If DownY <> A[I].A[A[I].N][2] Then
        Exit;
    End
    Else If A[I].Position = Left Then
    Begin
      If LeftX <> A[I].A[A[I].N][1] Then
        Exit;
    End
    Else If A[I].Position = Right Then
    Begin
      If RightX <> A[I].A[A[I].N][1] Then
        Exit;
    End;
  End;

  {$Q-,R-}

  B := True;
  If N = 4 Then
  Begin
    For I := 1 To N Do
      For J := 1 To 6 Do
        If Odd(J) Then
        Begin
          If (A[I].A[J Div 2][1] <> E[I][J])
            Then
            Begin
              B := False;
            End
        End
        Else
          If (A[I].A[J Div 2][2] <> E[I][J])
            Then
            Begin
              B := False;
            End
  End;

  Check := B;
  {$Q+,R+}
End;

Begin
  Assign(Input, 'glass.in');
  ReSet(Input);
  Assign(Output, 'glass.out');
  ReWrite(Output);

  ReadLn(N);
  For I := 1 To N Do
  Begin
    For J := 1 To 3 Do
    Begin
      Read(A[I].A[J][1], A[I].A[J][2]);
    End;
    A[I].Number := I;
    SetType(A[I]);
  End;

  Center;
  Correct;

  If Not Check Then
  Begin
    WriteLn('NO');
    Close(Input);
    Close(Output);
    Exit;
  End;

  For I := 1 To N Do
  Begin
    For J := 1 To 3 Do
      Write(A[I].A[J][1], ' ',
            A[I].A[J][2], ' ');
    WriteLn;
  End;


  Close(Input);
  Close(Output);
End.