{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
program         Template;

const
  MAX_N         = 100000;

var
  First         : Boolean;
  N, K          : LongInt;
  S             : array[1..MAX_N] of 0..1;
  SC            : array[1..MAX_N] of 0..1;
  SaveS         : array[Boolean, 1..MAX_N] of 0..1;
  Index, Len    : array[1..MAX_N] of LongInt;
  Le, Ind       : array[1..MAX_N] of LongInt;
  SaveL, SaveI  : array[Boolean, 1..MAX_N] of LongInt;
  FT            : array[Boolean, 1..MAX_N] of LongInt;
  LL            : array[Boolean] of LongInt;

procedure       OpenFiles;
begin
  Assign(Input, 'fishes.in');
  Reset(Input);
  Assign(Output, 'fishes.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : LongInt;
begin
  ReadLn(N, K);
  for I := 1 to N do
    Read(S[I]);
end;

procedure       Swap(W: Boolean; I, J: LongInt);
var
  T             : LongInt;
begin
  T := SaveS[W, I]; SaveS[W, I] := SaveS[W, J]; SaveS[W, J] := T;
  SaveI[W, J] := SaveI[W, I] + SaveL[W, J];
  T := SaveL[W, I]; SaveL[W, I] := SaveL[W, J]; SaveL[W, J] := T;
end;

function        Chaos(W: Boolean): LongInt;
var
  I, R          : LongInt;
  C             : 0..2;
begin
  C := 2; R := 0;
  for I := 1 to N do
    if SaveS[W, I] <> C then begin
      Inc(R);
      C := SaveS[W, I];
    end;

  Chaos := R;
end;

function        MergeSlave(Start: Boolean): LongInt;
var
  I             : LongInt;
  Skip          : Boolean;
begin
  LL[Start] := 0; Skip := Start; Move(S, SaveS[Start], SizeOf(S)); Move(Len, SaveL[Start], SizeOf(Len));
  Move(Index, SaveI[Start], SizeOf(Index));
  for I := 1 to N - 1 do begin
    if LL[Start] = K then
      Break;

    if SaveS[Start, I] <> SaveS[Start, I + 1] then
      if not Skip then begin
        Inc(LL[Start]);
        Swap(Start, I, I + 1);
        FT[Start, LL[Start]] := SaveI[Start, I];
        Skip := True;
      end else
        Skip := False;
  end;

  MergeSlave := Chaos(Start);
end;

procedure       WriteMerge(W: Boolean);
var
  I             : LongInt;
begin
  Move(SaveS[W], S, SizeOf(S));
  Move(SaveI[W], Index, SizeOf(Index));
  Move(SaveL[W], Len, SizeOf(Len));

  Write(LL[W]);
  for I := 1 to LL[W] do
    Write(' ', FT[W, I]);
  WriteLn;
end;

function        Merge: Boolean;
begin
  if MergeSlave(True) < MergeSlave(False) then
    WriteMerge(True)
  else
    WriteMerge(False);
end;

procedure       Compress;
var
  I, ON         : LongInt;
  C             : 0..2;
begin
  Move(S, SC, SizeOf(S));
  Move(Len, Le, SizeOf(Len));

  ON := N; N := 0; C := 2;
  for I := 1 to ON do begin
    if SC[I] <> C then begin
      C := SC[I];
      Inc(N);
      S[N] := C;
      Index[N] := Index[I];

      Len[N] := 0;
    end;

    Inc(Len[N], Le[I]);
  end;

  First := False;
end;

procedure       Solve;
var
  I             : LongInt;
begin
  First := True;
  for I := 1 to N do begin
    Index[I] := I;
    Len[I] := 1;
  end;

  repeat
    Compress;
    if N > 2 then
      Merge;
  until N <= 2;
  WriteLn('0');
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
