{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
program         Template;

type
  PEdge         = ^TEdge;
  TEdge         = record
    V           : Integer;
    Next        : PEdge;
  end;

var
  MVK           : Integer;
  N, MinS       : Integer;
  MinL          : Integer;
  Motto         : string;
  Words         : array[1..1000] of string[10];
  Edges         : array[1..1000] of PEdge;
  Visited       : array[1..1000] of Integer;
  Sequence, Seq : array[1..1000] of Integer;
  Timer         : LongInt absolute $0040:$006c;
  StartTime     : LongInt;

procedure       OpenFiles;
begin
  Assign(Input, 'chain.in');
  Reset(Input);
  Assign(Output, 'chain.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : Integer;
begin
  ReadLn(Motto);
  ReadLn(N);
  for I := 1 to N do
    ReadLn(Words[I]);
end;

procedure       Answer;
var
  I             : Integer;
begin
  if MinS = 1001 then
    WriteLn('?')
  else
    for I := 1 to MinS do
      WriteLn(Words[Sequence[I]]);

  CloseFiles;
  Halt;
end;

procedure       DFS(V, M, S, L: Integer);
var
  M1, M2, I, K  : Integer;
  OV            : Integer;
  E             : PEdge;
begin
  if Timer - StartTime >= 32 then
    Answer;

  if L >= MinL then
    Exit;

  M1 := 0; M2 := M; K := 1;
  for I := 1 to Length(Words[V]) do
    if M + K <= Length(Motto) then
      if Words[V][I] = Motto[M + K] then begin
        M2 := M + K;
        if M1 = 0 then
          M1 := M + K;

        Inc(K);
      end;

  if M2 = Length(Motto) then begin
    MinS := S; MinL := L; Seq[S] := V; Move(Seq, Sequence, SizeOf(Sequence));
    Exit;
  end;

  E := Edges[V]; OV := Visited[V]; Visited[V] := M; Seq[S] := V;
  while E <> nil do begin
    if Visited[E^.V] <> M then
      for I := M2 downto M do
        DFS(E^.V, I, S + 1, L + Length(Words[V]) - 1);

    E := E^.Next;
  end;
  Visited[V] := OV;
end;

procedure       Solve;
var
  I, J          : Integer;
  E             : PEdge;
begin
  for I := 1 to N do
    for J := 1 to N do
      if I <> J then
        if Words[I][Length(Words[I])] = Words[J][1] then begin
          New(E);
          E^.V := J;
          E^.Next := Edges[I];
          Edges[I] := E;
        end;

  MinS := 1001; MVK := N * 4; FillChar(Visited, SizeOf(Visited), 255); MinL := 10000;
  for I := 1 to N do
    DFS(I, 0, 1, 0);

  Answer;
end;

begin
  StartTime := Timer;

  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.