{$MEMORY 1000000, 1000000}
type int = longint;
type BigInt = int64; {!!!}
const MAXS = 110;

var x, y: array [-1..5, 1..110] of BigInt;
function inside(u: int; xx, yy: BigInt): boolean;
var s, ss, s1: BigInt;
var i: int;
begin
  s:=0;
  for i:=1 to 3 do
    s:=s + (x[i + 1][u] - x[i][u]) * (y[i + 1][u] + y[i][u]);
  s:=abs(s);

  ss:=0;
  for i:=1 to 3 do
    begin
      s1:=0;
      s1:=s1 + (xx - x[i][u]) * (yy + y[i][u]);
      s1:=s1 + (x[i][u] - x[i + 1][u]) * (y[i][u] + y[i + 1][u]);
      s1:=s1 + (x[i + 1][u] - xx) * (y[i + 1][u] + yy);
      ss:=ss + abs(s1);
    end;

  if s <> ss then
    inside:=false
  else
    inside:=true;
end;

const eps = 1e-11;
function bt(u: extended; x, y: BigInt): boolean;
begin
  bt:=((x < u + eps) and (u - eps < y)) or ((y < u + eps) and (u - eps < x));
end;


function inters(t1, u, t2, v: int): boolean;
var x1, y1, x2, y2, xx1, yy1, xx2, yy2: BigInt;
var a1, a2, b1, b2, c1, c2: BigInt;
var d, d1, d2: BigInt;
var xx, yy: extended;
begin
  x1:=x[u - 1][t1];
  y1:=y[u - 1][t1];
  x2:=x[u + 1][t1];
  y2:=y[u + 1][t1];
  xx1:=x[v - 1][t2];
  yy1:=y[v - 1][t2];
  xx2:=x[v + 1][t2];
  yy2:=y[v + 1][t2];

  a1:=y2 - y1;
  b1:=x1 - x2;
  c1:=a1 * x1 + b1 * y1;
  a2:=yy2 - yy1;
  b2:=xx1 - xx2;
  c2:=a2 * xx1 + b2 * yy1;

  d:=a1 * b2 - a2 * b1;
  if d = 0 then
    begin
      inters:=false;
      exit;
    end;
  d1:=b2 * c1 - b1 * c2;
  d2:=a1 * c2 - a2 * c1;

  xx:=d1 / d;
  yy:=d2 / d;

  if bt(xx, x1, x2) and bt(yy, y1, y2) and
     bt(xx, xx1, xx2) and bt(yy, yy1, yy2) then
       begin
         inters:=true;
         exit;
       end;
  inters:=false;
end;

var h: array [1..MAXS, 1..MAXS, 1..MAXS] of boolean;
var d: array [1..MAXS, 1..MAXS] of int;
var mark, marked: array [1..MAXS, 1..MAXS] of boolean;
var n: int;
var cycle: boolean;

procedure dfs(u, v: int);
var i: int;
begin
  mark[u][v]:=true;
  if cycle then exit;
  for i:=1 to n do
    if h[u][v][i] then
      begin
        if not mark[v][i] then dfs(v, i);
        if d[u][v] < d[v][i] + 1 then d[u][v]:=d[v][i] + 1;
      end;
  for i:=1 to n do
    if h[u][v][i] and (not marked[v][i]) then
      begin
        cycle:=true;
        exit;
      end;
  marked[u][v]:=true;
  if d[u][v] = 0 then d[u][v]:=1;
end;


var max, i, j, k, kk: int;
var t1, t2: array [1..MAXS, 1..MAXS] of int;
var xread, yread: int;
begin
  assign(input, 'travel.in');
  assign(output, 'travel.out');
  reset(input);
  rewrite(output);
  read(n);
  for i:=1 to n do
    for j:=1 to 3 do
      begin
        read(xread, yread);
        x[j][i]:=int64(xread);
        y[j][i]:=int64(yread);
      end;
  if n = 1 then
    begin
      writeln(0);
      close(input);
      close(output);
      exit;
    end;
  for i:=1 to n do
    begin
      x[-1][i]:=x[2][i];
      y[-1][i]:=y[2][i];
      x[0][i]:=x[3][i];
      y[0][i]:=y[3][i];
      x[4][i]:=x[1][i];
      y[4][i]:=y[1][i];
      x[5][i]:=x[2][i];
      y[5][i]:=y[2][i];
    end;
  for i:=1 to n do
    for j:=1 to n do
      if (i <> j) then
        begin
          kk:=-1;
          for k:=1 to 3 do
            if inside(i, x[k][j], y[k][j]) then
              begin
                kk:=k;
                break;
              end;
          t1[i][j]:=kk;
          t2[i][j]:=-1;
          if kk = -1 then continue;
          for k:=1 to 3 do
            if inters(i, k, j, kk - 1) and inters(i, k, j, kk + 1) then
              begin
                t2[i][j]:=k;
                break;
              end;
          if t2[i][j] = -1 then t1[i][j]:=-1;
        end;
  for i:=1 to n do
    for j:=1 to n do
      for k:=1 to n do
        h[i][j][k]:=false;
  for i:=1 to n do
    for j:=1 to n do
      if (i <> j) then
        for k:=1 to n do
          if (k <> i) and (k <> j) then
            begin
              if (t1[i][j] = -1) or (t1[j][k] = -1) then continue;
              if t1[i][j] = t2[j][k] then
                h[i][j][k]:=true;
            end;
  for i:=1 to n do
    for j:=1 to n do
      d[i][j]:=0;
  cycle:=false;
  for i:=1 to n do
    for j:=1 to n do
      if (i <> j) and (not mark[i][j]) then
        dfs(i, j);
  if cycle then
    begin
      writeln(-1);
      close(input);
      close(output);
      exit;
    end;
  max:=-1;
  for i:=1 to n do
    for j:=1 to n do
      if (i <> j) and (d[i][j] > max) then
        max:=d[i][j];
  writeln(max);
  close(input);
  close(output);
end.
