program G;

const maxN = 100;

type trType = record
                x,y: integer;
              end;

var t: array[1..maxN] of array[1..3] of trType;

var table: array[1..maxN,1..maxN] of array[1..3] of array[1..3] of boolean;

var N: byte;

function orient(a,b,c: trType): integer;

  var area: double;

  begin
    area:=a.x*b.y-a.y*b.x+b.x*c.y-b.y*c.x+c.x*a.y-c.y*a.x;
    if area>0 then
      orient:=1;
    if area<0 then
      orient:=-1;
    if area = 0 then
      orient:=0;
  end;

function contains(i,j,k: byte): boolean;

  begin {contains}
    if orient(t[i][1],t[i][2],t[i][3])*
       orient(t[i][2],t[i][3],t[j][k])*
       orient(t[i][3],t[j][k],t[i][1])*
       orient(t[j][k],t[i][1],t[i][2]) = -1 then
      contains:=true
    else
      contains:=false;
  end;  {contains}

function int(i,l,j,k1,k2: byte): boolean;

  var l1,l2: byte;
      x11,x12,y11,y12,x21,x22,y21,y22: integer;
      x0,y0,a1,a2,b1,b2: double;

  begin
    l1:=l mod 3+1;
    l2:=(l+1) mod 3+1;
    x11:=t[i][l1].x;
    x12:=t[i][l2].x;
    y11:=t[i][l1].y;
    y12:=t[i][l2].y;
    if (x11 <> x12) then
    begin
      a1:=(y12-y11)/(x12-x11);
      b1:=(x12*y11-y12*x11)/(x12-x11);
    end;

    x21:=t[j][k1].x;
    x22:=t[j][k2].x;
    y21:=t[j][k1].y;
    y22:=t[j][k2].y;
    if (x21 <> x22) then
    begin
      a2:=(y22-y21)/(x22-x21);
      b2:=(x22*y21-y22*x21)/(x22-x21);
    end;

    if (x11 = x12) then
    begin
      if (x21 = x22) then
        int:=false
      else
      begin
        y0:=a2*x11+b2;
        if ((y0>y21) and (y0<y22)) or ((y0<y21) and (y0>y22)) then
          int:=true
        else
          int:=false;
      end;
    end
    else
    begin
      if (x21 = x22) then
      begin
        y0:=a1*x21+b1;
        if ((y0>y11) and (y0<y12)) or ((y0<y11) and (y0>y12)) then
          int:=true
        else
          int:=false;
      end
      else
      begin
        if (a1 = a2) then
          int:=false
        else
        begin
          x0:=(b1-b2)/(a2-a1);
          if (((x0<x11) and (x0>x12)) or ((x0>x11) and (x0<x12))) and
             (((x0<x21) and (x0>x22)) or ((x0>x21) and (x0<x22))) then
            int:=true
          else
            int:=false;
        end;
      end;
    end;
  end;  {int}


function intersects(i,l,j,k: byte): boolean;

  begin  {intersects}
    if int(i,l,j,k,k mod 3+1) and int(i,l,j,k,(k+1) mod 3+1) then
      intersects:=true
    else
      intersects:=false;

    {if (orient(t[i][l mod 3 +1],t[j][k],t[i][(l+1) mod 3 +1])*
        orient(t[j][k],t[i][(l+1) mod 3 +1],t[j][k mod 3+1])*
        orient(t[i][(l+1) mod 3 +1],t[j][k mod 3+1],t[i][l mod 3+1])*
        orient(t[j][k mod 3+1],t[i][l mod 3+1],t[j][k]) = 1) and
       (orient(t[i][l mod 3 +1],t[j][k],t[i][(l+1) mod 3 +1])*
        orient(t[j][k],t[i][(l+1) mod 3 +1],t[j][(k+1) mod 3+1])*
        orient(t[i][(l+1) mod 3 +1],t[j][(k+1) mod 3+1],t[i][l mod 3+1])*
        orient(t[j][(k+1) mod 3+1],t[i][l mod 3+1],t[j][k]) = 1) then
      intersects:=true
    else
      intersects:=false;}
  end;   {intersects}

function findMaxPath(i,l: byte): integer;

  function max(a,b,c: integer): integer;
    begin
      if (a>b) and (a>c) then
        max:=a
      else
      if (b>c) then
        max:=b
      else
        max:=c;
    end;

  function max2(a,b: integer): integer;
    begin
      if a>b then
        max2:=a
      else
        max2:=b;
    end;

  var j,m,mm,m1,m2,m3: integer;

  begin  {findMaxPath}
    j:=1;
    mm:=1; {}
    m:=1;
    while (j<=N) and (mm<>-1) do
    begin
      if (i<>j) then
      begin
        if (table[i,j][l][1]) then
          m1:=findMaxPath(j,1)
        else
          m1:=0;
        if (table[i,j][l][2]) then
          m2:=findMaxPath(j,2)
        else
          m2:=0;
        if (table[i,j][l][3]) then
          m3:=findMaxPath(j,3)
        else
          m3:=0;
        if (m1 = -1) or (m2 = -1) or (m3 = -1) then
          m:=-1
        else
          inc(m,max(m1,m2,m3));
      end;
      if m = -1 then
        mm:=-1
      else
        mm:=max2(m,mm);
      inc(j);
    end;
    findMaxPath:=mm;
  end;  {findMaxPath}

const inPath = 'travel.in';
      outPath = 'travel.out';

var inf,outf: text;
    i,j,k,l,max,m: byte;

begin
  assign(inf,inPath);
  reset(inf);
  readln(inf,N);
  for i:= 1 to N do
    readln(inf,t[i][1].x,t[i][1].y,t[i][2].x,t[i][2].y,t[i][3].x,t[i][3].y);
  close(inf);

  for i:= 1 to N do
    for j:= 1 to N do
    begin
      if i <> j then
      begin
        for k:= 1 to 3 do
          if contains(i,j,k) then
          begin
            for l:= 1 to 3 do
            begin
              if intersects(i,l,j,k) then
                table[i,j][l][k]:=true
              else
                table[i,j][l][k]:=false;
            end;
          end;
      end;
    end;

  max:=1;{}
  i:=1;
  while (i<=N) and (max<>-1) do
  begin
    m:=1;  {}
    for j:= 1 to 3 do
    begin
      m:=findMaxPath(i,j);
      if (m = -1) or (m>max) then
        max:=m;
    end;
    inc(i);
  end;

  assign(outf,outPath);
  rewrite(outf);
  writeln(outf,max);
  close(outf);
end.