#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef struct {
  long x,y;
} point;

typedef struct {
  point a,b,c;
} triangle;

long mymax(long a, long b) {
  return (a>b)?a:b;
}

long mymin(long a, long b) {
  return (a<b)?a:b;
}

long area(point a, point b, point c) {
  return labs(
    a.x*b.y-b.x*a.y+
    b.x*c.y-c.x*b.y+
    c.x*a.y-c.y*a.x
  );
}

int isPoint(triangle a, point b) {
  long aa=area(a.b,a.c,b),bb=area(a.a,a.c,b),cc=area(a.b,a.a,b);
  if (aa==0) return 0;
  if (bb==0) return 0;
  if (cc==0) return 0;
  if (aa+bb+cc==area(a.a,a.b,a.c))
    return 1;
  return 0;
}

int Peresec(point a, point b, point c, point d) {
  float k1,b1,k2,b2,tt,ty;
  if (a.x==b.x) {
    if (c.x!=d.x) {
      k1=(c.y-d.y)/(1.0*(c.x-d.x));
      b1=c.y-k1*c.x;
      tt=k1*a.x+b1;
      if ((tt<mymax(c.y,d.y))&&(tt>mymin(c.y,d.y))) return 1;
      if ((c.y==d.y)&&(fabs(c.y-tt)<0.0000001)) return 1;
      return 0;
    } else return 0;
  } else {
    k1=(a.y-b.y)/(1.0*(a.x-b.x));
    b1=a.y-k1*a.x;
    if (c.x!=d.x) {
      k2=(c.y-d.y)/(1.0*(c.x-d.x));
      b2=c.y-k2*c.x;
      if (fabs(k1-k2)>0.0000001) {
	tt=(b2-b1)/(k1-k2);
	ty=k1*tt+b1;
	if ( (mymax(a.y,b.y)-ty>-0.0000001) &&
	     (ty-mymin(a.y,b.y)>-0.0000001) &&
	     (mymax(c.y,d.y)-ty>-0.0000001) &&
	     (ty-mymin(c.y,d.y)>-0.0000001)
	) return 1;
	return 0;
      } else return 0;
    } else {
      tt=k1*c.x+b1;
      if ((tt<mymax(a.y,b.y))&&(tt>mymin(a.y,b.y))) return 1;
      if ((a.y==b.y)&&(fabs(a.y-tt)<0.0000001)) return 1;
      return 0;
    }
  }
}

point a1,a2,a3,a4;

char isElocka(triangle a, triangle b) {
  point t;
  if (isPoint(b,a.a)||isPoint(b,a.b)||isPoint(b,a.c)) return 0;
  if (isPoint(a,b.b)) {
    t=b.b;
    b.b=b.a;
    b.a=t;
  }
  if (isPoint(a,b.c)) {
    t=b.c;
    b.c=b.a;
    b.a=t;
  }
  if (!isPoint(a,b.a)) return 0;
  if (isPoint(a,b.c)||isPoint(a,b.b)) return 0;
  if (Peresec(a.a,a.c,b.a,b.b)) {
    t=a.c;
    a.c=a.b;
    a.b=t;
  }
  if (Peresec(a.b,a.c,b.a,b.b)) {
    t=a.c;
    a.c=a.a;
    a.a=t;
  }
  if (!Peresec(a.a,a.b,b.a,b.c)) return 0;
  if (!Peresec(a.a,a.b,b.a,b.b)) return 0;
  a1=b.a;
  a3=a.a;
  a4=a.b;
  return 1;
}

int equalPoint(point a,point b) {
  return ((a.x==b.x)&&(a.y==b.y));
}

char isElochka(triangle a,triangle b, triangle c) {
  point a2;
  if (!isElocka(a,b)) return 0;
  a2=a1;
  if (!isElocka(b,c)) return 0;
  if (equalPoint(a2,a3)) return 0;
  if (equalPoint(a2,a4)) return 0;
  return 1;
}

char mc[100][100][100];
int max=0;
char vis[100];
int n;

void tarGO(int l,int v, long len) {
  int i;
  if (max > 0) {
    if (len>max) max=len;
    vis[v]=1;
    for (i=0;i<n;i++) if ((v!=i)&&(mc[l][v][i]==1)) {
      if (!vis[i]) tarGO(v,i,len+1);
      else max = -1;
    }
    vis[v]=0;
  }
}

int main () {
  int i,j,k;
  triangle t[100];
  FILE *f=fopen("travel.in","r");
  fscanf(f,"%ld\n",&n);
  for (i=0;i<n;i++) {
    fscanf(f,"%ld %ld %ld %ld %ld %ld\n",&t[i].a.x,&t[i].a.y,&t[i].b.x,&t[i].b.y,&t[i].c.x,&t[i].c.y);
  }
  fclose(f);
//  printf("sadas");
  for (i=0;i<n;i++) {
    for (j=0;j<n;j++) {
      for (k=0;k<n;k++) {
	if ((i!=j)&&(j!=k)) mc[i][j][k]=isElochka(t[i],t[j],t[k]);
	else mc[i][j][k]=0;
      }
    }
  }
  for (j=0;j<n;j++) vis[j]=0;

//  printf("sadas");
//fflush(stdout);
  for (i=0;i<n;i++) {
    vis[i]=1;
    for (j=0;j<n;j++) if ((i!=j)&&(isElocka(t[i],t[j]))) {
      tarGO(i,j,1);
    }
    vis[i]=0;
  }

  f=fopen("travel.out","w");
  fprintf(f,"%ld\n",max);
  fclose(f);
  return 0;
}
