{$E-}{$N+}
const
max = 5000;
type
point = record
      x, y : longint;
end;
var
   a : array [1..max] of point;
   n, i, j, bp : longint;
   min, S, z, z1, z2 : extended;
   xA, xB, xC : extended;
   tmp : point;

procedure calcCoeffs(a, b : point; var xa, xb, xc : extended);
begin
     xa := (b.y - a.y);
     xb := (a.x - b.x);
     xc := -(xa * a.x + xb * a.y);
end;

function dist(a, b : point) : extended;
var
p, q : extended;
begin
     p := (a.x-b.x);
     q := (a.y-b.y);
     dist := sqrt(sqr(p) + sqr(q));
end;

function inoneline(a,b,c:point) : boolean;
var
   z, z1 : comp;
begin
     z := b.y - a.y;
     z := z * (c.x - b.x);
     z1 := b.x - a.x;
     z1 := z1 * (c.y - b.y);
     inoneline := z = z1;
end;

procedure QSort(l, r : integer);
var
  pa, sa : point;
  k, i, j : integer;
begin
     pa := a[l + random(r-l+1)];
     i := l;
     j := r;
     repeat
           while (a[i].x < pa.x) or ((a[i].x = pa.x) and (a[i].y < pa.y)) do
                 inc(i);
           while (pa.x < a[j].x) or ((pa.x = a[j].x) and (pa.y < a[j].y)) do
                 dec(j);
           if i <= j then
           begin
                sa := a[i];
                a[i] := a[j];
                a[j] := sa;
                inc(i);
                dec(j);
           end;
     until i > j;
     if j > l then QSort(l, j);
     if r > i then QSort(i, r);
end;

begin
     randomize;
     if paramcount = 0 then
     assign(input,'d.in') else assign(input,paramstr(1));
     reset(input);
     if paramcount < 2 then
     assign(output,'d.out') else assign(output,paramstr(2));
     rewrite(output);
     read(n);
     for i := 1 to n do read(a[i].x, a[i].y);
     if (n = 3) then
     begin
          z := dist(a[1],a[2])+dist(a[2],a[3]);
          z1 := dist(a[2],a[3])+dist(a[3],a[1]);
          z2 := dist(a[1],a[2])+dist(a[3],a[1]);
          if z1 < z then z := z1;
          if z2 < z then z := z2;
          writeln(z:0:6);
          close(input);
          close(output);
          exit;
     end;
     if inoneline(a[1],a[2],a[3]) then calccoeffs(a[1],a[2],xa,xb,xc) else
     if inoneline(a[1],a[2],a[4]) then calccoeffs(a[1],a[2],xa,xb,xc) else
     calccoeffs(a[3],a[4],xa,xb,xc);
     bp := 0;
     for i := 1 to n do if xa*a[i].x + xb*a[i].y + xc <> 0 then bp := i;
     if bp <> 0 then
     begin
          tmp := a[1];
          a[1] := a[bp];
          a[bp] := tmp;
     end;
     if bp = 0 then QSort(1, n) else QSort(2, n);
     S := 0;
     if bp = 0 then for i := 1 to n-1 do S := S + dist(a[i],a[i+1]) else
        for i := 2 to n-1 do S := S + dist(a[i],a[i+1]);

     if bp = 0 then
     begin
          writeln(S:0:6);
          close(input);
          close(output);
          halt;
     end;
     min := S + dist(a[1],a[2]);
     if min > S + dist(a[1],a[n]) then min := S + dist(a[1],a[n]);
     for i := 2 to n-1 do
     begin
          if min > S - dist(a[i],a[i+1]) + dist(a[i],a[1]) + dist(a[1],a[i+1]) then
             min := S - dist(a[i],a[i+1]) + dist(a[i],a[1]) + dist(a[1],a[i+1]);
     end;
     writeln(min:0:6);
     close(input);
     close(output);
end.