{$apptype CONSOLE}
{$R+}

uses
	Math;

const
	inFile = 'cows.in';
	outFile = 'cows.out';

	maxN = 100000;
	maxM = maxN * 2;

type
	TEdge = record
		next : integer;
		tg : integer;
		w : integer;
		inv : integer;
	end;

	TIntArray = array[1..maxN] of integer;

var
	n : integer;
	ne : integer;
	e : array[1..maxM] of TEdge;
	h : TIntArray;
	emax : TIntArray;
	first : TIntArray;
	ansU, ansV : integer;
	ansMin : integer;

	curD : integer;
	di, dj, dk : integer;

	dlen : integer;
	de, dv : TIntArray;

	q : TIntArray;
    x : TIntArray;
	used : array[1..maxN] of boolean;

	la, lb, ra, rb : TIntArray;
    li, ri : TIntArray;

procedure DFS1(i, parent : integer);
var
	j : integer;
	cur, max1, max2 : integer;
	e1, e2 : integer;

begin
	h[i] := 0;
	j := first[i];
	max1 := 0;
	max2 := 0;
	e1 := 0;
	e2 := 0;
	while j <> 0 do begin
		if e[j].tg <> parent then begin
			DFS1(e[j].tg, i);
			cur := e[j].w + h[e[j].tg];
			if cur >= max1 then begin
				max2 := max1;
				e2 := e1;
				max1 := cur;
				e1 := j;
			end else if cur >= max2 then begin
				max2 := cur;
				e2 := j;
			end;
		end;
		j := e[j].next;
	end;

	cur := max1 + max2;
	if cur > curD then begin
		curD := cur;
		di := i;
		dj := e1;
		dk := e2;
	end;

	h[i] := max1;
	emax[i] := e1;
//	writeln('at ', i, ' max1=', max1, ' max2=', max2);
end;

procedure EnlistEdges(ei : integer; var list : TIntArray; var pos : integer);
begin
	repeat
		list[pos] := ei;
		inc(pos);
		ei := emax[e[ei].tg];
	until ei = 0;
end;

procedure ReverseEdges(var list : TIntArray; lo, hi : integer);
var
	i, tmp : integer;

begin
	for i := 0 to (hi - lo) div 2 do begin
		tmp := list[i + lo];
		list[i + lo] := list[hi - i];
		list[hi - i] := tmp;
	end;
	for i := lo to hi do
		list[i] := e[list[i]].inv;
end;

procedure FindDiameter;
var	
	i, x, y : integer;

begin
	curD := -1;
	di := 0;
	dj := 0;
	dk := 0;
	DFS1(1, 0);

	x := 1;
	EnlistEdges(dj, de, x);
	if dk > 0 then begin
		dv[1] := e[de[x - 1]].tg;
		ReverseEdges(de, 1, x - 1);
		y := x;
		EnlistEdges(dk, de, y);
		dlen := y - 1;
	end else begin
		dv[1] := di;
		dlen := x - 1;
	end;

	for i := 2 to dlen + 1 do
		dv[i] := e[de[i-1]].tg;
end;

procedure DFS2(i : integer);
var
	j : integer;

begin
	used[i] := true;
	j := first[i];
	q[i] := 0;
	while j <> 0 do begin
		if not used[e[j].tg] then begin
			DFS2(e[j].tg);
			q[i] := max(q[i], e[j].w + q[e[j].tg]);
		end;
		j := e[j].next;
	end;
end;

procedure FindQX;
var
	i : integer;

begin
	fillchar(used, sizeof(used), false);
	for i := 1 to dlen + 1 do
		used[dv[i]] := true;

	for i := 1 to dlen + 1 do
		DFS2(dv[i]);

    x[1] := 0;
    for i := 2 to dlen + 1 do
    	x[i] := x[i-1] + e[de[i-1]].w;
end;

procedure UpdateAB(a1, b1, a2, b2 : integer; var a, b : integer);
begin
	if b2 < -a2 + a1 + b1 then begin
		a := a1;
		b := b1;
	end else if (b2 >= -a2 + a1 + b1) and (b2 <= a2 - a1 + b1) then begin
		a := (a1 + a2 + b2 - b1) div 2;
		b := a + b1 - a1;
	end else begin
		a := a2;
		b := b2;
	end;
end;

procedure Adjust(var a, b : TIntArray; var t : TIntArray);
var
	i, j : integer;

begin
    j := 1;
    for i := 1 to dlen + 1 do begin
    	while a[i] > x[j] do
        	inc(j);
		if (j > 1) and (abs(x[j-1] - a[i]) < abs(x[j] - a[i])) then begin
            b[i] := b[i] + abs(x[j-1] - a[i]);
        	a[i] := x[j-1];
            t[i] := j - 1;
        end else begin
            b[i] := b[i] + abs(x[j] - a[i]);
        	a[i] := x[j];
            t[i] := j;
        end;
    end;
end;

procedure FindAB;
var
	i : integer;

begin
    la[1] := 0;
    la[1] := q[dv[1]];
	for i := 2 to dlen + 1 do
		UpdateAB(la[i-1], lb[i-1], x[i], q[dv[i]], la[i], lb[i]);

	ra[dlen + 1] := x[dlen + 1];
	rb[dlen + 1] := q[dv[dlen + 1]];
	for i := dlen downto 1 do
		UpdateAB(x[i], q[dv[i]], ra[i+1], rb[i+1], ra[i], rb[i]);
{
	writeln;
	for i := 1 to dlen + 1 do
		writeln(x[i], ' ', la1[i], ' ', lb1[i], ' ', li1[i], ' ', ra1[i], ' ', rb1[i], ' ', ri1[i]);
}
    Adjust(la, lb, li);
    Adjust(ra, rb, ri);
{
	writeln;
	for i := 1 to dlen + 1 do
		writeln(x[i], ' ', la1[i], ' ', lb1[i], ' ', li1[i], ' ', ra1[i], ' ', rb1[i], ' ', ri1[i]);
 }
end;

procedure FindUV;
var
	min, cur : integer;
    i : integer;

begin
	min := maxint;
    for i := 2 to dlen + 1 do begin
    	cur := max(lb[i-1], rb[i]);
        if cur < min then begin
        	min := cur;
        	ansU := dv[li[i-1]];
            ansV := dv[ri[i]];
        end;
    end;

    ansMin := min;
end;

procedure Solve;
begin
	FindDiameter;
	FindQX;
	FindAB;
    FindUV;
end;

procedure  ReadData;
var
	i : integer;
	x, y, w : integer;
	e1, e2 : integer;

	function InsertEdge(x, y, w : integer) : integer;
	begin
		inc(ne);
		e[ne].tg := y;
		e[ne].w := w;
		e[ne].next := first[x];
		first[x] := ne;
        InsertEdge := ne;
	end;

begin
	assign(input, inFile);
	reset(input);

	fillchar(first, sizeof(first), 0);
	read(n);
	for i := 1 to n - 1 do begin
		read(x, y, w);
		e1 := InsertEdge(x, y, w * 2);
		e2 := InsertEdge(y, x, w * 2);
		e[e1].inv := e2;
		e[e2].inv := e1;
	end;
	close(input);
end;

procedure WriteData;
begin
	assign(output, outFile);
	rewrite(output);
	writeln(ansU, ' ' , ansV);
	writeln(ansMin div 2);
	close(output);
end;

begin
	ReadData;
	Solve;
	WriteData;
end.
