Program SomeSmallPolygonTryingToIntersectItselfInSomeVeryVeryDangerousMannerAndToMakeOurAlgorithmTooSlow;
Uses Math;
Type
  Integer=LongInt;
Const
  TaskID='poly';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=100002;
  MaxCoord=Integer(1) Shl 20-1;
Type
  TEventKind=(_Start,_Finish,_Query);
  TEvent=Record
    Kind:TEventKind;
    X1,Y1,Y2:Integer;
  End;
Var
  N:Integer;
  X,Y:Array[1..MaxN]Of Integer;
  NE:Integer;
  Event:Array[1..MaxN*2]Of TEvent;
  Am:Array[0..2*MaxCoord]Of Integer;
  Res:Int64;
Procedure Load;
Var
  I:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  For I:=1 To N Do
    Read(X[I],Y[I]);
  Close(Input);
End;
Procedure QSort(L,R:Integer);
Var
  I,J,X:Integer;
  Y:TEvent;
Begin
  I:=L;
  J:=R;
  X:=Event[(L+R) Div 2].X1;
  Repeat
    While Event[I].X1<X Do Inc(I);
    While X<Event[J].X1 Do Dec(J);
    If I<=J Then Begin
      Y:=Event[I];
      Event[I]:=Event[J];
      Event[J]:=Y;
      Inc(I);
      Dec(J);
    End;
  Until I>J;
  If L<J Then QSort(L,J);
  If I<R Then QSort(I,R);
end;
Procedure Modify(At,By:Integer);
Var
  P2:Integer;
Begin
  P2:=1;
  Inc(Am[At],By);
  While True Do Begin
    If At And P2=0 Then Begin
      Inc(At,P2);
      If At>High(Am) Then Break;
      Inc(Am[At],By);
    End;
    P2:=P2 Shl 1;
  End;
End;
Function ZeroQuery(At:Integer):Integer;
Var
  P2:Integer;
  R:Integer;
Begin
  P2:=1;
  R:=0;
  While At>=0 Do Begin
    If At And P2=0 Then Begin
      Inc(R,Am[At]);
      Dec(At,P2);
    End;
    P2:=P2 Shl 1;
  End;
  ZeroQuery:=R;
End;
Function Query(Left,Right:Integer):Integer;
Begin
  Query:=ZeroQuery(Right)-ZeroQuery(Left-1);
End;
Procedure Solve;
Var
  I,CX,CY,By:Integer;
Begin
  If Odd(X[1]+Y[1]) Then
    By:=1
  Else
    By:=0;
  For I:=1 To N Do Begin
    CX:=(X[I]+Y[I]+By) Div 2;
    CY:=(X[I]-Y[I]+By) Div 2;
    X[I]:=CX;
    Y[I]:=CY;
  End;
  Res:=0;
  NE:=0;
  For I:=1 To N-1 Do Begin
    If X[I+1]=X[I] Then Begin
      Inc(NE);
      With Event[NE] Do Begin
        Kind:=_Query;
        X1:=X[I];
        Y1:=Min(Y[I],Y[I+1])+MaxCoord;
        Y2:=Max(Y[I],Y[I+1])+MaxCoord;
      End;
    End Else Begin
      Inc(NE);
      With Event[NE] Do Begin
        Kind:=_Start;
        X1:=Min(X[I],X[I+1]);
        Y1:=Y[I]+MaxCoord;
      End;
      Inc(NE);
      With Event[NE] Do Begin
        Kind:=_Finish;
        X1:=Max(X[I],X[I+1]);
        Y1:=Y[I]+MaxCoord;
      End;
    End;
  End;
  QSort(1,NE);
  FillChar(Am,SizeOf(Am),0);
  For I:=1 To NE Do With Event[I] Do Case Kind Of
    _Start:Modify(Y1,+1);
    _Finish:Modify(Y1,-1);
    _Query:Res:=Res+Query(Y1+1,Y2-1);
  End;
End;
Procedure Save;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Res);
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
