{$I-,Q-,R-,S-,H+}
Program HowManyConnectedGraphsCanYouConstruct;
Const
  TaskID='graphs';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=200;
  MaxLong=1500;
  ShiftBy=15;
  Base=1 Shl ShiftBy;
Type
  Integer=LongInt;
  TLong=Record
    Data:Array[0..MaxLong]Of Word;
    Imp:Integer;
  End;
Var
  N:Integer;
  Am:Array[1..MaxN]Of TLong;
  CStore:Array[0..MaxN,0..MaxN]Of TLong;
  ResFor:Array[0..MaxN,0..MaxN]Of TLong;
  Got:Array[0..MaxN,0..MaxN]Of Boolean;
Operator := (A:Integer)B:TLong;
Var
  I:Integer;
Begin
  FillChar(B.Data,SizeOf(B.Data),0);
  B.Imp:=0;
  I:=0;
  While A>0 Do Begin
    B.Data[I]:=A And (Base-1);
    A:=A Shr ShiftBy;
    Inc(I);
    Inc(B.Imp);
  End;
End;
Operator * (A,B:TLong)C:TLong;
Var
  I,J,K,R,P:Integer;
Begin
  C:=0;
  For I:=0 To MaxLong Do Begin
    If I>=A.Imp Then Break;
    P:=0;
    For J:=0 To MaxLong-I Do Begin
      If (J>=B.Imp) And (P=0) Then Break;
      K:=I+J;
      R:=Integer(A.Data[I])*B.Data[J]+C.Data[K]+P;
      C.Data[K]:=R And (Base-1);
      If K+1>C.Imp Then C.Imp:=K+1;
      P:=R Shr ShiftBy;
    End;
  End;
  While (C.Imp>0) And (C.Data[C.Imp-1]=0) Do Dec(C.Imp);
End;
Operator + (A,B:TLong)C:TLong;
Var
  I,R,P:Integer;
Begin
  P:=0;
  C:=0;
  For I:=0 To MaxLong Do Begin
    If (I>=A.Imp) And (I>=B.Imp) And (P=0) Then Break;
    R:=Integer(A.Data[I])+B.Data[I]+P;
    If R>=Base Then Begin
      C.Data[I]:=R-Base;
      P:=1;
    End Else Begin
      C.Data[I]:=R;
      P:=0;
    End;
    If I+1>C.Imp Then C.Imp:=I+1;
  End;
  While (C.Imp>0) And (C.Data[C.Imp-1]=0) Do Dec(C.Imp);
End;
Operator + (A:TLong; B:Integer)C:TLong;
Var
  D:TLong;
Begin
  D:=B;
  C:=A+D;
End;
Operator - (A,B:TLong)C:TLong;
Var
  I,R,P:Integer;
Begin
  P:=0;
  C:=0;
  For I:=0 To MaxLong Do Begin
    If (I>=A.Imp) And (I>=B.Imp) And (P=0) Then Break;
    R:=Integer(A.Data[I])-Integer(B.Data[I])-P;
    If R<0 Then Begin
      C.Data[I]:=R+Base;
      P:=1;
    End Else Begin
      C.Data[I]:=R;
      P:=0;
    End;
    If I+1>C.Imp Then C.Imp:=I+1;
  End;
  While (C.Imp>0) And (C.Data[C.Imp-1]=0) Do Dec(C.Imp);
End;
Operator * (A:TLong; B:Integer)C:TLong;
Var
  I,R,P:Integer;
Begin
  P:=0;
  C:=0;
  For I:=0 To MaxLong Do Begin
    If (I>=A.Imp) And (P=0) Then Break;
    R:=Integer(A.Data[I])*B+P;
    C.Data[I]:=R And (Base-1);
    P:=R Shr ShiftBy;
    If I+1>C.Imp Then C.Imp:=I+1;
  End;
  While (C.Imp>0) And (C.Data[C.Imp-1]=0) Do Dec(C.Imp);
End;
Operator Div (A:TLong; B:Integer)C:TLong;
Var
  I,R,P:Integer;
Begin
  P:=0;
  C:=0;
  For I:=A.Imp-1 DownTo 0 Do Begin
    R:=P Shl ShiftBy+Integer(A.Data[I]);
    C.Data[I]:=R Div B;
    P:=R Mod B;
  End;
  C.Imp:=A.Imp;
  While (C.Imp>0) And (C.Data[C.Imp-1]=0) Do Dec(C.Imp);
End;
Operator Mod(A:TLong; B:Integer)C:Integer;
Var
  I,R,P:Integer;
Begin
  P:=0;
  For I:=A.Imp-1 DownTo 0 Do Begin
    R:=P Shl ShiftBy+Integer(A.Data[I]);
    P:=R Mod B;
  End;
  C:=P;
End;
Function ToString(A:TLong):String;
Var
  C:String;
Begin
  C:='';
  While A.Imp>0 Do Begin
    C:=Chr(Ord('0')+A Mod 10)+C;
    A:=A Div 10;
  End;
  ToString:=C;
End;
Function C(N,K:Integer):TLong;
Begin
  C:=CStore[N,K];
End;
Procedure Load;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  Close(Input);
End;
Procedure Rec(Num,Max:Integer; Var Res:TLong);
Var
  A,B:TLong;
  I,J:Integer;
Begin
  If Got[Num,Max] Then Begin
    Res:=ResFor[Num,Max];
    Exit;
  End;
  Res:=0;
  For I:=Max DownTo 1 Do Begin
    If I=1 Then Begin
      Res:=Res+1;
      Break;
    End;
    A:=1;
    For J:=1 To Num Div I Do Begin
      A:=A*Am[I]*C(Num-(J-1)*I,I) Div J;
      Rec(Num-J*I,I-1,B);
      Res:=Res+A*B;
    End;
  End;
  Got[Num,Max]:=True;
  ResFor[Num,Max]:=Res;
End;
Procedure FillC;
Var
  I,J:Integer;
Begin
  For I:=0 To N Do
    For J:=0 To I Do Begin
      If (J=0) Or (J=I) Then
        CStore[I,J]:=1
      Else
        CStore[I,J]:=CStore[I-1,J-1]+CStore[I-1,J];
    End;
End;
Procedure Solve;
Var
  I,J:Integer;
  Total:TLong;
  Pow2,NP2:Integer;
  Progress:Text;
Begin
  FillC;
  Am[1]:=1;
  Total:=1;
  Pow2:=0;
  FillChar(Got,SizeOf(Got),False);
  Assign(Progress,'');
  ReWrite(Progress);
  For I:=2 To N Do Begin
    Rec(I,I-1,Am[I]);
    NP2:=I*(I-1) Div 2;
    For J:=Pow2+1 To NP2 Do
      Total:=Total*2;
    Pow2:=NP2;
    Am[I]:=Total-Am[I];
    Write(Progress,I,' - ');
    WriteLn(Progress,ToString(Am[I]));
  End;
  Close(Progress);
End;
Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  For I:=1 To N Do Begin
    Write(I,' - ');
    WriteLn(Output,ToString(Am[I]));
  End;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
