{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

{

  Sample solution for the task ""
  Copyright(c) by Michael Mirzayanov

  Last revision date : ??.06.2003

}

program Shablon;

  uses
    SysUtils;

  const
    inFile = 'left.in';
    outFile = 'left.out';
    inf : int64 = 9223372036854775807;
    lmax = 1000;

    base = 100009;
    mul = 1009;

  type
    int = int64;
    real = extended;
    TList = ^TNode;
    TNode = record
              seq : string;
              nxtChar : Char;
              nxt : TList;
            end;
            
    THuge = array [0..lmax] of integer;
    THashList = ^THashNode;
    THashNode = record
                  word : string;
                  nxt : THashList;
                end;

  var
    n : int;
    ans : int;
    gr : array ['A' .. 'Z'] of TList;
    start : Char;
    null : boolean = false;
    strArray : array [1..1024 * 1024] of string;
    tstrArray : int = 0;
    simpleFlag : boolean = true;
    a : array ['A' .. succ('Z'), 'A' .. succ('Z')] of real;
    log : array ['A'..'Z'] of THuge;
    hans : THuge;

    h : array [0..base - 1] of THashList;
    hashCount : integer = 0;

  function hash(w : string) : integer;
    var
      i : integer;
      pw : integer;
  begin
    Result := 0;
    pw := 1;
    for i := 1 to length(w) do begin
      Result := (Result + pw * ord(w[i])) mod base;
      pw := (pw * mul) mod base;
    end;
  end;

  function AddHash(w : string) : boolean;
    var
      x : THashList;
      hvalue : integer;
  begin
    AddHash := False;
    if hashCount > 100000 then exit;
    hvalue := hash(w);
    x := h[hvalue];
    while x <> nil do begin
      if x^.word = w then begin
        Exit;
      end;
      x := x^.nxt;
    end;
    new(x);
    x^.word := w;
    x^.nxt := h[hvalue];
    h[hvalue] := x;
    Result := True;
  end;

  procedure AddHuge(var a : THuge; b : THuge);
    var
      i, j : integer;
      r : int;
  begin
    r := 0;
    if a[0] < b[0] then a[0] := b[0];
    for i := 1 to a[0] do begin
      a[i] := a[i] + b[i] + r;
      r := a[i] div 10;
      a[i] := a[i] mod 10;
    end;
    while r > 0 do begin
      inc(a[0]);
      a[a[0]] := r mod 10;
      r := r div 10;
    end;
  end;

  procedure WritelnHuge(var a : THuge);
    var
      i : integer;
  begin
    if a[0] = 0 then writeln(0) else begin
      for i := a[0] downto 1 do
        write(a[i]);
      writeln;  
    end;
  end;

  procedure OutData;
    var
      i, j : int;
  begin
    assign(output,outFile);
    rewrite(output);

    if ans < inf then begin
      if simpleFlag then
        writeln(ans)
      else
        WritelnHuge(hans);
    end
    else
      writeln('infinity'); 

    close(output);
  end;

  procedure Rec(cur : Char; s : string);
    var
      x : TList;
  begin
    if not simpleFlag then exit;
    x := gr[cur];
    while x <> nil do begin
      if (x^.nxtChar = #0) then begin
        inc(tstrArray);
        if tstrArray > 1024 * 1024 then begin
          simpleFlag := false;
          exit;
        end;
        if x^.seq <> #0 then begin
          strArray[tstrArray] := x^.seq + s;
          if AddHash(x^.seq + s) then inc(hashCount);
        end
        else begin
          strArray[tstrArray] := s;
          if AddHash(s) then inc(hashCount);
        end;
      end else begin
        if a[x^.nxtChar, succ('Z')] <= 0 then begin
          if x^.seq <> #0 then
            Rec(x^.nxtChar, x^.seq + s)
          else
            Rec(x^.nxtChar, s)
        end;
      end;
      x := x^.nxt;
    end;
  end;

  function isInfinity() : boolean;
    var
      ch : char;
      x : TList;
      i, j, k : char;
      rans : real;
  begin
    for k := 'A' to succ('Z') do
      for i := 'A' to succ('Z') do
        if k <> i then
          a[k, i] := 1024
        else
          a[k, i] := 0;

    for ch := 'A' to 'Z' do begin
      x := gr[ch];
      while x <> nil do begin
        if Length(x^.seq) > 0 then begin
          if x^.nxtChar = #0 then begin
            a[ch][succ('Z')] := -0.001;
          end else begin
            a[ch][x^.nxtChar] := -0.001;
          end;
        end;
        x := x^.nxt;
      end;
    end;
    for k := 'A' to succ('Z') do
      for i := 'A' to succ('Z') do
        for j := 'A' to succ('Z') do
          if (a[i, j] > a[i, k] + a[k, j]) and (a[i, k] <= 0) and (a[k, j] <= 0) then begin
            a[i, j] := a[i, k] + a[k, j];
          end;
    rans := a[start, succ('Z')];
    if abs(rans) < 1E-9 then null := true;
    for k := 'A' to succ('Z') do
      for i := 'A' to succ('Z') do
        for j := 'A' to succ('Z') do
          if (a[i, j] > a[i, k] + a[k, j]) and (a[i, k] <= 0) and (a[k, j] <= 0) then begin
            a[i, j] := a[i, k] + a[k, j];
          end;
    Result := rans > a[start, succ('Z')] + 1E-7;        
  end;

  procedure HeapSort;
    var
      p, q : integer;
      x : string;

    procedure sift;
      var
        i, j : int;
    begin
      i := p;
      j := p shl 1;
      x := strArray[i];
      if (j < q) and (strArray[j] <= strArray[j + 1]) then inc(j);
      while (j <= q) and (strArray[j] > x) do begin
        strArray[i] := strArray[j];
        i := j;
        j := j shl 1;
        if (j < q) and (strArray[j] <= strArray[j + 1]) then inc(j);
      end;
      strArray[i] := x;
    end;

  begin
    q := tstrArray;
    for p := tstrArray downto 1 do sift;
    p := 1;
    while q > 1 do begin
      x := strArray[p];
      strArray[p] := strArray[q];
      strArray[q] := x;
      dec(q);
      sift;
    end;
  end;

  function DelSpace(s : string) : string;
    var
      i : integer;
  begin
    Result := '';
    for i := 1 to Length(s) do
      if (s[i] <> ' ') and (s[i] <> #0) then Result := Result + s[i];
  end;

  function SimpleCalc() : int;
    var
      i : integer;
  begin
    for i := 0 to base - 1 do h[i] := nil;
    Result := 0;
    if isInfinity() then begin
      Result := inf;
    end else begin
      if null then begin
        Result := -1;
        exit;
      end;
      Rec(start, '');
      if simpleFlag then begin
        HeapSort;
        if tstrArray = 0 then exit;
        Result := 1;
        for i := 2 to tstrArray do
          if strArray[i] <> strArray[i - 1] then inc(Result);
        exit;
      end else
        Result := -1;
    end;
  end;

  function xRec(cur : char) : THuge;
    var
      x : TList;
      arr : array [1..1024] of string;
      tarr : int;
      flag : boolean;
      j : integer;
      nxtChar : Char;
      tmp : THuge;
  begin
    if cur = #0 then begin
      fillchar(Result, SizeOf(Result), 0);
      Result[0] := 1;
      Result[1] := 1;
      exit;
    end;

    if log[cur][0] > -1 then begin
      Result := log[cur];
      exit;
    end;

    tarr := 0;
    fillchar(Result, SizeOf(Result), 0);
    Result[0] := 1;

    x := gr[cur];
    while x <> nil do begin
      if x^.nxtChar = #0 then
        nxtChar := succ('Z')
      else
        nxtChar := x^.nxtChar;

      if a[nxtChar, succ('Z')] <= 0 then begin
        flag := true;
        for j := 1 to tarr do
          if x^.seq = arr[j] then begin
            flag := false;
            break;
          end;
        if flag then begin
          inc(tarr);
          arr[tarr] := DelSpace(x^.seq + x^.nxtChar);
          tmp := xRec(x^.nxtChar);
          AddHuge(Result, tmp);
        end;
      end;
      x := x^.nxt;
    end;
    log[cur] := Result;
  end;

  procedure Solve;
    var
      i, j : int;
  begin
    ans := SimpleCalc();
    if ans >= 0 then exit;
    fillchar(log, SizeOf(log), $FF);

    if hashCount < 1000 then begin
      ans := hashCount;
      exit;
    end;

    hans := xRec(start);
  end;

  procedure ReadData;
    var
      i, j : integer;
      s : string;
      x : TList;
      xstart : char;
  begin
    assign(input,inFile);
    reset(input);
    read(n);
    read(start);
    readln(start);
    for i := 1 to n do begin
      readln(s);
      s := DelSpace(s);
      new(x);
      xstart := s[1];
      x^.seq := #0;
      x^.nxt := nil;
      x^.nxtChar := #0;
      if length(s) = 3 then begin
      end else begin
        if s[4] in ['A' .. 'Z'] then begin
          x^.nxtChar := s[4];
          x^.seq := Copy(s, 5, 1024);
        end else begin
          x^.seq := Copy(s, 4, 1024);
        end;
      end;
      if (random(2) = 0) or (gr[xstart] = nil) then begin
        x^.nxt := gr[xstart];
        gr[xstart] := x;
      end else begin
        x^.nxt := gr[xstart]^.nxt;
        gr[xstart]^.nxt := x;
      end;
    end;
    close(input);
  end;

begin
  ReadData;
  Solve;
  OutData;
end.
