uses Game;

{$Q-,R-}

type
	integer = longint;
const
	MaxN 	= 50;
	MaxCode	= 500000;
type
	TPath = array [0..MaxN-1] of integer;
var
	nn, k,w: system.integer;
	a: array [0..MaxN-1, 0..MaxN-1] of boolean;
	q: array [0..MaxN-1] of integer;
	wins: array [0..MaxCode] of integer;
	solved: array [0..MaxCode] of boolean;
	fence: TFence;
	curpath: TPath;

procedure SolveInit;
var
	i, j: integer;
begin
	fillchar(a, sizeof(a), 0);

	for i := 0 to nn-2 do
		a[i][i+1] := true;

	for i := 0 to nn-3 do
		for j := i+2 to nn-1 do
			if (j-i<w) and(fence[i] = fence[j]) and (fence[j-1] <> fence[j]) and (fence[i+1] <> fence[i]) then
				a[i][j] := true;

	q[nn-1] := 1;
	for i := nn-2 downto 0 do begin
		q[i] := 0;
		for j := i+1 to nn-1 do
			if a[i][j] then
				Inc(q[i], q[j]);
	end;

	for i := 0 to nn-2 do
		curpath[i] := i+1;
	curpath[nn-1] := -1;

	fillchar(solved, sizeof(solved), 0);
end;

{ u < v,  fence[u+1] <> fence[u], fence[v-1]<>fence[v], fence[u]==fence[v] }
procedure MakeMove(var fence: TFence; var path: TPath; u, v: integer);
var
	i : integer;
begin
	 for i := u+1 to v-1 do
	 	fence[i] := fence[u];
	 path[u] := v;
end;

function getcode(const p: TPath): integer;
var
	code, i, j: integer;
begin
	code := 0;
	i := 0;

	while true do begin
		for j := i+1 to p[i]-1 do
			if a[i][j] then
				Inc(code, q[j]);

		if (i = nn-1) then
			break
		else
			i := p[i];
	end;

	getcode := code;
end;

function getwins(const fence: TFence; const path: TPath): integer;
var
	i, j, code: integer;
	f: TFence;
	p: TPath;
begin
	code := getcode(path);
	if (solved[code]) then begin
		getwins :=  wins[code];
		exit;
	end;

	wins[code] := 0;

	for i := 0 to nn-3 do
		for j := i+2 to nn-1 do
			if (j-i<w) and(fence[i] = fence[j]) and (fence[j-1] <> fence[j]) and (fence[i+1] <> fence[i]) then begin
				f := fence;
				p := path;
				MakeMove(f, p, i, j);
				if (getwins(f, p) = 0) then
					inc(wins[code]);
			end;

	solved[code] := true;
	getwins := wins[code];
end;

var
	i, j, bestU, bestV, best, curWins: integer;
	ii,jj: system.integer;
	f: TFence;
	p: TPath;
begin
  Init(nn, k, w, fence);
  SolveInit;

  while true do begin
    best := maxint;
    bestU := -1;
	for i := 0 to nn-3 do
		for j := i+2 to nn-1 do
			if (j-i<w) and(fence[i] = fence[j]) and (fence[j-1] <> fence[j]) and (fence[i+1] <> fence[i]) then begin
    			f := fence;
    			p := curpath;
    			MakeMove(f, p, i, j);
    			curWins := getwins(f, p);
    			if (curWins < best) then begin
    				best := curWins;
    				bestU := i;
    				bestV := j;
    			end;
    		end;

	if bestU>=0 then
    MakeMove(fence, curpath, bestU, bestV);
    move(bestU, bestV, ii,jj);
    MakeMove(fence, curpath, ii,jj );
  end;
end.
