program Orlov_and_Dyatlov;
{$D-,I-,Q-,R-,S-}
{$N+}
const
  MAXN = 100; {100}
  EPS = 1e-10;
  BIG = 1e10;
  ADDX = 10007.74592635;
  ADDY = 10010.97439652;

type
  point = record
    x, y : extended;
  end;

var
  n, m, hs, ws1, ws2 : integer;
  yo : extended;
  po, pd : array [1..MAXN] of point;
  amin, amax : array [1..MAXN,1..MAXN] of extended;
  emin, emax : array [1..MAXN,1..MAXN] of boolean;
  pmin, pmax : array [1..MAXN,1..MAXN] of longint;
  andyatl, andyatl2 : array [1..MAXN,1..MAXN] of extended;
  h : array [1..MAXN] of longint;
  w1, w2 : array [1..MAXN] of longint;

procedure Load(infile, outfile : string);
var
  i : integer;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n);
  for i:=1 to n do
    read(po[i].x,po[i].y);
  read(m);
  for i:=1 to m do
    read(pd[i].x,pd[i].y);
end;

procedure swap(a, b : integer);
var
  t : integer;
begin
  t := h[a];
  h[a] := h[b];
  h[b] := t;
end;

function greater(a, b : point) : boolean;
begin
  greater := a.x*b.y + eps < b.x*a.y;
end;

procedure heapify(a : integer);
var
  l : integer;
begin
  l := a;
  if (2*a<=hs) and greater(po[h[2*a]],po[h[l]]) then
    l := 2*a;
  if (2*a+1<=hs) and greater(po[h[2*a+1]],po[h[l]]) then
    l := 2*a+1;
  if l<>a then
  begin
    swap(l,a);
    heapify(l);
  end;
end;

function NDyatl(a, b : integer) : integer;
var
  i, t : integer;
  veca, vecb : point;
begin
  t := 0;
  veca.x := po[b].x - po[a].x;
  veca.y := po[b].y - po[a].y;
  for i:=1 to m do
  begin
    vecb.x := pd[i].x - po[a].x;
    vecb.y := pd[i].y - po[a].y;
    if (not greater(po[a],pd[i])) and
       (not greater(pd[i],po[b])) and
       (not greater(veca,vecb)) then
      inc(t);
  end;
  NDyatl := t;
end;

function NDyatl2(a, b : integer) : integer;
var
  i, t : integer;
  veca, vecb : point;
begin
  t := 0;
  veca.x := po[b].x - po[a].x;
  veca.y := po[b].y - po[a].y;
  for i:=1 to m do
  begin
    vecb.x := pd[i].x - po[a].x;
    vecb.y := pd[i].y - po[a].y;
    if (not greater(po[a],pd[i])) and
       (not greater(pd[i],po[b])) and
       (greater(vecb,veca)) then
      inc(t);
  end;
  NDyatl2 := t;
end;

function sq(a, b : integer) : extended;
begin
  sq := po[a].x*po[b].y - po[b].x*po[a].y;
end;

procedure Solve;
var
  i, j, k, l, a, b, c, start : integer;
  veca, vecb : point;
  maxs, mins : extended;
  max3, min3 : integer;
begin
  for i:=1 to n do
  begin
    po[i].x := po[i].x + ADDX;
    po[i].y := po[i].y + ADDY;
  end;
  for i:=1 to m do
  begin
    pd[i].x := pd[i].x + ADDX;
    pd[i].y := pd[i].y + ADDY;
  end;
  hs := n;
  for i:=1 to n do
    h[i] := i;
  for i:=n downto 1 do
    heapify(i);
  while hs>1 do
  begin
    swap(1,hs);
    dec(hs);
    heapify(1);
  end;

  for i:=1 to n do
  begin
    a := h[i];
    for j:=i+1 to n do
    begin
      b := h[j];
      andyatl[a,b] := NDyatl(a,b);
      andyatl2[a,b] := NDyatl2(a,b);
    end;
  end;

  yo := 0;
  for i:=1 to n do                                      {100}
  begin
    start := h[i];
    fillchar(emax,sizeof(emax),0);
    fillchar(emin,sizeof(emin),0);
    for j:=i+1 to n do                                  {5000}
    begin
      a := h[j];
      emax[a,start] := true;
      amax[a,start] := sq(start,a) - Big*ANDyatl[start,a];
      pmax[a,start] := 0;
      emin[a,start] := true;
      amin[a,start] := sq(start,a) - Big*ANDyatl2[start,a];
      pmin[a,start] := 0;
      for k:=j-1 downto i+1 do                          {165000}
      begin
        b := h[k];
        veca.x := po[a].x - po[b].x;
        veca.y := po[a].y - po[b].y;
        for l:=k-1 downto i do                          {4125000}
        begin
          c := h[l];
          vecb.x := po[b].x - po[c].x;
          vecb.y := po[b].y - po[c].y;
          if emax[b,c] and (not greater(vecb,veca)) and
             ((not emax[a,b]) or (amax[a,b]<amax[b,c])) then
            begin
              emax[a,b] := true;
              amax[a,b] := amax[b,c];
              pmax[a,b] := c;
            end;
          if emin[b,c] and (not greater(veca,vecb)) and
             ((not emin[a,b]) or (amin[a,b]>amin[b,c])) then
            begin
              emin[a,b] := true;
              amin[a,b] := amin[b,c];
              pmin[a,b] := c;
            end;
        end;
        if emax[a,b] then
          amax[a,b] := amax[a,b] + sq(b,a) - Big*ANDyatl[b,a];
        if emin[a,b] then
          amin[a,b] := amin[a,b] + sq(b,a) - Big*ANDyatl2[b,a];
      end;
    end;
    for j:=i+1 to n do
    begin
      a := h[j];
      maxs := -1000*Big;
      mins := 1000*Big;
      max3 := 0;
      min3 := 0;
      for k:=i to j-1 do
      begin
        b := h[k];
        if emax[a,b] and (maxs<amax[a,b]) then
        begin
          maxs := amax[a,b];
          max3 := b;
        end;
        if emin[a,b] and (mins>amin[a,b]) then
        begin
          mins := amin[a,b];
          min3 := b;
        end;
      end;
      if maxs-mins>yo+eps then
      begin
        yo := maxs-mins;
        ws1 := 2;
        w1[1] := a;
        w1[2] := max3;
        while pmax[w1[ws1-1],w1[ws1]]<>0 do
        begin
          w1[ws1+1] := pmax[w1[ws1-1],w1[ws1]];
          inc(ws1);
        end;
        ws2 := 2;
        w2[1] := a;
        w2[2] := min3;
        while pmin[w2[ws2-1],w2[ws2]]<>0 do
        begin
          w2[ws2+1] := pmin[w2[ws2-1],w2[ws2]];
          inc(ws2);
        end;
      end;
    end;
  end;
end;

procedure Save;
var
  i : integer;
begin
  if yo<eps then
    writeln(0)
  else
  begin
    writeln(ws1+ws2-2);
    for i:=1 to ws1 do
      write(w1[i],' ');
    for i:=ws2-1 downto 2 do
      write(w2[i],' ');
    writeln;
  end;
  close(input);
  close(output);
end;

begin
  Load('birds.in','birds.out');
  Solve;
  Save;
end.
