#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define NN 110
#define eps 1e-7

struct POINT {
  double x, y;
  int i;
};

struct PP {
  POINT a;
  PP *nxt;
  PP *prv;
};

int _stklen = 4194304;

FILE *fi, *fo;
POINT a[NN];
POINT b[NN];
POINT res[NN];
PP *head;
int q;
int n,m;

int cmp(POINT a, POINT b)
{
  if((a.x-b.x)>eps) return 1;
  if((a.x-b.x)<-eps) return -1;
  if((a.y-b.y)>eps) return 1;
  if((a.y-b.y)<-eps) return -1;
  return 0;
}

void sift(int p, int q,POINT *a)
{
  int i,j;
  POINT x;
  i=p;
  x=a[i];
  j=2*i+1;
  if(j<q-1) if(cmp(a[j+1],a[j])>0) j++;
  if(j<q) if(cmp(x,a[j])>0) j=q+1;
  while(j<q)
  {
    a[i]=a[j];
    i=j;
    j=2*j+1;
    if(j<q-1) if(cmp(a[j+1],a[j])>0) j++;
    if(j<q) if(cmp(x,a[j])>0) j=q+1;
  }
  a[i]=x;
}

void Sort(int n, POINT *a)
{
  int i,j;
  POINT x;
  j=n;
  for(i=n/2+1;i>=0;i--)
    sift(i,j,a);
  i=0;
  for(j=n;j>1;j--)
  {
    x=a[0];
    a[0]=a[j-1];
    a[j-1]=x;
    sift(i,j-1,a);
  }
}

void Oboloch(POINT *a, int m)
{
  int i,j,k;
  double min;
  double alfa;
  q=1;
  res[0]=a[0];
  min=8.0;
  k=-1;
  for(i=1;i<m;i++)
  {
    alfa=atan2(a[i].y-a[0].y,a[i].x-a[0].x);
    if(alfa<min)
    {
      min=alfa;
      k=i;
    }
  }
  q=2;
  res[1]=a[k];
  while(true)
  {
    k=-1;
    min=32.0;
    for(i=0;i<m;i++)
    {
      if((cmp(res[q-1],a[i])!=0)&&(cmp(res[q-2],a[i])!=0))
      {
        alfa=atan2(a[i].y-res[q-1].y,a[i].x-res[q-1].x)-atan2(res[q-1].y-res[q-2].y,res[q-1].x-res[q-2].x);
        if(alfa<-M_PI+eps)
          alfa+=2.0*M_PI;
        if(alfa<min)
        {
          k=i;
          min=alfa;
        }
      }
    }
    if(k<=0)
      return ;
    res[q]=a[k];
    q++;
  }
}

double s(int n, POINT *a)
{
  double ss;
  int i;
  ss=0;
  for(i=0;i<n-1;i++)
  {
    ss+=(a[i].x+a[i+1].x)*(a[i].y-a[i+1].y)/2.0;
  }
  ss+=(a[n-1].x+a[0].x)*(a[n-1].y-a[0].y)/2.0;
  return fabs(ss);
}

double s(PP *head)
{
  POINT a[NN];
  PP *t;
  int n;
  if(head==NULL)
    return 0.0;
  n=1;
  t=head;
  t=t->nxt;
  a[0]=head->a;
  while(t!=head)
  {
    a[n]=t->a;
    t=t->nxt;
    n++;
  }
  return s(n,a);
}

double l(POINT a, POINT b)
{
  return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}

double s3(POINT a, POINT b, POINT c)
{
  double aa,bb,cc;
  double p;
  aa=l(b,c);
  bb=l(a,c);
  cc=l(a,b);
  p=(aa+bb+cc)/2.0;
  return sqrt(p*(p-aa)*(p-bb)*(p-cc));
}

void DelPP(PP *t)
{
  t->prv->nxt=t->nxt;
  t->nxt->prv=t->prv;
}

void run()
{
  PP *t;
  PP *r;
  PP *p;
  PP *tt;
  double ss,ss1;
  int q1,q2;
  int i;
  bool flag;
  ss=s(head);
  ss1=0.0;
  for(i=0;i<m;i++)
  {
    for(t=head->nxt;t!=head;t=t->nxt)
    {
      ss1+=s3(t->a,t->nxt->a,b[i]);
    }
    ss1+=s3(head->a,head->nxt->a,b[i]);
    if(fabs(ss1-ss)>eps)
    {
      b[i]=b[m-1];
      i--;
      m--;
    }
  }
  while(m>0)
  {
    flag=true;
    for(t=head->nxt;t!=head;t=t->nxt)
    {
      ss=s3(t->prv->a,t->a,t->nxt->a);
      ss1=s3(t->prv->a,t->a,b[0])+s3(t->prv->a,t->nxt->a,b[0])+s3(t->a,t->nxt->a,b[0]);
      if(fabs(ss1-ss)<eps)
      {
        flag=false;
        DelPP(t);
        q--;
        t=head->prv;
      }
    }
    if(flag)
    {
      t=head;
      ss=s3(t->prv->a,t->a,t->nxt->a);
      ss1=s3(t->prv->a,t->a,b[0])+s3(t->prv->a,t->nxt->a,b[0])+s3(t->a,t->nxt->a,b[0]);
      if(fabs(ss1-ss)<eps)
      {
        flag=false;
        DelPP(t);
        q--;
        t=head->prv;
      }
    }
    if(flag)
    {
      r=head;
      p=head->nxt;
      q1=2;
      for(t=p->nxt;t!=head;t=t->nxt)
      {
        ss=s3(r->a,p->a,t->a);
        ss1=s3(r->a,p->a,b[0])+s3(p->a,t->a,b[0])+s3(r->a,t->a,b[0]);
        if(fabs(ss1-ss)<eps)
        {
          flag=false;
          r->nxt=t;
          p->prv=t;
          tt=t->nxt;
          t->nxt=p;
          ss=s(p);
          t->nxt=tt;
          tt=t->prv;
          t->prv=r;
          ss1=s(r);
          if(ss>ss1)
          {
            t->prv=tt;
            t->nxt=p;
            head=p;
            q=q1;
          }
          else
          {
            q=q-q1+1;
          }
          t=head->prv;
        }
        q1++;
      }
    }
    if(q<3)
    {
      return ;
    }
    for(i=0;i<m;i++)
    {
      ss=s(head);
      ss1=0.0;
      for(t=head->nxt;t!=head;t=t->nxt)
      {
        ss1+=s3(t->a,t->nxt->a,b[i]);
      }
      ss1+=s3(head->a,head->nxt->a,b[i]);
      if(fabs(ss1-ss)>eps)
      {
        b[i]=b[m-1];
        i--;
        m--;
      }
    }
  }
}

void wr(PP *head)
{
  PP *t;
  fprintf(fo,"%i",head->a.i+1);
  for(t=head->nxt;t!=head;t=t->nxt)
    fprintf(fo," %i",t->a.i+1);
  fprintf(fo,"\n");
}

int main()
{
  int i,j;
  double ss;
  PP *t;
  fi=fopen("birds.in","rt");
  fo=fopen("birds.out","wt");

  fscanf(fi,"%i",&n);
  for(i=0;i<n;i++)
  {
    fscanf(fi,"%lf%lf",&a[i].x,&a[i].y);
    a[i].i=i;
  }
  fscanf(fi,"%i",&m);
  for(i=0;i<m;i++)
    fscanf(fi,"%lf%lf",&b[i].x,&b[i].y);

  Sort(n,a);
  Oboloch(a,n);

  ss=s(q,res);
  if(ss<eps)
  {
    fprintf(fo,"0\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }

  t=new PP;
  t->a=res[0];
  t->nxt=t;
  t->prv=t;
  head=t;
  for(i=1;i<q;i++)
  {
    t=new PP;
    t->a=res[i];
    t->nxt=head->nxt;
    t->prv=head;
    head->nxt=t;
    t->nxt->prv=t;
  }

  run();
  ss=s(head);
  if(ss<eps)
  {
    fprintf(fo,"0\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }

  fprintf(fo,"%i\n",q);
  wr(head);

  fclose(fi);
  fclose(fo);
  return 0;
}


