{$D-,L-,Q-,R-,S-,I-}
Program pr_a;
const
  inpfile='birds.in';
  outfile='birds.out';
  eps=1e-6;
  nm=205;
type
  Coord=record
    x,y : Extended;
    n : Integer;
  end;
var
  a,b,c,r : array [1..nm] of Coord;
  sb : array [1..nm] of Extended;
  rn : array [1..nm] of LongInt;
  n,m,k,cn,res : LongInt;
{}
Procedure Inp;
var
  i,j : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do begin
    read(a[i].x,a[i].y);
    a[i].n:=i;
  end;
  read(m);
  for i:=1 to m do begin
    read(b[i].x,b[i].y);
    b[i].n:=i;
  end;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  for i:=1 to res do write(rn[i],' ');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(r,sizeof(r),0);
  fillchar(rn,sizeof(rn),0);
  fillchar(sb,sizeof(sb),0);
  fillchar(b,sizeof(b),0);
end;
{}
Function Vc(a,b,c,d : Coord) : Extended;
begin
  Vc:=(b.x-a.x)*(d.y-c.y)-(d.x-c.x)*(b.y-a.y);
end;
{}
Function Sc(a,b,c,d : Coord) : Extended;
begin
  Sc:=(b.x-a.x)*(d.x-c.x)+(d.y-c.y)*(b.y-a.y);
end;
{}
Procedure Swap(var q,w : Coord);
var
  bak : Coord;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Function Eq(q,w : Coord) : Boolean;
begin
  if (abs(q.x-w.x)<eps) and (abs(q.y-w.y)<eps) then Eq:=true
                                               else Eq:=false;
end;
{}
Function Len(q,w : Coord) : Extended;
begin
  Len:=sqrt(sqr(q.x-w.x)+sqr(q.y-w.y));
end;
{}
Procedure Solve;
var
  i,j,t,min : LongInt;
  s,sn,smax : Extended;
  ok : Boolean;
begin
  r[1]:=a[1]; k:=1;
  for i:=1 to n do
    if (a[i].y+eps<r[1].y) or (abs(a[i].y-r[1].y)<eps)
    and (a[i].x-eps>r[1].x) then begin
      r[1]:=a[i];
      Swap(a[1],a[i]);
    end;

  repeat
    min:=2;
    for i:=1 to n do
      if (Vc(r[k],a[min],r[k],a[i])<-eps)
      or (abs(Vc(r[k],a[min],r[k],a[i]))<eps)
      and (Len(r[k],a[min])+eps<Len(r[k],a[i])) then min:=i;

    inc(k); r[k]:=a[min];
  until Eq(r[k],r[1]);
  dec(k);

  for i:=1 to k do r[i+k]:=r[i];

  s:=0;
  for i:=1 to k do
    s:=s+(r[i+1].y*r[i].x-r[i+1].x*r[i].y);
  s:=s/2;

  for i:=1 to k do begin
    for j:=1 to m do
      sb[j]:=sb[j]+abs(Vc(b[j],r[i],b[j],r[i+1]));
  end;

  for j:=1 to m do
      sb[j]:=sb[j]/2;

  cn:=0;
  for j:=1 to m do
    if abs(sb[j]-s)<eps then begin
      inc(cn); c[cn]:=b[j];
    end;

  if cn=0 then begin
    smax:=s; res:=k;
    for i:=1 to k do rn[i]:=r[i].n;
    Out;
  end;

  smax:=0;
  for i:=1 to k-2 do
    for j:=i+2 to k do begin
      if (i=1) and (j=k) then break;
      ok:=true;
      for t:=1 to cn do begin
        if Vc(r[i],r[j],r[i],c[t])<eps then begin
          ok:=false; break;
        end;
      end;
      if ok then begin
        sn:=0;
        for t:=i to j-1 do
          sn:=sn+(r[t+1].y*r[t].x-r[t+1].x*r[t].y);
          sn:=sn+r[i].y*r[j].x-r[i].x*r[j].y;
        sn:=sn/2;
        if sn-eps>smax then begin
          res:=j-i+1; smax:=sn;
          for t:=i to j do rn[t-i+1]:=r[t].n;
        end;
      end;
    end;

  for i:=1 to k-2 do
    for j:=i+2 to k do begin
      if (i=1) and (j=k) then break;
      ok:=true;
      for t:=1 to cn do begin
        if Vc(r[j],r[i],r[j],c[t])<eps then begin
          ok:=false; break;
        end;
      end;
      if ok then begin
        sn:=0;
        for t:=j to n+i-1 do
          sn:=sn+(r[t+1].y*r[t].x-r[t+1].x*r[t].y);
          sn:=sn+r[j].y*r[n+i].x-r[j].x*r[n+i].y;
        sn:=sn/2;
        if sn-eps>smax then begin
          res:=n-j+i+1; smax:=sn;
          for t:=j to n+i do rn[t-j+1]:=r[t].n;
        end;
      end;
    end;

end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
