{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65520,0,655360}
Const maxn = 105;

Type Rec = Record
            n: Integer;
            k: Extended;
            e: Boolean;
           End;
     Point = Record
              x, y: Integer;
             End;

Var i, j, n, m, t, k, kmax, first, last: Integer;
    smax, l, lmin: Extended;
    p, pmax: array[0..maxn] of Integer;
    r: array[1..maxn] of Rec;
    a, b, af: array[1..maxn] of Point;

Procedure Swap(var a, b: Point);
 Var c: Point;
 Begin
  c := a;
  a := b;
  b := c;
 End;

Procedure HoarA(left, right: Integer);
 Var i, j, c: Integer;
 Begin
  i := left;
  j := right;
  c := a[Random(j - i + 1) + i].y;
  While i < j do
   Begin
    While a[i].y < c do Inc(i);
    While a[j].y > c do Dec(j);
    If i <= j Then
     Begin
      Swap(a[i], a[j]);
      Inc(i);
      Dec(j);
     End;
   End;
  If j > left Then HoarA(left, j);
  If i < right Then HoarA(i, right);
 End;

Procedure HoarB(left, right: Integer);
 Var i, j, c: Integer;
 Begin
  i := left;
  j := right;
  c := b[Random(j - i + 1) + i].y;
  While i < j do
   Begin
    While b[i].y < c do Inc(i);
    While b[j].y > c do Dec(j);
    If i <= j Then
     Begin
      Swap(b[i], b[j]);
      Inc(i);
      Dec(j);
     End;
   End;
  If j > left Then HoarB(left, j);
  If i < right Then HoarB(i, right);
 End;

Function Len(x, y: Point): Extended;
 Begin
  Len := Sqrt(Sqr(x.x - y.x) + Sqr(x.y - y.y));
 End;

Function Angle(a, b: Point): Extended;
 Var s: Extended;
 Begin
  s := (b.y - a.y) / Len(a, b);
  If b.x > a.x Then Angle := s
               Else Angle := 2 - s;
 End;

Procedure HoarR(left, right: Integer);
 Var i, j: Integer;
     c: Extended;
 Procedure Swap(var a, b: Rec);
  Var c: Rec;
  Begin
   c := a;
   a := b;
   b := c;
  End;
 Begin
  i := left;
  j := right;
  c := r[Random(j - i + 1) + i].k;
  While i < j do
   Begin
    While r[i].k < c do Inc(i);
    While r[j].k > c do Dec(j);
    If i <= j Then
     Begin
      Swap(r[i], r[j]);
      Inc(i);
      Dec(j);
     End;
   End;
  If j > left Then HoarR(left, j);
  If i < right Then HoarR(i, right);
 End;

Function VectMul(x1, y1, x2, y2: Extended): Extended;
 Begin
  VectMul := x1 * y2 - x2 * y1;
 End;

Procedure Check(k: Integer);
 Var i: Integer;
     s0: Extended;
 Begin
  s0 := a[r[p[0]].n].x * a[r[p[k]].n].y - a[r[p[k]].n].x * a[r[p[0]].n].y;
  For i := 0 to k - 1 do
   s0 := s0 + a[r[p[i + 1]].n].x * a[r[p[i]].n].y - a[r[p[i]].n].x * a[r[p[i + 1]].n].y;
  s0 := Abs(s0 / 2);
  If s0 > smax Then
   Begin
    smax := s0;
    For i := 0 to k do
     pmax[i] :=r[p[i]].n;
    kmax := k;
   End;
 End;

Procedure Poisk(k: Integer);
 Var i: Integer;
 Function Right: Boolean;
  Var x, y, z: Point;
  Begin
   If r[p[k - 2]].e Then x := a[r[p[k - 2]].n]
                    Else x := b[r[p[k - 2]].n];
   If r[p[k - 1]].e Then y := a[r[p[k - 1]].n]
                    Else y := b[r[p[k - 1]].n];
   If r[i].e Then z := a[r[i].n]
             Else z := b[r[i].n];
   If VectMul(y.x - x.x, y.y - x.y, z.x - y.x, z.y - y.y) > 0
    Then Right := True
    Else Right := False;
  End;
 Begin
  If r[p[k - 1]].e and (k > 2) Then Check(k - 1);
  For i := p[k - 1] + 1 to last do
   If Right Then
    If r[p[k - 1]].e
     Then
      Begin
       p[k] := i;
       Poisk(k + 1);
       If not r[i].e Then Break;
      End
     Else
      Begin
       p[k - 1] := i;
       Poisk(k);
      End;
 End;

Procedure CountFirstLast;
 Var i, f1, l1: Integer;
 Begin
  f1 := 1;
  lmin := 1e10;
  While (f1 <= t) and (r[f1].k = r[1].k) do
   Begin
    If not r[f1].e Then
     Begin
      l := Len(a[r[1].n], b[r[f1].n]);
      If l < lmin Then lmin := l;
     End;
    Inc(f1);
   End;
  first := 2;
  If f1 < t Then
   For i := 2 to f1 do
    If r[i].e and (Len(a[r[i].n], a[r[1].n]) >= lmin) Then first := f1;
  l1:= t;
  lmin := 1e10;
  While (l1 >= 1) and (r[l1].k = r[t].k) do
   Begin
    If not r[l1].e Then
     Begin
      l := Len(a[r[1].n], b[r[l1].n]);
      If l < lmin Then lmin := l;
     End;
    Dec(l1);
   End;
  last := t - 1;
  If l1 > 0 Then
   For i := t - 1 downto l1 do
    If r[i].e and (Len(a[r[i].n], a[r[1].n]) >= lmin) Then last := l1;
 End;

Begin
 Assign(input, 'birds.in');
 Assign(output, 'birds.out');
 Reset(input);
 Rewrite(output);
 Read(n);
 For i := 1 to n do
  Read(a[i].x, a[i].y);
 Read(m);
 For i := 1 to m do
  Read(b[i].x, b[i].y);
 af := a;
 HoarA(1, n);
 HoarB(1, m);
 k := 1;
 For i := 1 to n do
  Begin
   r[1].n := i;
   r[1].e := True;
   t := 1;
   For j := i + 1 to n do
    Begin
     Inc(t);
     r[t].n := j;
     r[t].k := Angle(a[i], a[j]);
     r[t].e := True;
    End;
   While (k <= m) and (b[k].y < a[i].y) do Inc(k);
   For j := k to m do
    Begin
     Inc(t);
     r[t].n := j;
     r[t].k := Angle(a[i], b[j]);
     r[t].e := False;
    End;
   HoarR(2, t);
   p[0] := 1;
   CountFirstLast;
   For j := first to last do
    Begin
     p[1] := j;
     If r[j].e Then Poisk(2);
    End;
  End;
 If smax > 0
  Then
   Begin
    Writeln(kmax + 1);
    For i := 0 to kmax do
     For j := 1 to n do
      If (af[j].x = a[pmax[i]].x) and (af[j].y = a[pmax[i]].y) Then
       Write(j, ' ');
   End
  Else
   Write('0');
 Close(input);
 Close(output);
End.