#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

class TPermut {
  private:
    short n,N,m;
    int c;
    short*a,*b,*D,**d;
    char*p;
    void insert0(short*,short);
    void insert1(short*,short,short);
    void extract0(short*,short);
    void extract1(short*,short,short);
    void extractparts(short*,short,short,short);
    void extractwhols(short*,short,short,short);
    short seekgrparts(short*,short,short);
    int find(short*,short,int);
  public:
    TPermut(void);
    ~TPermut();
    void Delete(void);
    void scan(FILE*);
    void print(FILE*);
    void process(void);
};

TPermut g;

int main(void) {
  fi=fopen("in.in","rt");
  g.scan(fi);
  fclose(fi);
  g.process();
  fo=fopen("in.out","wt");
  g.print(fo);
  fclose(fo);
  return(0);
}


void TPermut::insert0(short*e,short k) {
  short i,j;
  e[0]=0;
  for (i=1,j=0; i<k; i++,j++) e[i]=d[m][j]+1;
}
void TPermut::insert1(short*e,short k,short l) {
  short i,j;
  e[0]=l; e[l]=0;
  for (i=1,j=0; i<l; i++,j++) e[i]=d[m][j]+((d[m][j]+1<l)?1:2);
  for (i++; i<k; i++,j++) e[i]=d[m][j]+((d[m][j]+1<l)?1:2);
}
void TPermut::extract0(short*e,short k) {
  short i,j;
  for (i=1,j=0; i<k; i++,j++) d[m][j]=e[i]-1;
}
void TPermut::extract1(short*e,short k,short l) {
  short i,j;
  for (i=1,j=0; i<l; i++,j++) d[m][j]=e[i]-((e[i]<=l)?1:2);
  for (i++; i<k; i++,j++) d[m][j]=e[i]-((e[i]<=l)?1:2);
}
void TPermut::extractparts(short*e,short k,short l,short z) {
  short i,j;
  memset(p,0,k*sizeof(char)); p[0]=1; p[l]=1;
  for (i=1,j=0; i<z; i++,j++) {
    d[m][j]=e[i]-((e[i]<=l)?1:2);
    p[e[i]]=1;
  }
}
void TPermut::extractwhols(short*,short k,short l,short z) {
  short i,j,y;
  y=0;
  for (i=z,j=z-1; i<l; i++,j++) {
    for (y++; p[y]; y++);
    d[m][j]=y-((y<=l)?1:2);
  }
  for (i++; i<k; i++,j++) {
    for (y++; p[y]; y++);
    d[m][j]=y-((y<=l)?1:2);
  }
}
short TPermut::seekgrparts(short*e,short k,short l) {
  short i,y;
  for (i=l-1; i>=1; i--) {
    p[e[i]]=0;
    for (y=e[i]+1; y<k; y++) if (!p[y]) return(i);
  }
  return(0);
}
int TPermut::find(short*e,short k,int o) {
  if (k<=1) return(!o);
  int z; short i,j,l;
  if (e[0]<=0) {
    extract0(e,k);
    m++; z=find(d[m-1],k-1,o); m--;
    if (z) { insert0(e,k); return(1); }
  } else {
    for (l=1; l<k; l++) if (e[l]<=0) break;
    if (l==e[0]) {
      extract1(e,k,e[0]);
      m++; z=find(d[m-1],k-2,o); m--;
      if (z) { insert1(e,k,e[0]); return(1); }
    } else if (l>e[0]) {
      extractparts(e,k,e[0],e[0]);
      j=seekgrparts(e,k,e[0]);
      if (j>0) {
        for (i=e[j]+1; i<k; i++) if (!p[i]) break;
        d[m][j-1]=i-((i<=e[0])?1:2); p[i]=1;
        extractwhols(e,k,e[0],j+1);
        m++; z=find(d[m-1],k-2,0); m--;
        if (z) { insert1(e,k,e[0]); return(1); }
      }
    } else if (l<e[0]) {
      extractparts(e,k,e[0],l);
      extractwhols(e,k,e[0],l);
      m++; z=find(d[m-1],k-2,0); m--;
      if (z) { insert1(e,k,e[0]); return(1); }
    }
  }
  if (e[0]+1<k) {
    for (i=0; i<k-2; i++) d[m][i]=i;
    insert1(e,k,e[0]+1);
    return(1);
  }
  return(0);
}
void TPermut::process(void) {
  memcpy(b,a,n*sizeof(short)); m=0;
  c=find(b,n,1);
}

TPermut::TPermut(void) {
  a=0; b=0;
  D=0; d=0;
  p=0;
}
TPermut::~TPermut() {
  Delete();
}
void TPermut::Delete(void) {
  if (a) delete[]a; if (b) delete[]b;
  if (D) delete[]D; if (d) delete[]d;
  if (p) delete[]p;
}
void TPermut::scan(FILE*f) {
  Delete();
  short i,j;
  fscanf(f,"%hd",&n);
  a=new short[n];
  for (i=0; i<n; i++) { fscanf(f,"%hd",&a[i]); a[i]--; }
  b=new short[n];
  N=n*n;
  D=new short[N]; d=new short*[n];
  for (i=0,j=0; i<n; i++,j+=n) d[i]=&D[j];
  p=new char[n];
}
void TPermut::print(FILE*f) {
  short i;
  if (c) {
    fprintf(f,"%hd\n",n);
    for (i=0; i<n; i++) {
      if (i) fprintf(f," ");
      fprintf(f,"%hd",b[i]+1);
    }
  } else fprintf(f,"0");
}


