program Road;
{$N+}
const
  MAXN = 3000; {3000}

var
  n : integer;
  g : array [1..MAXN,1..MAXN] of boolean;
  x, y : array [1..MAXN] of longint;
  p : array [1..MAXN] of integer;

procedure Load(infile, outfile : string);
var
  m, i, a, b : longint;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n,m);
  fillchar(g,sizeof(g),0);
  for i:=1 to n do
    read(x[i],y[i]);
  for i:=1 to m do
  begin
    read(a,b);
    g[a,b] := true;
    g[b,a] := true;
  end;
end;

function ro(a, b : integer) : extended;
begin
  if g[a,b] then
    ro := 0
  else
    ro := sqrt(sqr(x[a]-x[b]) + sqr(y[a]-y[b]));
end;

procedure Solve;
var
  c, i, j : integer;
  used : array [1..MAXN] of boolean;
  d : array [1..MAXN] of extended;
  d2 : array [1..MAXN] of integer;
  ro2 : extended;
begin
  fillchar(used,sizeof(used),0);
  used[1] := true;
  for i:=2 to n do
  begin
    d[i] := ro(1,i);
    d2[i] := 1;
  end;
  for i:=2 to n do
  begin
    c := 0;
    for j:=1 to n do
      if (not used[j]) and ((c=0) or (d[c]>d[j])) then
        c := j;
    used[c] := true;
    p[c] := d2[c];
    for j:=1 to n do
    begin
      ro2 := ro(c,j);
      if (not used[j]) and (d[j]>ro2) then
      begin
        d[j] := ro2;
        d2[j] := c;
      end;
    end;
  end;
end;

procedure Save;
var
  k : longint;
  i : integer;
begin
  k := 0;
  for i:=2 to n do
    if not g[i,p[i]] then
      inc(k);
  writeln(k);
  for i:=2 to n do
    if not g[i,p[i]] then
      writeln(i,' ',p[i]);
  close(input);
  close(output);
end;

begin
  Load('road.in','road.out');
  Solve;
  Save;
end.