#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define NN 3100

struct POINT {
  double x,y;
};

struct IPOINT {
  short x,y;
};

FILE *fi, *fo;
POINT g[NN];
bool **rd;  //[NN][NN];
int mark[NN];
int q;
bool used[NN];
IPOINT *h; //[NN*NN+10];
int hSize;
int n,m;

double l(POINT a, POINT b)
{
  return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}

double ll(IPOINT a)
{
  return l(g[a.x],g[a.y]);
}

void init()
{
  int i,j;
  rd=new bool *[n];
  for(i=0;i<n;i++)
    rd[i]=new bool [n];
  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
    {
      rd[i][j]=false;
    }
    mark[i]=0;
    used[i]=false;
  }
}

void dfs(int v, int q)
{
  int i;
  mark[v]=q;
  for(i=0;i<n;i++)
    if(rd[v][i])
      if(!mark[i])
        dfs(i,q);
}

void sift(int p, int q)
{
  int i,j;
  IPOINT x;
  i=p;
  x=h[p];
  j=2*i+1;
  if(j<q-1) if(ll(h[j+1])<ll(h[j])) j++;
  if(j<q) if(ll(h[j])>ll(x)) j=q+1;
  while(j<q)
  {
    h[i]=h[j];
    i=j;
    j=2*i+1;
    if(j<q-1) if(ll(h[j+1])<ll(h[j])) j++;
    if(j<q) if(ll(h[j])>ll(x)) j=q+1;
  }
  h[i]=x;
}

void Add(IPOINT a)
{
  h[hSize]=a;
  hSize++;
}

void Build()
{
  int i;
  for(i=hSize/2+1;i>=0;i--)
    sift(i,hSize);
}

void Get(IPOINT *a)
{
  *a=h[0];
  hSize--;
  h[0]=h[hSize];
  sift(0,hSize);
}

int main()
{
  int i,j;
  int x,y;
  IPOINT t;
  fi=fopen("road.in","rt");
  fo=fopen("road.out","wt");

  fscanf(fi,"%i%i",&n,&m);
  init();
  for(i=0;i<n;i++)
    fscanf(fi,"%lf%lf",&g[i].x,&g[i].y);
  for(i=0;i<m;i++)
  {
    fscanf(fi,"%i%i",&x,&y);
    x--;
    y--;
    rd[x][y]=true;
    rd[y][x]=true;
  }
  q=0;
  for(i=0;i<n;i++)
  {
    if(!mark[i])
    {
      q++;
      dfs(i,q);
    }
  }
  fprintf(fo,"%i\n",q-1);
  for(i=0;i<n;i++)
    delete(rd[i]);
  delete(rd);
  h=new IPOINT [n*(n-1)/2+5];
  hSize=0;

  for(i=0;i<n;i++)
  {
    for(j=i+1;j<n;j++)
    {
      if(mark[i]!=mark[j])
      {
        t.x=i;
        t.y=j;
        Add(t);
      }
    }
  }

  Build();

  while(q>1)
  {
    Get(&t);
    if(mark[t.x]!=mark[t.y])
    {
      q--;
      fprintf(fo,"%i %i\n",t.x+1,t.y+1);
      x=mark[t.x];
      y=mark[t.y];
      for(i=0;i<n;i++)
        if(mark[i]==x)
          mark[i]=y;
    }
  }
  delete(h);

  fclose(fi);
  fclose(fo);
  return 0;
}
