program roads;

const
  inf = 1E10;
  maxn = 3000;
type
  real = double;
  point = record
   x,y: real;
  end;
var
  a: array[1..maxn] of point;
  link,col: array[1..maxn] of longint;
  cn,i,j,t,k,n,num,m: longint;
  min: real;
  used,vis: array[1..maxn] of boolean;
  best: array[1..maxn] of double;
  g: array[1..maxn,1..maxn] of boolean;
function d(p1,p2: point): double;
begin
  d := sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y));
end;
procedure dfs(v: longint);
var i: longint;
begin
  vis[v] := true;
  for i := 1 to n do begin
    if g[v,i] and not vis[i] then begin
      col[i] := col[v];
      dfs(i);
    end;
  end;
end;
procedure repaint(cn,cm: longint);
var i,j: longint;
begin
  for i := 1 to n do begin
    if col[i] = cm then begin
      col[i] := cn;
      for j := 1 to n do begin
        if (col[j] <> cn) and (col[j] <> cm) then begin
          if d(a[i],a[j]) < best[j] then begin
            best[j] := d(a[i],a[j]);
            link[j] := i;
          end;
        end;
      end;
    end;
  end;
end;
begin
  assign(input,'road.in'); reset(input);
  assign(output,'road.out'); rewrite(output);
  read(n,m);
  for i := 1 to n do read(a[i].x,a[i].y);
  for i := 1 to m do begin
    read(k,t);
    g[k,t] := true;
    g[t,k] := true;
  end;
  for i := 1 to n do best[i] := inf;
  for i := 1 to n do begin
    if not vis[i] then begin
      inc(cn); col[i] := cn;
      dfs(i);
    end;
  end;
  for i := 1 to n do if col[i] = 1 then begin
    used[i] := true;
    best[i] := 0;
    for j := 1 to n do begin
      if col[j] <> 1 then begin
        if d(a[i],a[j]) < best[j] then begin
          best[j] := d(a[i],a[j]);
          link[j] := i;
        end;
      end;
    end;
  end;
  writeln(cn-1);
  for i := 1 to cn-1 do begin
    min := inf;
    for j := 1 to n do begin
      if (best[j] < min) and (col[j]<>1) then begin
        min := best[j];
        num := j;
      end;
    end;
    writeln(link[num],' ',num);
    repaint(1,col[num]);
  end;
  close(output);
  close(input);
end.
