{$I-,Q-,R-,S-}
Program Roads;

const
  MaxN = 3005;
  MaxM = MaxN*MaxN;

type
  Ttown = record
    x,y: Longint;
    el,en: integer;
  end;
  Troad = array[1..2] of integer;

var
  N,M: integer;
  ts: array[1..MaxN] of Ttown;
  mark: array[1..MaxN] of integer;
  rs: array[1..MaxM] of Troad;
  dists: array[1..MaxN,1..MaxN] of double;
  rts: array[1..MaxN,1..MaxN] of integer;

procedure DFS(v,id: integer);
var st: array[1..MaxN] of integer;
    sp,i: longint;
begin
  st[1]:=v;
  sp:=1; mark[v]:=id;
  while sp>0 do begin
    v:=st[sp]; dec(sp);
    For i:=ts[v].el to ts[v].el+ts[v].en-1 do
      if mark[rs[i,2]]=0 then begin
        mark[rs[i,2]]:=id;
        inc(sp); st[sp]:=rs[i,2];
      end;
  end;
end;

function dist(a,b: integer):double;
var dx,dy: longint;
begin
  dx:=ts[a].x-ts[b].x;
  dy:=ts[a].y-ts[b].y;
  dist:=sqrt(dx*dx+dy*dy);
end;

var cds: array[1..MaxN] of double;
    cprev: array[1..MaxN] of integer;
    cmark: array[1..MaxN] of byte;
    crds: array[1..MaxN] of Troad;
    crn: integer;

procedure Solve;
var i,j,k: longint;
    t: double;
begin
  k:=0;
  For i:=1 to N do
    if mark[i]=0 then begin
      inc(k);
      DFS(i,k);
    end;
  For i:=1 to k do
    For j:=1 to k do
      dists[i,j]:=1e+99;
  For i:=1 to N-1 do
    For j:=i+1 to N do begin
      t:=dist(i,j);
      if t<dists[mark[i],mark[j]] then begin
        dists[mark[i],mark[j]]:=t;
        dists[mark[j],mark[i]]:=t;
        rts[mark[i],mark[j]]:=i;
        rts[mark[j],mark[i]]:=j;
      end;
    end;

  cds[1]:=0;
  For i:=2 to k do
    cds[i]:=1e+99;
  crn:=0;
  while true do begin
    j:=0;
    For i:=1 to k do
      if ((j=0) or (cds[i]<cds[j])) and (cmark[i]=0) then j:=i;
    if j=0 then break;
    cmark[j]:=1;
    if cprev[j]<>0 then begin
      inc(crn);
      crds[crn,1]:=cprev[j]; crds[crn,2]:=j;
    end;
    For i:=1 to k do
      if cmark[i]=0 then
        if dists[j,i]<cds[i] then begin
          cds[i]:=dists[j,i]; cprev[i]:=j;
        end;
  end;

  For i:=1 to crn do begin
    j:=crds[i,1]; k:=crds[i,2];
    crds[i,1]:=rts[j,k];
    crds[i,2]:=rts[k,j];
  end;
end;

procedure Save;
var f: text;
    i: integer;
begin
  Assign(f,'road.out');
  Rewrite(f);
  WriteLn(f,crn);
  For i:=1 to crn do begin
    WriteLn(f,crds[i,1],' ',crds[i,2]);
  end;
  Close(f);
end;

procedure sort(l,r: longint);
  var
     i,j: longint;
     x: integer;
     y: Troad;
  begin
     i:=l;
     j:=r;
     x:=rs[(l+r) div 2,1];
     repeat
       while rs[i,1]<x do
        inc(i);
       while x<rs[j,1] do
        dec(j);
       if not(i>j) then
         begin
            y:=rs[i];
            rs[i]:=rs[j];
            rs[j]:=y;
            inc(i);
            j:=j-1;
         end;
     until i>j;
     if l<j then
       sort(l,j);
     if i<r then
       sort(i,r);
  end;


procedure Load;
var f: text;
    i,k,a,b: longint;
begin
  Assign(f,'road.in');
  Reset(f);
  Read(f,N,k);
  For i:=1 to N do
    Read(f,ts[i].x,ts[i].y);
  M:=0;
  For i:=1 to k do begin
    Read(f,a,b);
    inc(M);
    rs[M,1]:=a; rs[M,2]:=b;
    inc(M);
    rs[M,1]:=b; rs[M,2]:=a;
  end;
  Close(f);
  sort(1,M);
  For i:=1 to M do begin
    if ts[rs[i,1]].el=0 then ts[rs[i,1]].el:=i;
    inc(ts[rs[i,1]].en);
  end;
end;


Begin
  Load;
  Solve;
  Save;
End.
