{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 3010;
 inf = 2000000000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'road.in';
 coutfile= 'road.out';
 {$endif}
type
 int = longint;
 real = extended;
 tpoint = record
  x,y :int;
 end;
var
 n,m :int;
 p :array [0..nmax] of tpoint;
 gr :array [1..nmax,1..nmax] of boolean;
 pnt :array [1..nmax] of int;
 k :int;
 used :array [1..nmax] of boolean;
 d :array [1..nmax] of int;
 prev :array [1..nmax] of int;
 road :array [1..nmax] of tpoint;
 ans :int;

procedure init;
begin
 ans := 0;
 fillchar (p,sizeof(p),0);
 fillchar (gr,sizeof(gr),0);
 fillchar (used,sizeof(used),0);
 fillchar (pnt,sizeof(pnt),0);
 fillchar (prev,sizeof(prev),0);
 fillchar (road,sizeof(road),0);
 k := 0;
end;

procedure readdata;
var i,j :int;
    u,v :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n,m);
 for i := 1 to n do
  read (p[i].x,p[i].y);
 for i := 1 to m do
  begin
   read (u,v);
   gr[u,v] := true;
   gr[v,u] := true;
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (k-1);
 for i := 2 to k do
  writeln (road[i].x,' ',road[i].y);
 close (output);
end;

procedure dfs (v :int);
var i :int;
begin
 if used[v] then
  exit;
 used[v] := true;
 pnt[v] := k;
 for i := 1 to n do
  if gr[v,i] then
   dfs(i);
end;

function len (a,b :tpoint):int;
begin
 len := sqr(a.x - b.x) + sqr(a.y - b.y);
end;

procedure solve;
var i,j,u :int;
    cur :int;
    res :int;
    t :int;
begin
 for i := 1 to n do
  if not used[i] then
   begin
    inc(k);
    dfs(i);
   end;
 d[1] := 0;
 for i := 2 to k do
  d[i] := inf;
 fillchar (used,sizeof(used),0);
 for i := 1 to k do
  begin
   cur := 0;
   res := inf;
   for j := 1 to k do
    if not used[j] then
     if d[j] < res then
      begin
       res := d[j];
       cur := j;
      end;
   if cur = 0 then
    break;
   used[cur] := true;
   for j := 1 to n do
    if pnt[j] = cur then
     for u := 1 to n do
      if not (pnt[u] = cur) and not used[pnt[u]] then
       begin
        t := len (p[j],p[u]);
        if t < d[pnt[u]] then
         begin
          d[pnt[u]] := t;
          prev[pnt[u]] := cur;
          road[pnt[u]].x := j;
          road[pnt[u]].y := u;
         end;
       end;
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.