{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

const infile = 'convexh.in'; outfile = 'convexh.out';
      maxn = 2005; eps = 0.0000001; maxm = 2*maxn;
type pt = record x,y: extended; end;
type line = record a,b,c: extended; end;
var l: array [1..maxn] of line;
    d,c: array [1..maxm] of pt;
    t: array [1..maxn] of pt;
    n,k,m,cm,f: longint;
    s: extended;

procedure ptline(p1,p2: pt; var q: line);
begin
     q.a:=p2.y-p1.y; q.b:=p1.x-p2.x;
     q.c:=-(q.a*p1.x+q.b*p1.y);
end;

procedure find_peres(l1,l2: line; var e: pt);
var z: extended;
begin
     z:=l1.a*l2.b-l1.b*l2.a;
     e.x:=-(l1.c*l2.b-l1.b*l2.c)/z;
     e.y:=(l2.a*l1.c-l1.a*l2.c)/z;
end;

procedure init;
var i: longint;
    p1,p2: pt;
begin
     assign(input,infile);
     reset(input);
     read(n);
     for i:=1 to n do begin
         read(p1.x,p1.y,p2.x,p2.y);
         ptline(p1,p2,l[i]);
     end;
     close(input);
end;

function eq_pt(p1,p2: pt): boolean;
begin
     eq_pt:=(abs(p1.x-p2.x) < eps)and(abs(p1.y-p2.y) < eps);
end;

procedure add_x;
var t1,t2,i: longint;
begin
     t1:=1; t2:=1;
     for i:=2 to k do begin
         if t[i].x-t[t1].x > eps then t1:=i;
         if t[t2].x-t[i].x > eps then t2:=i;
     end;
     inc(m); d[m]:=t[t1];
     if not eq_pt(t[t1],t[t2]) then inc(m); d[m]:=t[t2];
end;

procedure add_y;
var t1,t2,i: longint;
begin
     t1:=1; t2:=1;
     for i:=2 to k do begin
         if t[i].y-t[t1].y > eps then t1:=i;
         if t[t2].y-t[i].y > eps then t2:=i;
     end;
     inc(m); d[m]:=t[t1];
     if not eq_pt(t[t1],t[t2]) then inc(m); d[m]:=t[t2];
end;

procedure find_f;
var i: longint;
begin
     f:=1;
     for i:=2 to m do
         if (d[i].x-d[f].x <-eps)or((abs(d[i].x-d[f].x) < eps)and
            (d[i].y-d[f].y <-eps)) then f:=i;
end;

function st(p1,p2,p3: pt): extended;
begin
     st:=p1.x*p2.y-p2.x*p1.y+p2.x*p3.y-p3.x*p2.y+p3.x*p1.y-p1.x*p3.y;
end;

function dist(p1,p2: pt): extended;
begin
     dist:=sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
end;

procedure convex;
var nnew: array [1..maxm] of longint;
    i,h: longint;
begin
     find_f; cm:=1; c[1]:=d[f];
     fillchar(nnew,SizeOF(nnew),0);
     repeat
           h:=1;
           while (h <= m)and(nnew[h] = 1) do inc(h);
           for i:=1 to m do
               if ((st(c[cm],d[h],d[i]) < -eps)or((abs(st(c[cm],d[h],d[i])) < eps)and
                  (dist(c[cm],d[i])-dist(c[cm],d[h]) > eps)))and(nnew[i] = 0) then h:=i;
           inc(cm); c[cm]:=d[h]; nnew[h]:=1;
     until h = f;
     dec(cm);
end;

procedure find_s;
var i: longint;
begin
     s:=0;
     for i:=1 to cm do begin
         s:=s+c[i].x*c[i mod cm+1].y-c[i].y*c[i mod cm+1].x;
     end;
     s:=abs(s/2);
end;

procedure solve;
var i,j: longint;
    e: pt;
begin
     m:=0;
     for i:=2 to n do begin
         k:=i-1;
         for j:=1 to i-1 do find_peres(l[i],l[j],t[j]);
         if l[i].a = 0 then add_x
            else add_y;
     end;
     convex; find_s;
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     write(s:0:5);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
