#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define NN 2100
#define eps 1e-7

struct POINT {
  double x, y;
};

struct LINE {
  double a,b,c;
};

FILE *fi, *fo;
POINT a[2*NN+10];
int n,m;
POINT res[2*NN+5];
int q;
LINE b[NN];
POINT d[NN];

void GetPeres(LINE a, LINE b, POINT *p)
{
  LINE tmp;
  if(fabs(a.b)<fabs(b.b))
  {
    tmp=a;
    a=b;
    b=tmp;
  }
  p->x=(b.b*a.c-b.c*a.b)/(b.a*a.b-a.a*b.b);
  p->y=-(a.a*p->x+a.c)/a.b;
}

int cmp(POINT a, POINT b)
{
  if((a.x-b.x)>eps) return 1;
  if((a.x-b.x)<-eps) return -1;
  if((a.y-b.y)>eps) return 1;
  if((a.y-b.y)<-eps) return -1;
  return 0;
}

void sift(int p, int q,POINT *a)
{
  int i,j;
  POINT x;
  i=p;
  x=a[i];
  j=2*i+1;
  if(j<q-1) if(cmp(a[j+1],a[j])>0) j++;
  if(j<q) if(cmp(x,a[j])>0) j=q+1;
  while(j<q)
  {
    a[i]=a[j];
    i=j;
    j=2*j+1;
    if(j<q-1) if(cmp(a[j+1],a[j])>0) j++;
    if(j<q) if(cmp(x,a[j])>0) j=q+1;
  }
  a[i]=x;
}

void Sort(int n, POINT *a)
{
  int i,j;
  POINT x;
  j=n;
  for(i=n/2+1;i>=0;i--)
    sift(i,j,a);
  i=0;
  for(j=n;j>1;j--)
  {
    x=a[0];
    a[0]=a[j-1];
    a[j-1]=x;
    sift(i,j-1,a);
  }
}

void Oboloch()
{
  int i,j,k;
  double min;
  double alfa;
  q=1;
  res[0]=a[0];
  min=8.0;
  k=-1;
  for(i=1;i<m;i++)
  {
    alfa=atan2(a[i].y-a[0].y,a[i].x-a[0].x);
    if(alfa<min)
    {
      min=alfa;
      k=i;
    }
  }
  q=2;
  res[1]=a[k];
  while(true)
  {
    k=-1;
    min=32.0;
    for(i=0;i<m;i++)
    {
      if((cmp(res[q-1],a[i])!=0)&&(cmp(res[q-2],a[i])!=0))
      {
        alfa=atan2(a[i].y-res[q-1].y,a[i].x-res[q-1].x)-atan2(res[q-1].y-res[q-2].y,res[q-1].x-res[q-2].x);
        if(alfa<-M_PI+eps)
          alfa+=2.0*M_PI;
        if(alfa<min)
        {
          k=i;
          min=alfa;
        }
      }
    }
    if(k<=0)
      return ;
    res[q]=a[k];
    q++;
  }
}

double s(int n, POINT *a)
{
  double ss;
  int i;
  ss=0;
  for(i=0;i<n-1;i++)
  {
    ss+=(a[i].x+a[i+1].x)*(a[i].y-a[i+1].y)/2.0;
  }
  ss+=(a[n-1].x+a[0].x)*(a[n-1].y-a[0].y)/2.0;
  return fabs(ss);
}

int main()
{
  int i,j;
  POINT aa,bb;
  fi=fopen("convexh.in","rt");
  fo=fopen("convexh.out","wt");

  fscanf(fi,"%i",&n);
  if(n<=2)
  {
    fprintf(fo,"0.00\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }
  
  for(i=0;i<n;i++)
  {
    fscanf(fi,"%lf%lf%lf%lf",&aa.x,&aa.y,&bb.x,&bb.y);
    b[i].a=bb.y-aa.y;
    b[i].b=aa.x-bb.x;
    b[i].c=aa.y*bb.x-aa.x*bb.y;
  }

  m=0;
  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
    {
      if(j<i)
        GetPeres(b[i],b[j],&d[j]);
      if(j>i)
        GetPeres(b[i],b[j],&d[j-1]);
    }
    Sort(n-1,d);
    m+=2;
    a[m-2]=d[0];
    a[m-1]=d[n-2];
  }
  
  Sort(m,a);
/*  for(i=0;i<m;i+=2)
  {
    a[i/2]=a[i];
  }
  m/=2;*/
  
  Oboloch();

  fprintf(fo,"%0.2lf\n",s(q,res));
  
  fclose(fi);
  fclose(fo);
  return 0;
}
