{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 2010;
 eps = 1e-9;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'convexh.in';
 coutfile= 'convexh.out';
 {$endif}
type
 int = longint;
 real = extended;
 tl = record
  x0,y0 :int;
  dx,dy :int;
 end;
 tpoint = record
  x,y :real;
 end;
 tmatrix = array [1..2,1..3] of real;
var
 n,m :int;
 l :array [1..nmax] of tl;
 p :array [1..2*nmax] of tpoint;
 s :array [1..2*nmax] of int;
 k :int;
 ans :real;

procedure init;
begin
 randseed := 37853;
 randseed := random(31561);
 ans := 0;
 fillchar (l,sizeof(l),0);
 fillchar (p,sizeof(p),0);
 fillchar (s,sizeof(s),0);
 k := 0;
 m := 0;
end;

procedure readdata;
var i,j :int;
    x,y :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n);
 for i := 1 to n do
  begin
   read (l[i].x0,l[i].y0);
   read (x,y);
   l[i].dx := x - l[i].x0;
   l[i].dy := y - l[i].y0;
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans:0:17);
 close (output);
end;

function solvesystem (var a :tmatrix; var x,y :real):boolean;
var d :real;
begin
 d := a[1][1]*a[2][2] - a[2][1]*a[1][2];
 solvesystem := false;
 if abs (d) < eps then
  exit;
 solvesystem := true;
 x := (a[1][3]*a[2][2] - a[2][3]*a[1][2])/d;
 y := (a[1][1]*a[2][3] - a[2][1]*a[1][3])/d;
end;

function test (l1,l2 :tl; t1,t2 :real):boolean;
var x1,y1,x2,y2 :real;
begin
 x1 := l1.x0 + l1.dx*t1;
 y1 := l1.y0 + l1.dy*t1;
 x2 := l2.x0 + l2.dx*t2;
 y2 := l2.y0 + l2.dy*t2;
 test := (abs(x1 - x2) < eps) and (abs(y1 - y2) < eps);
end;

procedure addpoints (num :int);
var
 pt :array [1..nmax] of real;
 i,j :int;
 t1,t2 :real;
 k :int;
 mtr :tmatrix;
 min,max :real;

begin
 fillchar (pt,sizeof(pt),0);
 k := 0;
 for j := num+1 to n do
  begin
   mtr[1][1] := l[num].dx;
   mtr[1][2] := -l[j].dx;
   mtr[2][1] := l[num].dy;
   mtr[2][2] := -l[j].dy;
   mtr[1][3] := l[j].x0 - l[num].x0;
   mtr[2][3] := l[j].y0 - l[num].y0;
   if solvesystem (mtr,t1,t2) then
    begin
     {$ifdef debug}
     if not test (l[num],l[j],t1,t2) then
      writeln ('jopa');
     {$endif}
     inc(k);
     pt[k] := t1;
    end;
  end;
 min := 1e50;
 max := -1e50;
 for i := 1 to k do
  begin
   if pt[i] < min then
    min := pt[i];
   if pt[i] > max then
    max := pt[i];
  end;
 if (min > 1e40) or (max < -1e40) then
  exit;
 inc(m);
 p[m].x := l[num].x0 + l[num].dx*min;
 p[m].y := l[num].y0 + l[num].dy*min;
 inc(m);
 p[m].x := l[num].x0 + l[num].dx*max;
 p[m].y := l[num].y0 + l[num].dy*max;
end;

procedure swap (var a,b :tpoint);
var tmp :tpoint;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

function less (a,b :tpoint):boolean;
var x1,y1,x2,y2 :real;
    prd :real;
begin
 x1 := a.x - p[1].x;
 y1 := a.y - p[1].y;
 x2 := b.x - p[1].x;
 y2 := b.y - p[1].y;
 prd := x1*y2 - x2*y1;
 if abs(prd) < eps then
  less := sqr(p[1].x - a.x) + sqr(p[1].y - a.y) <
          sqr(p[1].x - b.x) + sqr(p[1].y - b.y)
 else
  less := prd > 0;
end;

procedure sort (l,r :int);
var i,j :int;
    x :tpoint;
begin
 i := l;
 j := r;
 x := p[l + random(r-l+1)];
 repeat
  while less (p[i],x) do
   inc(i);
  while less (x,p[j]) do
   dec(j);
  if i <= j then
   begin
    swap (p[i],p[j]);
    inc(i);
    dec(j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if l < j then
  sort (l,j);
end;

function product (var a,b,c :tpoint):real;
var x1,y1,x2,y2 :real;
begin
 x1 := b.x - a.x;
 y1 := b.y - a.y;
 x2 := c.x - b.x;
 y2 := c.y - b.y;
 product := x1*y2 - x2*y1;
end;

procedure solve;
var i,j :int;
    min1,min2 :real;
    cur :int;
begin
 for i := 1 to n-1 do
  addpoints (i);
 min1 := 1e50;
 for i := 1 to m do
  if p[i].y < min1 then
   min1 := p[i].y;
 min2 := 1e50;
 cur := 0;
 for i := 1 to m do
  if p[i].y - min1 < eps then
   if p[i].x < min2 then
    begin
     min2 := p[i].x;
     cur := i;
    end;
 swap (p[1],p[cur]);
 sort (2,m);
 k := 3;
 s[1] := 1;
 s[2] := 2;
 s[3] := 3;
 for i := 4 to m do
  begin
   while (k > 1) and (product (p[s[k-1]],p[s[k]],p[i]) < eps) do
    dec(k);
   inc(k);
   s[k] := i;
  end;
 s[k+1] := s[1];
 for i := 1 to k do
  ans := ans + (p[s[i+1]].x - p[s[i]].x)*(p[s[i+1]].y + p[s[i]].y);
 ans := abs(ans/2);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.