#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

struct TEdgvrt {
  int x,y;
};

class TGraph {
  private:
    int n,m,C;
    long nm,nc,mc;
    int*G,**g,*g0,*G1,**g1;
    char*A,*B,**a,**b;
    TEdgvrt*q;
    int getcol(int,int);
    void search(int,int);
  public:
    TGraph(void);
    ~TGraph();
    void Delete(void);
    void scan(FILE*);
    void print(FILE*);
    void paint(void);
};

TGraph g;

int main(void) {
  fi=fopen("move.in","rt");
  g.scan(fi);
  fclose(fi);
  g.paint();
  fo=fopen("move.out","wt");
  g.print(fo);
  fclose(fo);
  return(0);
}


int TGraph::getcol(int x,int y) {
  int k;
  for (k=0; k<C; k++) if ((!a[x][k])&&(!b[y][k])) break;
  a[x][k]=1; b[y][k]=1;
  return(k);
}
void TGraph::search(int ux,int uy) {
  long i,l; int k; TEdgvrt v,w;
  q[0].x=ux; q[0].y=uy; k=getcol(ux,uy); g[ux][uy]=k+1; l=1;
  for (i=0; i<l; i++) {
    v=q[i];
    for (w.y=v.y,w.x=0; w.x<n; w.x++) {
      if (g[w.x][w.y]<0) { q[l]=w; k=getcol(w.x,w.y); g[w.x][w.y]=k+1; l++; }
    }
    for (w.x=v.x,w.y=0; w.y<m; w.y++) {
      if (g[w.x][w.y]<0) { q[l]=w; k=getcol(w.x,w.y); g[w.x][w.y]=k+1; l++; }
    }
  }
}
void TGraph::paint(void) {
  int i,j,k;
  memset(A,0,nc*sizeof(char));
  memset(B,0,mc*sizeof(char));
  for (i=0; i<n; i++) for (j=0; j<m; j++) if (g[i][j]<0) search(i,j);
}

TGraph::TGraph(void) {
  G=0; g=0;
  g0=0; G1=0; g1=0;
  A=0; B=0; a=0; b=0;
  q=0;
}
TGraph::~TGraph() {
  Delete();
}
void TGraph::Delete(void) {
  if (G) delete[]G; if (g) delete[]g;
  if (g0) delete[]g0; if (G1) delete[]G1; if (g1) delete[]g1;
  if (A) delete[]A; if (B) delete[]B; if (a) delete[]a; if (b) delete[]b;
  if (q) delete[]q;
}
void TGraph::scan(FILE*f) {
  Delete();
  int i,j,k,u; long l;
  fscanf(f,"%d%d",&n,&m);
  nm=((long)n)*((long)m);
  G=new int[nm]; g=new int*[n];
  for (i=0,l=0; i<n; i++,l+=(long)m) g[i]=&G[l];
  g0=new int[n]; G1=new int[nm]; g1=new int*[n];
  for (i=0,l=0; i<n; i++,l+=(long)m) g1[i]=&G1[l];
  memset(G,0,nm*sizeof(int));
  for (i=0; i<n; i++) {
    fscanf(f,"%d",&k);
    g0[i]=k;
    for (j=0; j<k; j++) {
      fscanf(f,"%d",&u); u--;
      g[i][u]=-1;
      g1[i][j]=u;
    }
  }
  C=n+m+2;
  nc=((long)n)*((long)C); mc=((long)m)*((long)C);
  A=new char[nc]; B=new char[mc];
  a=new char*[n]; b=new char*[m];
  for (i=0,l=0; i<n; i++,l+=(long)C) a[i]=&A[l];
  for (i=0,l=0; i<m; i++,l+=(long)C) b[i]=&B[l];
  q=new TEdgvrt[nm+2];
}
void TGraph::print(FILE*f) {
  int i,j,k,u;
  for (i=0; i<n; i++) {
    k=g0[i];
    for (j=0; j<k; j++) {
      u=g1[i][j];
      if (j) fprintf(f," ");
      fprintf(f,"%d",g[i][u]-1);
    }
    fprintf(f,"\n");
  }
}


