program ManyManyMayors;

const
  MAXN = 20000; {20000}
  MAXS = MAXN*3;

var
  n, m1, m2 : longint;
  x, y, color : array [0..MAXN] of longint;
  h1, h2, px, py : array [0..MAXN] of integer;
  good : array [0..MAXN] of boolean;

procedure Load(infile, outfile : string);
var
  i : integer;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n);
  for i:=1 to n do
    read(x[i],y[i]);
end;

procedure swap1(a, b : longint);
var
  t : longint;
begin
  t := h1[a];
  h1[a] := h1[b];
  h1[b] := t;
end;

function greater1(a, b : longint) : boolean;
begin
  greater1 := (y[a]>y[b]) or ((y[a]=y[b]) and (x[a]>x[b]));
end;

procedure heapify1(a : longint);
var
  l : longint;
begin
  l := a;
  if (2*a<=m1) and greater1(h1[2*a],h1[l]) then
    l := 2*a;
  if (2*a+1<=m1) and greater1(h1[2*a+1],h1[l]) then
    l := 2*a+1;
  if l<>a then
  begin
    swap1(l,a);
    heapify1(l);
  end;
end;

procedure heapsort1;
var
  i : longint;
begin
  m1 := n;
  for i:=1 to m1 do
    h1[i] := i;
  for i:=m1 downto 1 do
    heapify1(i);
  while m1>1 do
  begin
    swap1(1,m1);
    dec(m1);
    heapify1(1);
  end;
end;

procedure swap2(a, b : longint);
var
  t : longint;
begin
  t := h2[a];
  h2[a] := h2[b];
  h2[b] := t;
end;

function greater2(a, b : longint) : boolean;
begin
  greater2 := (x[a]>x[b]) or ((x[a]=x[b]) and (y[a]>y[b]));
end;

procedure heapify2(a : longint);
var
  l : longint;
begin
  l := a;
  if (2*a<=m2) and greater2(h2[2*a],h2[l]) then
    l := 2*a;
  if (2*a+1<=m2) and greater2(h2[2*a+1],h2[l]) then
    l := 2*a+1;
  if l<>a then
  begin
    swap2(l,a);
    heapify2(l);
  end;
end;

procedure heapsort2;
var
  i : longint;
begin
  m2 := n;
  for i:=1 to m2 do
    h2[i] := i;
  for i:=m2 downto 1 do
    heapify2(i);
  while m2>1 do
  begin
    swap2(1,m2);
    dec(m2);
    heapify2(1);
  end;
end;

var
  sts : integer;
  sta, stb, std, ste : array [1..MAXS] of integer;
  a, b, d, e : integer;

procedure Go(c : integer);
begin
  if c>n then
    exit;
  if good[c] then
  begin
    go(c+1);
    exit;
  end;
  if (px[c]=0) and (py[c]=0) then
  begin
    go(c+1);
    color[c] := 0;
    exit;
  end;
  if px[c]=0 then
  begin
    py[py[c]] := 0;
    go(c+1);
    color[c] := 1 - color[py[c]];
    exit;
  end;
  if py[c]=0 then
  begin
    px[px[c]] := 0;
    go(c+1);
    color[c] := 1 - color[px[c]];
    exit;
  end;
  a := px[c];
  b := py[c];
  d := py[a];
  e := px[b];
  inc(sts);
  sta[sts] := a;
  stb[sts] := b;
  std[sts] := d;
  ste[sts] := e;
  if (d>0) and (d=e) then
  begin
    good[d] := true;
    good[a] := true;
    good[b] := true;
    go(c+1);
    color[c] := 0;
    color[std[sts]] := 0;
    color[sta[sts]] := 1;
    color[stb[sts]] := 1;
    dec(sts);
    exit;
  end;
  if (d>0) and (x[d]=x[b]) then
  begin
    if e>0 then
      px[e] := px[d];
    px[px[d]] := e;
    good[d] := true;
    good[a] := true;
    good[b] := true;
    go(c+1);
    color[c] := 0;
    color[std[sts]] := 0;
    color[sta[sts]] := 1;
    color[stb[sts]] := 1;
    dec(sts);
    exit;
  end;
  if (e>0) and (y[e]=y[c]) then
  begin
    if d>0 then
      py[d] := py[e];
    py[py[e]] := d;
    good[e] := true;
    good[a] := true;
    good[b] := true;
    go(c+1);
    color[c] := 0;
    color[ste[sts]] := 0;
    color[sta[sts]] := 1;
    color[stb[sts]] := 1;
    dec(sts);
    exit;
  end;
  x[c] := x[b];
  y[c] := y[a];
  px[c] := e;
  if e>0 then
    px[e] := c;
  py[c] := d;
  if d>0 then
    py[d] := c;
  good[a] := true;
  good[b] := true;
  go(c);
  a := sta[sts];
  b := stb[sts];
  d := std[sts];
  e := ste[sts];
  x[c] := x[a];
  y[c] := y[b];
  color[a] := color[c];
  color[b] := color[c];
  color[c] := 1-color[c];
end;

procedure Solve;
var
  c : integer;
begin
  heapsort1;
  heapsort2;
  c := 1;
  while c<=n do
    if (c>=n) or (y[h1[c+1]]<>y[h1[c]]) then
    begin
      py[h1[c]] := 0;
      inc(c);
    end
    else
    begin
      py[h1[c]] := h1[c+1];
      py[h1[c+1]] := h1[c];
      inc(c,2);
    end;
  c := 1;
  while c<=n do
    if (c>=n) or (x[h2[c+1]]<>x[h2[c]]) then
    begin
      px[h2[c]] := 0;
      inc(c);
    end
    else
    begin
      px[h2[c]] := h2[c+1];
      px[h2[c+1]] := h2[c];
      inc(c,2);
    end;
  fillchar(good,sizeof(good),0);
  sts := 0;
  go(1);
end;

procedure Save;
var
  i : integer;
begin
  for i:=1 to n do
    writeln(color[i]);
  close(input);
  close(output);
end;

begin
  Load('mayors.in','mayors.out');
  Solve;
  Save;
end.
