#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

class TLand {
  private:
    long n,nx,ny;
    long*ax,*ay,*dx,*dy,*bx,*by,*cx,*cy,*c;
    void heapify(long*,long,long);
    void sort(long*,long);
    long resolve(long,long*,long);
    void shrink(long*,long*,long*,long&);
  public:
    TLand(void);
    ~TLand();
    void Delete(void);
    void scan(FILE*);
    void print(FILE*);
    void prepare(void);
    void paint(void);
};

TLand g;

int main(void) {
  fi=fopen("mayors.in","rt");
  g.scan(fi);
  fclose(fi);
  g.prepare();
  g.paint();
  fo=fopen("mayors.out","wt");
  g.print(fo);
  fclose(fo);
  return(0);
}


void TLand::paint(void) {
  long i;
  //memset(c,-1,n*sizeof(long));
  memset(cx,0,nx*sizeof(long)); memset(cy,0,ny*sizeof(long));
  for (i=0; i<n; i++) if ((cx[bx[i]]<=0)&&(cy[by[i]]<=0)) {
    c[i]=0;
    cx[bx[i]]++; cy[by[i]]++;
  } else {
    c[i]=1;
    cx[bx[i]]--; cy[by[i]]--;
  }
}

long TLand::resolve(long z,long*dz,long nz) {
  long u,v,w;
  for (v=0,w=nz; v<w; ) {
    u=(v+w)>>1;
    if (dz[u]<z) v=u+1; else w=u;
  }
  return(v);
}
void TLand::shrink(long*az,long*dz,long*bz,long&nz) {
  long i;
  memcpy(dz,az,n*sizeof(long));
  sort(dz,n);
  for (nz=1,i=1; i<n; i++) if (dz[i]!=dz[nz-1]) dz[nz++]=dz[i];
  for (i=0; i<n; i++) bz[i]=resolve(az[i],dz,nz);
}
void TLand::prepare(void) {
  shrink(ax,dx,bx,nx);
  shrink(ay,dy,by,ny);
}

TLand::TLand(void) {
  ax=0; ay=0;
  dx=0; dy=0;
  bx=0; by=0;
  cx=0; cy=0;
  c=0;
}
TLand::~TLand() {
  Delete();
}
void TLand::Delete(void) {
  if (ax) delete[]ax; if (ay) delete[]ay;
  if (dx) delete[]dx; if (dy) delete[]dy;
  if (bx) delete[]bx; if (by) delete[]by;
  if (cx) delete[]cx; if (cy) delete[]cy;
  if (c) delete[]c;
}
void TLand::scan(FILE*f) {
  Delete();
  long i;
  fscanf(f,"%ld",&n);
  ax=new long[n]; ay=new long[n];
  for (i=0; i<n; i++) fscanf(f,"%ld%ld",&ax[i],&ay[i]);
  dx=new long[n]; dy=new long[n];
  bx=new long[n]; by=new long[n];
  cx=new long[n]; cy=new long[n];
  c=new long[n];
}
void TLand::print(FILE*f) {
  long i;
  for (i=0; i<n; i++) fprintf(f,"%ld\n",c[i]);
}

void TLand::heapify(long*e,long v,long w) {
  long i,j; long z;
  i=v; j=(v<<1)+1;
  if ((j<w)&&(e[j]<e[j+1])) j++;
  z=e[i];
  while ((j<=w)&&(z<e[j])) {
    e[i]=e[j];
    i=j; j=(j<<1)+1;
    if ((j<w)&&(e[j]<e[j+1])) j++;
  }
  e[i]=z;
}
void TLand::sort(long*e,long k) {
  long i,j; long z;
  for (i=k>>1,j=k-1; i>0; i--) heapify(e,i,j);
  for (; j>0; j--) {
    heapify(e,i,j);
    z=e[i]; e[i]=e[j]; e[j]=z;
  }
}

