{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
Const maxn = 100000;

Type Avto = Record
             t1, t2, n, k: Longint;
            End;

Var i, n, m, x, hs, sqn: Longint;
    a: array[1..maxn + 2] of Avto;
    h: array[1..maxn + 2] of Longint;
    k: array[1..maxn] of Longint;
    r: array[1..maxn] of Record
                          n: Longint;
                          busy: Boolean;
                         End;

Procedure SwapAuto(var a, b: Avto);
 Var c: Avto;
 Begin
  c := a;
  a := b;
  b := c;
 End;

Procedure SwapInt(var a, b: Longint);
 Var c: Longint;
 Begin
  c := a;
  a := b;
  b := c;
 End;

Procedure Hoar(left, right: Longint);
 Var i, j, x: Longint;
 Begin
  i := left;
  j := right;
  x := a[Random(j - i + 1) + i].t1;
  While i < j do
   Begin
    While a[i].t1 < x do Inc(i);
    While a[j].t1 > x do Dec(j);
    If i <= j Then
     Begin
      SwapAuto(a[i], a[j]);
      SwapInt(k[a[i].k], k[a[j].k]);
      Inc(i);
      Dec(j);
     End;
   End;
  If j > left Then Hoar(left, j);
  If i < right Then Hoar(i, right);
 End;

Function Min(a, b: Longint): Longint;
 Begin
  If a < b Then Min := a
           Else Min := b;
 End;

Procedure Put(x: Longint);
 Var i: Longint;
 Begin
  r[x].busy := True;
  For i := 1 to sqn do
   Begin
    If not r[x].busy Then Break;
    If x < n Then r[x].n := Min(r[x + 1].n + 1, sqn)
             Else r[x].n := Min(r[1].n + 1, sqn);
    Dec(x);
    If x = 0 Then x := n;
   End;
 End;

Procedure Get(x: Longint);
 Var i, s: Longint;
 Begin
  r[x].busy := False;
  s := 0;
  For i := 1 to sqn do
   Begin
    If r[x].n <= s Then Break
                   Else r[x].n := s;
    Dec(x);
    Inc(s);
    If x = 0 Then x := n;
   End;
 End;

Procedure OutHeap(x: Longint);
 Var l, r: Longint;
 Function Left(x: Longint): Longint;
  Begin
   If x > hs shr 1 Then Left := n + 1
                     Else Left := x shl 1;
  End;
 Function Right(x: Longint): Longint;
  Begin
   If x > hs shr 1 Then Right:= n + 1
                     Else Right:= x shl 1 + 1;
  End;
 Begin
  Repeat
   l := Left(x);
   If a[h[x]].t2 > a[h[l]].t2
    Then SwapInt(h[x], h[l])
    Else
     Begin
      r := Right(x);
      If a[h[x]].t2 > a[h[r]].t2
       Then SwapInt(h[x], h[r])
       Else Break;
     End;
  Until False;
 End;

Procedure InHeap(x: Longint);
 Var p: Integer;
 Function Parent(x: Longint): Longint;
  Begin
   If x > 1 Then Parent := x shr 1
            Else Parent := n + 2;
  End;
 Begin
  Repeat
   p := Parent(x);
   If a[h[x]].t2 < a[h[p]].t2
    Then SwapInt(h[x], h[p])
    Else Break;
  Until False;
 End;

Begin
 Assign(input, 'parking.in');
 Assign(output, 'parking.out');
 Reset(input);
 Rewrite(output);
 Read(n, m);
 For i := 1 to m do
  Begin
   Read(a[i].t1, a[i].t2, a[i].n);
   a[i].k := i;
   k[i] := i;
  End;
 Hoar(1, m);
 h[n + 1] := n + 1;
 h[n + 2] := n + 2;
 a[n + 1].t2 := MaxLongint;
 a[n + 2].t2 := 0;
 h[1] := n + 1;
 sqn := Trunc(Sqrt(n));
 For i := 1 to m do
  Begin
   While a[h[1]].t2 < a[i].t1 do
    Begin
     Get(a[h[1]].n);
     a[h[1]].t2 := MaxLongint;
     OutHeap(1);
    End;
   While r[a[i].n].busy do
    Begin
     Inc(a[i].n, r[a[i].n].n);
     If a[i].n > n Then Dec(a[i].n, n);
    End;
   Put(a[i].n);
   Inc(hs);
   h[hs] := i;
   InHeap(hs);
  End;
 For i := 1 to m do
  Writeln(a[k[i]].n);
 Close(input);
 Close(output);
End.