{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 21000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'mayors.in';
 coutfile= 'mayors.out';
 {$endif}
type
 int = longint;
 real = extended;
 tvector = array [1..nmax] of int;
 tpoint = record
  x,y :int;
 end;
 tptr = ^tlist;
 tlist = record
  inf :int;
  color :byte;
  number :int;
  next :tptr;
 end;
var
 n :int;
 x,y :array [1..nmax] of int;
 p :array [1..nmax] of tpoint;
 gr :array [1..2,1..nmax] of tptr;
 count :array [1..2] of int;
 colors :array [1..nmax] of byte;
 xx,yy :tvector;
 nx,ny :tvector;

procedure init;
begin
 fillchar (x,sizeof(x),0);
 fillchar (y,sizeof(y),0);
 fillchar (p,sizeof(p),0);
 fillchar (colors,sizeof(colors),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n);
 for i := 1 to n do
  read (x[i],y[i]);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := 1 to n do
  writeln (colors[i]);
 close (output);
end;

procedure swap (var a,b :int);
begin
 a := a xor b;
 b := a xor b;
 a := a xor b;
end;

procedure quicksort (var b :tvector);

procedure sort (l,r :int);
var i,j :int;
    x :real;
begin
 i := l;
 j := r;
 x := b[l + random(r-l+1)];
 repeat
  while b[i] < x do
   inc(i);
  while b[j] > x do
   dec(j);
  if i <= j then
   begin
    if not (i = j) then
     swap (b[i],b[j]);
    inc(i);
    dec(j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if j > l then
  sort (l,j);
end;

begin
 sort (1,n);
end;

procedure convert (var b :tvector; var num :tvector);
var i :int;
begin
 fillchar (num,sizeof(num),0);
 num[1] := 1;
 for i := 2 to n do
  if b[i] > b[i-1] then
   num[i] := num[i-1] + 1
  else
   num[i] := num[i-1];
end;

function search (var b :tvector; value :int):int;
var l,r :int;
    mid :int;
begin
 l := 1;
 r := n;
 while r-l > 1 do
  begin
   mid := (l+r) shr 1;
   if b[mid] < value then
    l := mid
   else
    r := mid;
  end;
 if b[l] = value then
  search := l
 else
  search := r;
end;

procedure add (var list :tptr; value :int; number :int);
var x :tptr;
begin
 new(x);
 x^.inf := value;
 x^.number := number;
 x^.color := 0;
 x^.next := list;
 list := x;
end;

procedure repaint (part :int; u :int; v :int; color :byte);
var x :tptr;
begin
 x := gr[part][u];
 while not (x = nil) do
  begin
   if x^.inf = v then
    begin
     {$ifdef debug}
     if x^.color > 0 then
      writeln ('jopa');
     {$endif}
     x^.color := color;
     exit;
    end;
   x := x^.next;
  end;
 {$ifdef debug}
 writeln ('JOPA');
 {$endif}
end;

procedure dfs (part :int; v :int; start :byte);
var x :tptr;
    color :byte;
begin
 x := gr[part][v];
 color := start;
 while not (x = nil) do
  begin
   if x^.color = 0 then
    begin
     x^.color := color;
     repaint (3 - part,x^.inf,v,color);
     color := 3 - color;
     dfs (3 - part,x^.inf,color);
    end;
   x := x^.next;
  end;
end;

procedure solve;
var i,j :int;
    z :tptr;
begin
 for i := 1 to n do
  begin
   xx[i] := x[i];
   yy[i] := y[i];
  end;
 quicksort (xx);
 quicksort (yy);
 convert (xx,nx);
 convert (yy,ny);
 count[1] := nx[n];
 count[2] := ny[n];
 for i := 1 to n do
  begin
   p[i].x := nx[search(xx,x[i])];
   p[i].y := ny[search(yy,y[i])];
  end;
 for i := 1 to n do
  begin
   add (gr[1][p[i].x],p[i].y,i);
   add (gr[2][p[i].y],p[i].x,i);
  end;
 for i := 1 to 2 do
  for j := 1 to count[i] do
   dfs (i,j,1);
 for i := 1 to n do
  begin
   z := gr[1][i];
   while not (z = nil) do
    begin
     colors[z^.number] := z^.color - 1;
     z := z^.next;
    end;
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.