program SynchroGraph;

type
  plist = ^tlist;
  tlist = record
    data : integer;
    w : longint;
    next : plist;
  end;

const
  MAXN = 1000; {1000}

var
  n, m : longint;
  ans : array [1..MAXN] of integer;
  f : array [1..MAXN] of longint;
  li : array [1..MAXN] of plist;
  khm : array [1..MAXN,1..MAXN] of longint;

procedure Load(infile, outfile : string);
var
  i, a, b, c : longint;
  p : plist;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n,m);
  fillchar(li,sizeof(li),0);
  fillchar(khm,sizeof(khm),255);
  for i:=1 to m do
  begin
    read(a,b,c);
    new(p);
    p^.data := a;
    p^.next := li[b];
    p^.w := ord(c>0);
    li[b] := p;
    if (khm[b,a]=-1) or (khm[b,a]>c) then
      khm[b,a] := c;
  end;
end;

var
  t : boolean;

procedure dfs(a : integer);
var
  p : plist;
  b, c : longint;
  good : boolean;
  und : boolean;
begin
  ans[a] := 1;
  p := li[a];
  good := true;
  und := false;
  while p<>nil do
  begin
    b := p^.data;
    c := p^.w;
    p := p^.next;
    if c>khm[a,b] then
      continue;
    if ans[b]=0 then
    begin
      f[b] := f[a] + c;
      dfs(b);
    end;
    if (ans[b]=1) or (ans[b]=0) then
    begin
      if t then
        good := good and (f[a]+c>f[b])
      else
        und := true;
    end
    else
      good := good and (ans[b]=2);
  end;
  if (good and und) then
    ans[a] := 0
  else
    if good then
      ans[a] := 2
    else
      ans[a] := 3;
end;

procedure Solve;
var
  i : integer;
begin
  fillchar(ans,sizeof(ans),0);
  fillchar(f,sizeof(f),0);
  t := false;
  for i:=1 to n do
    if ans[i]=0 then
      dfs(i);
  t := true;
  for i:=1 to n do
    if ans[i]=0 then
      dfs(i);
end;

procedure Save;
var
  i : integer;
begin
  for i:=1 to n do
    if ans[i]=2 then
      writeln(1)
    else
      writeln(0);
  close(input);
  close(output);
end;

begin
  Load('synchro.in','synchro.out');
  Solve;
  Save;
end.