#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define MM 10000
#define NN 1100
#define LET_NUM 27
#define INF 2000000000

struct RULE {
  char a;
  char b;
  char *s;
  int sl;
};

struct REB {
  int a;
  char c;
  REB *p;
};

int _stklen = 4194304;

FILE *fi, *fo;
RULE r[NN];
REB *g1[MM];
int g2[MM][LET_NUM];
int m;
int nt[LET_NUM];
bool term[MM];
bool used[MM];
bool pos[MM];
int d[MM];
char ss;
int res;
int res1;
int n;

void Add(int x, int y, char c)
{
  REB *t;
  t=new REB;
  t->a=y;
  t->c=c;
  t->p=g1[x];
  g1[x]=t;
  g2[x][c-'a']=y;
}

char GetNextC()
{
  char c;
  c=getc(fi);
  while(c==' ') c=getc(fi);
  return c;
}

void GetRule(RULE *r)
{
  char c;
  char s[3000];
  int i;
  c=getc(fi);
  while((c==' ')||(c=='\n')) c=getc(fi);
  r->a=c;
  c=getc(fi);
  while((c==' ')||(c=='\n')||(c=='-')||(c=='>')) c=getc(fi);
  i=0;
  if((c>='A')&&(c<='Z'))
  {
    r->b=c;
  }
  else
  {
    r->b=-1;
    if(isalpha(c))
    {
      s[i]=c;
      i++;
    }
  }
  while(((c=GetNextC())!='\n')&&(c!=EOF))
  {
    s[i]=c;
    i++;
  }
  s[i]='\0';
  r->sl=strlen(s);
  r->s=new char [r->sl];
  strcpy(r->s,s);
}

void RunRule(RULE p,int v)
{
  int nxt;
  if(p.sl==0)
  {
    if(p.b<0)
      term[v]=true;
    return ;
  }
  if(p.sl==1)
  {
    if(p.b>=0)
    {
      if(nt[p.b-'A']>=0)
      {
        Add(v,nt[p.b-'A'],p.s[0]);
//        g2[v][p->s[0]-'a']=nt[r->b-'A'];
        return ;
      }
    }
  }
  nxt=g2[v][p.s[p.sl-1]-'a'];
  if(nxt<0)
  {
    nxt=m;
    m++;
  }
  Add(v,nxt,p.s[p.sl-1]);
  p.sl--;
  p.s[p.sl]='\0';
  if(p.sl==0)
    if(p.b>=0)
      nt[p.b-'A']=nxt;
    else
      term[nxt]=true;
  RunRule(p,nxt);
}

bool dfs(int v)
{
  REB *t;
  used[v]=true;
  for(t=g1[v];t!=NULL;t=t->p)
    if(!used[t->a])
      if(dfs(t->a))
        pos[v]=true;
  if(term[v])
    pos[v]=true;
  return pos[v];
}

void solv()
{
  int i,j;
  REB *t;
  int d1[MM];
  for(i=0;i<MM;i++)
  {
    g1[i]=NULL;
    term[i]=false;
//    used[i]=false;
//    pos[i]=false;
    d[i]=0;
    for(j=0;j<LET_NUM;j++)
      g2[i][j]=-1;
  }
  for(j=0;j<LET_NUM;j++)
    nt[j]=-1;
  m=0;
  res=0;
  for(i=0;i<n;i++)
    if(nt[r[i].a-'A']>=0)
      RunRule(r[i],nt[r[i].a-'A']);
    else
    {
      m++;
      nt[r[i].a-'A']=m-1;
      RunRule(r[i],m-1);
    }
/*  for(i=0;i<m;i++)
    if(!used[i])
      dfs(i);*/
  d[nt[ss-'A']]=1;
  for(i=0;i<m;i++)
  {
    for(j=0;j<m;j++)
    {
      d1[j]=0;
      if(term[j])
        res+=d[j];
    }
    for(j=0;j<m;j++)
      for(t=g1[j];t!=NULL;t=t->p)
        d1[t->a]+=d[j];
    for(j=0;j<m;j++)
      d[j]=d1[j];
  }
  for(i=0;i<m;i++)
  {
    for(j=0;j<m;j++)
    {
      d1[j]=0;
      if(term[j])
        if(d[j]>0)
          res=INF;
    }
    for(j=0;j<m;j++)
      for(t=g1[j];t!=NULL;t=t->p)
        d1[t->a]+=d[j];
    for(j=0;j<m;j++)
      d[j]=d1[j];
  }
}

int main()
{
  int i,j;
  fi=fopen("left.in","rt");
  fo=fopen("left.out","wt");

  fscanf(fi,"%i",&n);
  ss=GetNextC();
  for(i=0;i<n;i++)
    GetRule(&r[i]);
  solv();
  if(res>=INF)
    fprintf(fo,"infinity\n");
  else
    fprintf(fo,"%i\n",res);

  fclose(fi);
  fclose(fo);
  return 0;
}
