{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65520,0,655360}
Const maxp = 1010;
      maxt = 2050;

Type Word = array[1..maxp] of Char;
     Rule = Record
             a, b: Char;
             k: integer;
             c: Word;
            End;
     Tree = ^DTree;
     DTree = Record
              exist: Boolean;
              next: array['a'..'z'] of Tree;
             End;

Var i, j, k, n, p, vs, ws: Integer;
    s, c: Char;
    w: Word;
    root: Tree;
    exitable: array['A'..'Z'] of Boolean;
    use: array['A'..'Z'] of Byte;
    r: array[1..maxp] of Rule;
    a: array['A'..'Z', 'A'..'Z'] of Byte;

Procedure ReadSpaces;
 Begin
  c := ' ';
  While c in [' ', '-', '>', #10] do Read(c);
 End;

Procedure Init;
 Begin
  Read(n);
  ReadSpaces;
  s := c;
  Readln;
  For i := 1 to n do
   Begin
    ReadSpaces;
    r[i].a := c;
    ReadSpaces;
    r[i].b := c;
    If not (c in ['A'..'Z'])
     Then r[i].b := '*'
     Else ReadSpaces;
    k := 0;
    While (c <> #13) and (c <> #26) do
     Begin
      Inc(k);
      r[i].c[k] := c;
      ReadSpaces;
     End;
    r[i].k := k;
   End;
 End;

Procedure Swap(var a, b: Rule);
 Var c: Rule;
 Begin
  c := a;
  a := b;
  b := c;
 End;

Procedure Hoar(left, right: Integer);
 Var i, j: Longint;
     x: Char;
 Begin
  i := left;
  j := right;
  x := r[Random(j - i + 1) + i].a;
  While i < j do
   Begin
    While r[i].a < x do Inc(i);
    While r[j].a > x do Dec(j);
    If i <= j Then
     Begin
      Swap(r[i], r[j]);
      Inc(i);
      Dec(j);
     End;
   End;
  If j > left Then Hoar(left, j);
  If i < right Then Hoar(i, right);
 End;

Procedure ExitCheck(x: Char);
 Var i: Integer;
 Begin
  For i := 1 to n do
   If (r[i].b = x) and (use[r[i].a] = 0) Then
    Begin
     use[r[i].a] := 1;
     ExitCheck(r[i].a);
    End;
 End;

Procedure Infinity;
 Begin
  Write('infinity');
  Close(input);
  Close(output);
  Halt;
 End;

Function First(x: Char): Integer;
 Var i, j, p: Integer;
 Begin
  i := 1;
  j := n;
  While i <= j do
   Begin
    p := (i + j) shr 1;
    If r[p].a > x Then j := p - 1;
    If r[p].a < x Then i := p + 1;
    if r[p].a = x Then Break;
   End;
  i := p;
  While (i >= 1) and (r[i].a = x) do Dec(i);
  First := i + 1;
 End;

Procedure CycledCheck(x: Char; empty: Boolean);
 Var p: Char;
 Begin
  If (x = c) and not empty
   Then
    If exitable[x] Then Infinity Else
   Else
    For p := 'A' to 'Z' do
     Case a[x, p] of
      1: If use[p] = 0 Then
          Begin
           use[p] := 1;
           CycledCheck(p, empty);
          End;
      2: If use[p] < 2 Then
          Begin
           use[p] := 2;
           CycledCheck(p, False);
          End;
     End;
 End;

Function Equil(const a, b: Word): Boolean;
 Var i: Integer;
 Begin
  i := 1;
  While (a[i] = b[i]) and (a[i] <> #0) do Inc(i);
  If a[i] = b[i] Then Equil := True
                 Else Equil := False;
 End;

Procedure WordCheck(x: Char; e: Integer);
 Var i, j: Integer;
     p: Tree;
 Begin
  If (x <> '*') and not exitable[x] Then Exit;
  If e > 0 Then
   Begin
    For j := 1 to r[e].k do
     w[ws + j] := r[e].c[r[e].k - j + 1];
    Inc(ws, r[e].k);
   End;
  If x = '*'
   Then
    Begin
     p := root;
     j := 1;
     While (j <= ws) and (p^.next[w[j]] <> nil) do
      Begin
       p := p^.next[w[j]];
       Inc(j);
      End;
     If j > ws
      Then
       If not p^.exist
        Then
         Begin
          p^.exist := True;
          Inc(vs);
         End Else
      Else
       Begin
        Inc(vs);
        For k := j to ws do
         Begin
          New(p^.next[w[k]]);
          p := p^.next[w[k]];
          p^.exist := False;
          For c := 'a' to 'z' do p^.next[c] := nil;
         End;
        p^.exist := True;
       End;
    End
   Else
    Begin
     i := First(x);
     While r[i].a = x do
      Begin
       If r[i].b = '*'
        Then
         WordCheck(r[i].b, i)
        Else
         If use[r[i].b] = 0 Then
          Begin
           use[r[i].b] := 1;
           WordCheck(r[i].b, i);
           use[r[i].b] := 0;
          End;
       Inc(i);
      End;
    End;
  If e > 0 Then Dec(ws, r[e].k);
 End;

Begin
 Assign(input, 'left.in');
 Assign(output, 'left.out');
 Reset(input);
 Rewrite(output);
 Init;
 Hoar(1, n);
 ExitCheck('*');
 For c := 'A' to 'Z' do
  If use[c] = 1 Then exitable[c] := True;
 FillChar(use, SizeOf(use), 0);
 For i := 1 to n do
  If r[i].b <> '*' Then
   If r[i].k > 0
    Then a[r[i].a, r[i].b] := 2
    Else
     If a[r[i].a, r[i].b] = 0
      Then a[r[i].a, r[i].b] := 1;
 For c := 'A' to 'Z' do
  CycledCheck(c, True);
 FillChar(use, SizeOf(use), 0);
 New(root);
 For c := 'a' to 'z' do root^.next[c] := nil;
 WordCheck(s, 0);
 Write(vs);
 Close(input);
 Close(output);
End.
