program C_N_K;
{$N+}
const
  MAXL = 3000;
  MAXM = 10000; {10000}
  Eps = 1e-12;  {dangerous!}

type
  Long = array [0..MAXL] of Integer;

procedure WriteLong(a : Long);
var
  i : integer;
begin
  write(a[a[0]]);
  for i:=a[0]-1 downto 1 do
    write(a[i] div 1000,a[i] mod 1000 div 100,a[i] mod 100 div 10,a[i] mod 10);
  writeln;
end;

procedure LongMulShort(var a : Long; b : longint);
var
  i, c, o : longint;
begin
  o := 0;
  for i:=1 to a[0] do
  begin
    c := o + a[i]*b;
    o := c div 10000;
    a[i] := c mod 10000;
  end;
  if o>0 then
  begin
    inc(a[0]);
    a[a[0]] := o;
    if a[0]>MAXL then
      halt(13);
  end;
end;

var
  m, p, hs : longint;
  hn, hk : array [1..MAXM] of integer;
  fact : array [0..MAXM] of extended;
  v : array [1..MAXM] of longint;
  res : Long;

procedure Load(infile, outfile : string);
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(m,p);
end;

procedure swap(a, b : integer);
var
  t : integer;
begin
  t := hn[a];
  hn[a] := hn[b];
  hn[b] := t;
  t := hk[a];
  hk[a] := hk[b];
  hk[b] := t;
end;

function f(a : integer) : extended;
begin
  f := fact[hn[a]]-fact[hk[a]]-fact[hn[a]-hk[a]];
end;

procedure heapify(a : integer);
var
  l : integer;
begin
  l := a;
  if (2*a<=hs) and (f(2*a)+eps<f(l)) then
    l := 2*a;
  if (2*a+1<=hs) and (f(2*a+1)+eps<f(l)) then
    l := 2*a+1;
  if l<>a then
  begin
    swap(l,a);
    heapify(l);
  end;
end;

function prime(a : integer) : boolean;
var
  i : integer;
begin
  prime := false;
  for i:=2 to trunc(sqrt(a)) do
    if a mod i=0 then
      exit;
  prime := true;
end;

procedure Solve;
var
  i, j, t : longint;
  cn, ck, dn, dk : integer;
  cf : extended;
begin
  fact[0] := 0;
  fact[1] := 0;
  for i:=2 to m do
    fact[i] := fact[i-1] + ln(i);
  hs := m;
  for i:=1 to m do
  begin
    hn[i] := i;
    hk[i] := 0;
  end;
  for i:=m downto 1 do
    heapify(i);
  while p>0 do
  begin
    dec(p);
    cn := hn[1];
    ck := hk[1];
    cf := f(1);
    while (abs(f(1)-cf)<eps) do
    begin
      dn := hn[1];
      dk := hk[1];
      swap(1,hs);
      dec(hs);
      heapify(1);
      if (dn>1) and (2*dk<dn) then
      begin
        inc(dk);
        inc(hs);
        hn[hs] := dn;
        hk[hs] := dk;
        t := hs;
        while (t>1) and (f(t)<f(t div 2)) do
        begin
          swap(t,t div 2);
          t := t div 2;
        end;
      end;
    end;
  end;

  fillchar(p,sizeof(p),0);
  for i:=2 to m do
    if prime(i) then
    begin
      v[i] := 0;
      t := cn;
      while t>0 do
      begin
        t := t div i;
        v[i] := v[i] + t;
      end;
      t := ck;
      while t>0 do
      begin
        t := t div i;
        v[i] := v[i] - t;
      end;
      t := cn-ck;
      while t>0 do
      begin
        t := t div i;
        v[i] := v[i] - t;
      end;
    end;
  res[0] := 1;
  res[1] := 1;
  for i:=2 to m do
    for j:=1 to v[i] do
      LongMulShort(res,i);
end;

procedure Save;
begin
  writelong(res);
  close(input);
  close(output);
end;

begin
  Load('cnk.in','cnk.out');
  Solve;
  Save;
end.