program Robot;

const maxn = 30;

type ttoken = (_end,_a,_b,_c,_d,_true,_false,_left,_right,_and,_or,_xor,_not);

var
  m,n,p,q,x0,y0,a0 : integer;
  k : longint;
  x,y : integer;
  st,newst : array [1..4] of boolean;
  ang : integer;
  trigch : array [1..maxn,1..maxn,1..4] of boolean;
  man : array [1..maxn,1..maxn] of integer;
  app : array [1..maxn,1..maxn,0..1,0..1,0..1,0..1,0..3] of longint;
  max,may : array [1..25] of integer;
  maf : array [1..maxn] of string;
  crash : boolean;
  moveno : longint;
  ch : char;
  ctok : ttoken;
  cf : string;

procedure Inp;
var
  i : integer;
  trigx,trigy,trigr : integer;
  c,tc : char;
begin
  assign(input,'input.txt'); reset(input);
  assign(output,'output.txt'); rewrite(output);
  read(m,n,p,q,k,x0,y0,a0);
  fillchar(trigch,sizeof(trigch),0);
  fillchar(man,sizeof(man),0);
  for i:=1 to p do
  begin
    readln(trigx,trigy,tc,c);
    c := upcase(c);
    trigr := ord(c)-ord('A')+1;
    trigch[trigx,trigy,trigr] := not trigch[trigx,trigy,trigr];
  end;
  for i:=1 to q do
  begin
    read(max[i],may[i],c,maf[i]);
    man[max[i],may[i]] := i;
  end;
  fillchar(app,sizeof(app),0);
  fillchar(st,sizeof(st),0);
  x := x0;
  y := y0;
  ang := a0 div 90;
end;

function again : boolean;
begin
  again := app[x,y,ord(st[1]),ord(st[2]),ord(st[3]),ord(st[4]),ang] <> 0;
end;

procedure rch;
begin
  if cf='' then ch := #0 else ch:=cf[1];
  delete(cf,1,1);
  ch := upcase(ch);
end;

procedure rtok;
begin
  while ch=' ' do rch;
  case ch of
    #0 : ctok := _end;
    'A': begin rch;
    if ch = 'N' then begin ctok := _and; rch; rch; end else ctok := _a; end;
    'B': begin rch; ctok := _b; end;
    'C': begin rch; ctok := _c; end;
    'D': begin rch; ctok := _d; end;
    'T': begin rch; rch; rch; rch; ctok := _true; end;
    'F': begin rch; rch; rch; rch; rch; ctok := _false; end;
    'O': begin rch; rch; ctok := _or; end;
    'X': begin rch; rch; rch; ctok := _xor; end;
    'N': begin rch; rch; rch; ctok := _not; end;
    '(': begin rch; ctok := _left; end;
    ')': begin rch; ctok := _right; end;
  end;
end;

function expr : boolean; forward;

function expr2 : boolean;
begin
  if ctok = _left then
  begin
    rtok;
    expr2 := expr;
    rtok;
  end else
  begin
  if ctok = _a then expr2 := st[1]
  else if ctok = _b then expr2 := st[2]
  else if ctok = _c then expr2 := st[3]
  else if ctok = _d then expr2 := st[4] else
  if ctok = _true then expr2 := true else
  if ctok = _false then expr2 := false;
  rtok;
  end;
end;

function expr1 : boolean;
var
  cr : boolean;
begin
  cr := false;
  while ctok = _not do
  begin
    rtok;
    cr := not cr;
  end;
  expr1 := cr xor expr2;
end;

function expr : boolean;
var
  cr,tr : boolean;
  tt : ttoken;
begin
  cr := expr1;
  while (ctok in [_and,_or,_xor]) do
  begin
    tt := ctok;
    rtok;
    tr := expr1;
    if tt=_and then cr := cr and tr
    else if tt=_or then cr := cr or tr
    else if tt=_xor then cr := cr xor tr;
  end;
  expr := cr;
end;

function formula(forno : integer) : boolean;
begin
  cf := maf[forno];
  rch;
  rtok;
  formula := expr;
end;

procedure move;
var
  i : integer;
begin
  app[x,y,ord(st[1]),ord(st[2]),ord(st[3]),ord(st[4]),ang] := moveno;
  if ang=0 then dec(y);
  if ang=1 then inc(x);
  if ang=2 then inc(y);
  if ang=3 then dec(x);
  crash := crash or (x<1) or (x>m) or (y<1) or (y>n);
  if crash then exit;
  for i:=1 to 4 do
    newst[i] := st[i] xor trigch[x,y,i];
  st := newst;
  if man[x,y]<>0 then
    if formula(man[x,y]) then
      inc(ang)
    else
      inc(ang,3);
  ang := ang mod 4;
end;

procedure Run;
var
  cyclen,cycbeg : longint;
  i : integer;
begin
  crash := false;
  for moveno:=1 to k do
  begin
    if again then
    begin
      cycbeg := app[x,y,ord(st[1]),ord(st[2]),ord(st[3]),ord(st[4]),ang];
      cyclen := moveno-cycbeg;
      k := k - cycbeg + 1;
      k := k mod cyclen;
      for i:= 1 to k do
        move;
      writeln(x,' ',y);
      exit;
    end;
    if crash then
    begin
      writeln(-1);
      exit;
    end;
    move;
  end;
  if crash then writeln(-1) else
  writeln(x,' ',y);
end;

procedure Outp;
begin
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.