const
     FileIn='input.txt';
     FileOut='output.txt';
     MaxP=10000;
     MaxQ=25;
     vLeft=1;
     vRight=2;
     vDown=3;
     vUp=4;
     MaxN=30;
     MaxM=30;
     MaxSteps=MaxN*MaxM*2*2*2*2;
type
    TTrigger=record
                   X, Y: Byte;
                   R: Char;
             end;
    TLight=record
                 X, Y: Byte;
                 F: string;
           end;
    TCell=record
               Value: array [false..true, false..true, false..true, false..true] of set of vLeft..vUp;
          end;
    TPos=record
               X, Y: Byte;
               Vector: Byte;
               A, B, C, D: Boolean;
         end;
var
   Alive: Boolean;
   AnswerX, AnswerY: LongInt;
   M, N, P, Q, K, X0, Y0, A0: LongInt;
   Triggers: array [1..MaxP] of TTrigger;
   Lights: array [1..MaxQ] of TLight;
   Board: array [1..MaxN, 1..MaxM] of TCell;
   A, B, C, D: Boolean;
   X, Y: LongInt;
   Vector: Byte;
   Positions: array [0..MaxSteps] of TPos;
   StepsCount: LongInt;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
   Ch: Char;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, M, N, P, Q, K, X0, Y0, A0);
     for NItem:=1 to P
         do Readln (F, Triggers [NItem].X, Triggers [NItem].Y, Ch, Triggers [NItem].R);
     for NItem:=1 to Q
         do Readln (F, Lights [NItem].X, Lights [NItem].Y, Ch, Lights [NItem].F);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     case Alive of
          false: Writeln (F, -1);
          true: Writeln (F, AnswerX, #32, AnswerY);
     end;
     Close (F);
end;

function StrVarOrConstToBool (aStr: string): Boolean;
begin
     if aStr='FALSE'
        then StrVarOrConstToBool:=false
        else if aStr='TRUE'
                then StrVarOrConstToBool:=true
                else if aStr='A'
                        then StrVarOrConstToBool:=A
                        else if aStr='B'
                                then StrVarOrConstToBool:=B
                                else if aStr='C'
                                        then StrVarOrConstToBool:=C
                                        else StrVarOrConstToBool:=D;
end;

function AdvEvaluate (const aExpr: string): Boolean;
var
   NChar: Byte;
   Expr: string;

function RecEvaluate: Boolean;
var
   W, O: string;
   Value, Right: Boolean;

procedure ExtractWord (var aWord: string);
begin
     aWord:='';
     while (Expr [NChar] in [#32, ')']) and (NChar<=Length (Expr))
           do Inc (NChar);
     while (not (Expr [NChar] in [#32, ')'])) and (NChar<=Length (Expr))
           do begin
              aWord:=aWord+Expr [NChar];
              Inc (NChar);
           end;
     while (Expr [NChar]=#32) and (NChar<=Length (Expr))
           do Inc (NChar);
end;

procedure GetRightSmart;
begin
     if Expr [NChar]='('
        then begin
             Inc (NChar);
             Right:=RecEvaluate;
        end
        else begin
             ExtractWord (W);
             if W='NOT'
                then begin
                     ExtractWord (W);
                     Right:=not StrVarOrConstToBool (W);
                end
                else Right:=StrVarOrConstToBool (W);
        end;
end;

begin
     GetRightSmart;
     Value:=Right;
     while (Expr [NChar]<>')') and (NChar<=Length (Expr))
           do begin
              ExtractWord (O);
              GetRightSmart;
              if O='OR'
                 then Value:=Value or Right
                 else if O='AND'
                         then Value:=Value and Right
                         else if O='XOR'
                                 then Value:=Value xor Right;
           end;
     RecEvaluate:=Value;
end;

begin
     NChar:=1;
     Expr:=aExpr+')';
     AdvEvaluate:=RecEvaluate;
end;

function Evaluate (aLight: LongInt): Boolean;
begin
     if Lights [aLight].F='FALSE'
        then Evaluate:=false
        else if Lights [aLight].F='TRUE'
                then Evaluate:=true
                else if Lights [aLight].F='A'
                        then Evaluate:=A
                        else if Lights [aLight].F='B'
                                then Evaluate:=B
                                else if Lights [aLight].F='C'
                                        then Evaluate:=C
                                        else if Lights [aLight].F='D'
                                                then Evaluate:=D
                                                else Evaluate:=AdvEvaluate (Lights [aLight].F);
end;

procedure ProcessCell;
var
   NItem: LongInt;
begin
     for NItem:=1 to P
         do if (Triggers [NItem].X=X) and (Triggers [NItem].Y=Y)
               then case Triggers [NItem].R of
                         'A': A:=not A;
                         'B': B:=not B;
                         'C': C:=not C;
                         'D': D:=not D;
                    end;
     for NItem:=1 to Q
         do if (Lights [NItem].X=X) and (Lights [NItem].Y=Y)
               then begin
                    case Evaluate (NItem) of
                         false: case Vector of
                                     vLeft: Vector:=vDown;
                                     vUp: Vector:=vLeft;
                                     vRight: Vector:=vUp;
                                     vDown: Vector:=vRight;
                                end;
                         true: case Vector of
                                    vLeft: Vector:=vUp;
                                    vUp: Vector:=vRight;
                                    vRight: Vector:=vDown;
                                    vDown: Vector:=vLeft;
                               end;
                    end;
               end;
end;

procedure Solve;
var
   PrevSuchPos: LongInt;
begin
     X:=X0;
     Y:=Y0;
     A:=false;
     B:=false;
     C:=false;
     D:=false;
     case A0 of
          0: Vector:=vUp;
          90: Vector:=vRight;
          180: Vector:=vDown;
          270: Vector:=vLeft;
     end;
     Alive:=true;
     StepsCount:=0;
     Positions [StepsCount].X:=X;
     Positions [StepsCount].Y:=Y;
     Positions [StepsCount].Vector:=Vector;
     Positions [StepsCount].A:=A;
     Positions [StepsCount].B:=B;
     Positions [StepsCount].C:=C;
     Positions [StepsCount].D:=D;
     Board [X, Y].Value [A, B, C, D]:=Board [X, Y].Value [A, B, C, D]+[Vector];
     ProcessCell;
     repeat
           case Vector of
                vUp: if Y>1
                        then Dec (Y)
                        else begin
                             Alive:=false;
                             Exit;
                        end;
                vLeft: if X>1
                         then Dec (X)
                         else begin
                              Alive:=false;
                              Exit;
                         end;
                vDown: if Y<N
                          then Inc (Y)
                          else begin
                               Alive:=false;
                               Exit;
                          end;
                vRight: if X<M
                           then Inc (X)
                           else begin
                                Alive:=false;
                                Exit;
                           end;
           end;
           Inc (StepsCount);
           Positions [StepsCount].X:=X;
           Positions [StepsCount].Y:=Y;
           Positions [StepsCount].Vector:=Vector;
           Positions [StepsCount].A:=A;
           Positions [StepsCount].B:=B;
           Positions [StepsCount].C:=C;
           Positions [StepsCount].D:=D;
           if Vector in Board [X, Y].Value [A, B, C, D]
              then Break;
           Board [X, Y].Value [A, B, C, D]:=Board [X, Y].Value [A, B, C, D]+[Vector];
           ProcessCell;
     until false;
     if Alive
        then begin
             for PrevSuchPos:=0 to StepsCount-1
                 do if (Positions [PrevSuchPos].X=X) and
                       (Positions [PrevSuchPos].Y=Y) and
                       (Positions [PrevSuchPos].Vector=Vector) and
                       (Positions [PrevSuchPos].A=A) and
                       (Positions [PrevSuchPos].B=B) and
                       (Positions [PrevSuchPos].C=C) and
                       (Positions [PrevSuchPos].D=D)
                       then Break;
             AnswerX:=Positions [((K-1-PrevSuchPos) mod StepsCount)+1+PrevSuchPos].X;
             AnswerY:=Positions [((K-1-PrevSuchPos) mod StepsCount)+1+PrevSuchPos].Y;
        end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
