program template;
const
 h = 31;
type
 int = longint;
 tpole = record
  reg :string;
  s :string;
 end;
var
 n,m,p,q,k :int;
 ans :int;
 pole :array [1..h,1..h] of ^tpole;
 dx,dy :int;
 x,y :int;
 rg :array ['A'..'D'] of boolean;
 a0 :int;
 ps :array [1..h,1..h,0..63] of longint;
 maked :boolean;

procedure init;
begin
 fillchar (pole,sizeof(pole),0);
 fillchar (rg,sizeof(rg),0);
 fillchar (ps,sizeof(ps),128);
 maked := false;
end;

procedure readdata;
var i,j :int;
    x_,y_ :int;
    r :char;
    c :char;
    s :string;
begin
 assign (input,'input.txt');
 reset (input);
 readln (m,n,p,q,k,x,y,a0);
 for i := 1 to m do
  for j := 1 to n do
   begin
    new (pole[i,j]);
    pole[i,j]^.reg := '';
    pole[i,j]^.s := '';
   end;
 for i := 1 to p do
  begin
   read (x_,y_);
   repeat
   read (r);
   r := upcase (r);
   until r in ['A'..'D'];
   pole[x_,y_]^.reg := pole[x_,y_]^.reg + r;
  end;
 for i := 1 to q do
  begin
   read (x_,y_);
   s := '';
   while not eoln do
    begin
     read (c);
     s := s + upcase(c);
    end;
   readln;
   pole[x_,y_]^.s := s;
  end;
 case a0 of
  0: begin dx := 0; dy := -1; end;
  90: begin dx := 1; dy := 0; end;
  180: begin dx := 0; dy := 1; end;
  270: begin dx := -1; dy := 0; end;
 end;
 close (output);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,'output.txt');
 rewrite (output);
 writeln (x,' ',y);
 close (output);
end;

procedure turnright;
var x_, y_ :int;
begin
 if dx > 0 then
  begin
   dx := 0;
   dy := 1;
   exit;
  end;
 if dx < 0 then
  begin
   dx := 0;
   dy := -1;
   exit;
  end;
 if dy > 0 then
  begin
   dy := 0;
   dx := -1;
   exit;
  end;
 if dy < 0 then
  begin
   dy := 0;
   dx := 1;
   exit;
  end;
{ x_ := dy;
 y_ := -dx;
 dx := x_;
 dy := y_;}
end;

procedure turnleft;
var x_,y_ :int;
begin
 if dx > 0 then
  begin
   dx := 0;
   dy := -1;
   exit;
  end;
 if dx < 0 then
  begin
   dx := 0;
   dy := 1;
   exit;
  end;
 if dy > 0 then
  begin
   dy := 0;
   dx := 1;
   exit;
  end;
 if dy < 0 then
  begin
   dy := 0;
   dx := -1;
   exit;
  end;

{ x_ := -dy;
 y_ := dx;
 dx := x_;
 dy := y_;}
end;

procedure analyze;
var s :string;
    pos :int;

function rec:boolean;
var t :string;
    res :boolean;
    op :int;
    arg :boolean;
    inverse :boolean;
begin
 res := true;
 inverse := false;
 arg := false;
 op := 1;
 t := '';
 while pos <= length(s) do
  begin
   if s[pos] = ')' then
    begin
     if not (t = '') then
      begin
       if t = 'TRUE' then
        arg := true
       else if t = 'FALSE' then
        arg := false
       else arg := rg[t[1]];
      end;
     if inverse then
      arg := not arg;
     inverse := false;
     case op of
      1: res := res and arg;
      2: res := res or arg;
      3: res := res xor arg;
     end;
     break;
    end;
   if s[pos] = '(' then
    begin
     inc (pos);
     arg := rec;
     inc (pos);
     if inverse then
      arg := not arg;
     inverse := false;
     case op of
      1: res := res and arg;
      2: res := res or arg;
      3: res := res xor arg;
     end;
     op := 1;
     continue;
    end;
   if s[pos] = ' 'then
    begin
     inc (pos);
     if t = '' then
      continue;
     if  t = 'NOT' then
      inverse := not inverse
     else
     if t = 'AND' then
      op := 1
     else
     if t = 'OR' then
      op := 2
     else
     if t = 'XOR' then
      op := 3
     else
      begin
       if t = 'TRUE' then
        arg := true
       else
       if t = 'FALSE' then
        arg := false
       else
        arg := rg[t[1]];
       if inverse then
        arg := not arg;
       t := '';
       inverse := false;
       case op of
        1: res := res and arg;
        2: res := res or arg;
        3: res := res xor arg;
       end;
       op := 1;
      end;
     t := '';
     continue;
    end;
    t := t + s[pos];
    inc (pos);
  end;
 rec := res;
end;

var res :boolean;
    i,j :int;
begin
 if length (pole[x,y]^.reg) > 0 then
  begin
   for i := 1 to length (pole[x,y]^.reg) do
    rg[pole[x,y]^.reg[i]] := not rg[pole[x,y]^.reg[i]];
   exit;
  end;
 if length (pole[x,y]^.s) > 0 then
  begin
   s := pole[x,y]^.s + ' ';
   pos := 1;
   res := rec;
   if res then
    turnright
   else
    turnleft;
  end;
end;


procedure outno;
begin
 assign (output,'output.txt');
 rewrite (output);
 writeln (-1);
 close (output);
 halt;
end;

function code :int;
var res :int;
begin
 if dx > 0 then
  res := 0;
 if dy > 0 then
  res := 1;
 if dx < 0 then
  res := 2;
 if dy < 0 then
  res := 3;
 if rg['A'] then
  res := res or 4;
 if rg['B'] then
  res := res or 8;
 if rg['C'] then
  res := res or 16;
 if rg['D'] then
  res := res or 32;
 code := res;
end;

procedure solve;
var i,j :int;
    c,d :int;
begin
 ans := 0;
 while true do
  begin
   c := code;
   if (ps[x,y,c] >= 0) and not maked then
    begin
     maked := true;
     d := ans;
     k := k mod (d - ps[x,y,c]);
     ans := 0;
    end
   else
    ps[x,y,c] := ans;
   if ans = k then
    break;

   analyze;
   x := x + dx;
   y := y + dy;
   if (x > m) or (x < 1) or (y > n) or (y < 1) then
    outno;
   inc (ans);
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.