{$I+,Q+,R+,S+}
program         Template;

var
  N, M, K       : Integer;
  Words         : array[1..100] of string[3];
  F             : array[1..100] of Integer;
  Alphabet      : string;
  Max, Mx       : LongInt;
  MaxShout      : string;
  SixShout      : string;
  SixWeight     : LongInt;
  L1S, L2S      : string;
  L1W, L2W      : LongInt;
  L1R, L2R      : LongInt;
  L1SS, L2SS    : string;
  L1WW, L2WW    : LongInt;
  L1RR, L2RR    : LongInt;

procedure       OpenFiles;
begin
  Assign(Input, 'INPUT.TXT');
  Reset(Input);
  Assign(Output, 'OUTPUT.TXT');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I, Code       : Integer;
  S             : string;
begin
  ReadLn(N, M, K);
  ReadLn(Alphabet);

  for I := 1 to K do begin
    ReadLn(S);

    Words[I] := Copy(S, 1, Pos(' ', S) - 1);
    Val(Copy(S, Pos(' ', S) + 1, Length(S) - Pos(' ', S)), F[I], Code);
  end;
end;

function        Price(S: string): LongInt;
var
  I             : Integer;
  P             : LongInt;
begin
  P := 0;
  for I := 1 to K do
    if Copy(S, Length(S) - Length(Words[I]) + 1, Length(Words[I])) = Words[I] then
      Inc(P, F[I]);

  Price := P;
end;

function        MorePrice(S: string): LongInt;
var
  I             : Integer;
  P             : LongInt;
begin
  S := S + S; P := 0;
  for I := 1 to K do
    if Length(Words[I]) > 1 then begin
      if Copy(S, Length(S) div 2, Length(Words[I])) = Words[I] then
        Inc(P, F[I]);
      if Length(Words[I]) > 2 then
        if Copy(S, Length(S) div 2 - 1, Length(Words[I])) = Words[I] then
          Inc(P, F[I]);
    end;

  MorePrice := P;
end;

procedure       Rec(Shout: string; CurF: LongInt);
var
  I             : Integer;
begin
  if Length(Shout) = 6 then begin
    if CurF + MorePrice(Shout) > Max then begin
      Max := CurF + MorePrice(Shout);
      Mx := CurF;
      MaxShout := Shout;
    end;
  end else
    for I := 1 to M do
      Rec(Shout + Alphabet[I], CurF + Price(Shout + Alphabet[I]));
end;

procedure       CRec(Shout: string; CurF: LongInt);
var
  I             : Integer;
begin
  if Length(Shout) = N then begin
    if CurF  > Max then begin
      Max := CurF;
      MaxShout := Shout;
    end;
  end else
    for I := 1 to M do
      CRec(Shout + Alphabet[I], CurF + Price(Shout + Alphabet[I]));
end;

function        MuPrice(S: string): LongInt;
var
  I, L1         : Integer;
  P             : LongInt;
begin
  L1 := Length(S); S := S + SixShout; P := 0;
  for I := 1 to K do
    if Length(Words[I]) > 1 then begin
      if Copy(S, L1, Length(Words[I])) = Words[I] then
        Inc(P, F[I]);
      if Length(Words[I]) > 2 then
        if Copy(S, L1 - 1, Length(Words[I])) = Words[I] then
          Inc(P, F[I]);
    end;

  MuPrice := P;
end;

function        NuPrice(S: string): LongInt;
var
  I             : Integer;
  P             : LongInt;
begin
  S := SixShout + S; P := 0;
  for I := 1 to K do
    if Length(Words[I]) > 1 then begin
      if Copy(S, 6, Length(Words[I])) = Words[I] then
        Inc(P, F[I]);
      if Length(Words[I]) > 2 then
        if Copy(S, 5, Length(Words[I])) = Words[I] then
          Inc(P, F[I]);
    end;

  NuPrice := P;
end;

procedure       RecPart1(Shout: string; CurF: LongInt; Len: Integer);
var
  I             : Integer;
begin
  if Length(Shout) = Len then begin
    if CurF + MuPrice(Shout) > L1W then begin
      L1W := CurF + MuPrice(Shout);
      L1R := CurF;
      L1S := Shout;
    end;
  end else
    for I := 1 to M do
      RecPart1(Shout + Alphabet[I], CurF + Price(Shout + Alphabet[I]), Len);
end;

procedure       RecPart2(Shout: string; CurF: LongInt; Len: Integer);
var
  I             : Integer;
begin
  if Length(Shout) = Len then begin
    if CurF + NuPrice(Shout) > L2W then begin
      L2W := CurF + NuPrice(Shout);
      L2R := CurF;
      L2S := Shout;
    end;
  end else
    for I := 1 to M do
      RecPart2(Shout + Alphabet[I], CurF + Price(Shout + Alphabet[I]), Len);
end;

function        Dup(K: Integer; S: string): string;
var
  SS            : string;
  I             : Integer;
begin
  SS := '';
  for I := 1 to K do
    SS := SS + S;

  Dup := SS;
end;

procedure       Solve;
var
  I, J          : Integer;
begin
  if N >= 6 then begin
    Max := 0; Rec('', 0); SixShout := MaxShout; SixWeight := Max;

    L1WW := 0; L2WW := 0; L1W := 0; L2W := 0; L1RR := 0; L2RR := 0; L1R := 0; L2R := 0;
    for I := 0 to 6 do
      for J := 0 to 6 do begin
        L1W := 0; L2W := 0; L1R := 0; L2R := 0;

        if I + J = N mod 6 then begin
          if I > 0 then
            RecPart1('', 0, I);
          if J > 0 then
            RecPart2('', 0, J);
          if L1W + L2W > L1WW + L2WW then begin
            L1WW := L1W; L1SS := L1S;
            L2WW := L2W; L2SS := L2S;
            L1RR := L1R; L2RR := L2R;
          end;
        end;
      end;

    WriteLn(L1RR + (N div 6) * Mx + L2RR);
    WriteLn(L1SS + Dup(N div 6, SixShout) + L2SS);
  end else begin
    Max := 0; CRec('', 0); SixShout := MaxShout; SixWeight := Max;

    WriteLn(Max);
    WriteLn(MaxShout);
  end;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
