{.$define debug}

program template;
const
 h = 21000;
 mmax = 201000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'e.in';
 coutfile = 'e.out';
 {$endif}
type
 int = longint;
 tptr = ^tlist;
 tlist = record
  inf :int;
  num :int;
  next :tptr;
  mark :byte;
 end;
var
 n :int;
 ans :int;
 graph :array [1..h] of tptr;
 paint :array [1..h] of byte;
 enter :array [1..h] of int;
 k :int;
 d :array [1..mmax] of int;
 m :int;
 p :int;

procedure init;
var i :int;
begin
 for i := 1 to h do
  graph[i] := nil;
 ans := 0;
 fillchar (paint,sizeof(paint),0);
 fillchar (enter,sizeof(enter),0);
 fillchar (d,sizeof(d),0);
 k := 0;
 p := 0;
 randseed := 13;
end;

procedure add (var list :tptr; value :int; number :int);
var x :tptr;
begin
 new (x);
 x^.inf := value;
 x^.num := number;
 x^.mark := 0;
 x^.next := list;
 list := x;
end;

procedure readdata;
var i,j :int;
    a,b :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n,m);
 for i := 1 to m do
  begin
   readln (a,b);
   add (graph[a],b,i);
   add (graph[b],a,i);
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 for i := 1 to ans do
  write (d[i],' ');
 close (output);
end;

procedure dfs (v :int);
var x :tptr;
begin
 if paint[v] > 0 then
  exit;
 paint[v] := 1;
 inc (k);
 enter[k] := v;
 x := graph[v];
 while not (x = nil) do
  begin
   if paint[x^.inf] = 0 then
    begin
     dfs (x^.inf);
  {   if not (x^.prev = nil) then
      x^.prev^.next := x^.next
     else
      graph[v] := x^.next;
     if not (x^.next = nil) then
      x^.next^.prev := x^.prev;}
     x^.mark := 1;
    end;
   x := x^.next;
  end;
end;

procedure dfs2 (v :int);
var x :tptr;
begin
 if paint[v] > 0 then
  exit;
 paint[v] := p;
 x := graph[v];
 while not (x = nil) do
  begin
   if x^.mark = 1 then
    begin
     x := x^.next;
     continue;
    end;
   if (paint[x^.inf] > 0) then
    begin
     if paint[x^.inf] <> p then
      begin
       inc (ans);
       d[ans] := x^.num;
      end;
    end
   else
    dfs2 (x^.inf);
   x := x^.next;
  end;
end;

procedure swap (var a,b :int);
begin
 a := a xor b;
 b := a xor b;
 a := a xor b;
end;

procedure sort (l,r :int);
var i,j :int;
    x :int;
begin
 i := l;
 j := r;
 x := d[l + random(r-l+1)];
 repeat
  while d[i] < x do
   inc (i);
  while d[j] > x do
   dec (j);
  if i <= j then
   begin
    if not (i = j) then
     swap (d[i],d[j]);
    inc (i);
    dec (j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if j > l then
  sort (l,j);
end;


procedure solve;
var i,j :int;
begin
 for i := 1 to n do
  if paint[i] = 0 then
   dfs (i);
 fillchar (paint,sizeof(paint),0);
 for i := 1 to k do
  if paint[enter[i]] = 0 then
   begin
    inc (p);
    dfs2 (enter[i]);
   end;
 sort (1,ans);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.