const
     FileIn='nice.in';
     FileOut='nice.out';
     MaxM=5;
     MaxStatesCount=2*2*2*2*2;
type
    TBinMatrix=array [1..2, 1..MaxM] of Byte;
    TStates=array [0..MaxStatesCount-1] of LongInt;
var
   M, N, P: LongInt;
   Answer: LongInt;
   StatesCount: LongInt;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, M, P);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

procedure Swap (var aNum1, aNum2: LongInt);
var
   Temp: LongInt;
begin
     Temp:=aNum1;
     aNum1:=aNum2;
     aNum2:=Temp;
end;

procedure SolveFor1;
var
   I: LongInt;
begin
     Answer:=1;
     for I:=1 to N
         do Answer:=(Answer*2) mod P;
end;

function IsValidBinMatrix (const aMatrix: TBinMatrix): Boolean;
var
   Row: Byte;
begin
     for Row:=1 to M-1
         do if (aMatrix [1, Row]=aMatrix [2, Row]) and
               (aMatrix [1, Row]=aMatrix [1, Row+1]) and
               (aMatrix [1, Row]=aMatrix [2, Row+1])
               then begin
                    IsValidBinMatrix:=false;
                    Exit;
               end;
     IsValidBinMatrix:=true;
end;

function BinMatrixToNState (var aMatrix: TBinMatrix): LongInt;
begin
     BinMatrixToNState:=aMatrix [2, 1]+aMatrix [2, 2]*2+aMatrix [2, 3]*4+aMatrix [2, 4]*8+aMatrix [2, 5]*16;
end;

procedure SolveForM;
var
   States, NewStates: TStates;


procedure WorkWithState (aNState: LongInt);
var
   BinMatrix: TBinMatrix;

procedure Recursion (aRow: LongInt);
var
   Value: LongInt;
begin
     for Value:=0 to 1
         do begin
            BinMatrix [2, aRow]:=Value;
            if aRow<M
               then Recursion (aRow+1)
               else if IsValidBinMatrix (BinMatrix)
                       then Inc (NewStates [BinMatrixToNState (BinMatrix)], States [aNState]);
         end;
end;

begin
     BinMatrix [1, 1]:=aNState and 1;
     BinMatrix [1, 2]:=(aNState and 2) div 2;
     BinMatrix [1, 3]:=(aNState and 4) div 4;
     BinMatrix [1, 4]:=(aNState and 8) div 8;
     BinMatrix [1, 5]:=(aNState and 16) div 16;
     FillChar (BinMatrix [2], SizeOf (BinMatrix [2]), 0);
     Recursion (1);
end;

procedure GetNewStates;
var
   NState: LongInt;
begin
     FillChar (NewStates, SizeOf (NewStates), 0);
     for NState:=0 to StatesCount-1
         do if States [NState]<>0
               then WorkWithState (NState);
end;

var
   NState, NCol: LongInt;
begin
     for NState:=0 to StatesCount-1
         do States [NState]:=1;
     for NCol:=2 to N
         do begin
            GetNewStates;
            Move (NewStates, States, SizeOf (States));
            for NState:=0 to StatesCount-1
                do States [NState]:=States [NState] mod P;
         end;
     Answer:=0;
     for NState:=0 to StatesCount-1
         do Inc (Answer, States [NState]);
     Answer:=Answer mod P;
end;

procedure Solve;
begin
     if N<M
        then Swap (N, M);
     case M of
          1: SolveFor1;
          2: begin
                  StatesCount:=4;
                  SolveForM;
             end;
          3: begin
                  StatesCount:=8;
                  SolveForM;
             end;
          4: begin
                  StatesCount:=16;
                  SolveForM;
             end;
          5: begin
                  StatesCount:=32;
                  SolveForM;
             end;
     end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
