program NiceTables;

const
  maxn = 110; {110}
  maxq = maxn*2+2;
  s_no = 1;
  t_no = 2;

var
  m,n : integer;
  mat : array [1..maxn,1..maxn] of longint;
  r,c : array [1..maxn] of longint;
  f : array [1..maxq,1..maxq] of longint;
  big : array [1..maxq,1..maxq] of longint;
  exc : array [1..maxq] of longint;
  h : array [1..maxq] of longint;
  bad : boolean;
  bign : longint;
  current : array [1..maxq] of longint;
  listno : array [1..maxq] of longint;
  lists : array [1..maxq,1..maxq] of longint;
  lid,lin,lip : array [0..maxq] of longint;
  liy : longint;


function leftno(a : integer) : integer;
begin
  leftno := a+2;
end;

function rightno(a : integer) : integer;
begin
  rightno := a+m+2;
end;

procedure Inp;
var
  i,j : integer;
begin
  assign(input,'nice.in'); reset(input);
  assign(output,'nice.out'); rewrite(output);
  read(m,n);
  for i:=1 to m do
    read(r[i]);
  for i:=1 to n do
    read(c[i]);
  for i:=1 to m do
    for j:=1 to n do
      read(mat[i,j]);
end;

function getc(u,v : integer) : longint;
begin
  if big[u,v]<0 then getc := -1 else
    getc := big[u,v] - f[u,v];
end;

procedure push(u,v : integer);
var
  delta : longint;
begin
  delta := getc(u,v);
  if (delta < 0) or (delta > exc[u]) then
    delta := exc[u];
  exc[v] := exc[v] + delta;
  exc[u] := exc[u] - delta;
  f[u,v] := f[u,v] + delta;
  f[v,u] := f[v,u] - delta;
end;

procedure lift(u : integer);
var
  min : integer;
  i : integer;
begin
  min := 10000;
  for i:=1 to bign do
    if getc(u,i)<>0 then
      if min > h[i] then
        min := h[i];
  h[u] := min + 1;
end;

procedure Discharge(u : integer);
var
  v : integer;
begin
  while exc[u]>0 do
  begin
    v := lists[u,current[u]];
    if current[u]>listno[u] then
    begin
      lift(u);
      current[u] := 1;
    end
    else
      if (getc(u,v)<>0) and (h[u] = h[v] + 1) then
        push(u,v)
      else
        inc(current[u]);
  end;
end;

procedure Preflow_Do;
var
  i,j : integer;
  oldh : longint;
  tmp1,tmp2 : longint;
begin
  fillchar(f,sizeof(f),0);
  fillchar(h,sizeof(h),0);
  h[s_no] := bign;
  fillchar(exc,sizeof(exc),0);
  for i:=1 to bign do
  begin
    f[s_no,i] := big[s_no,i];
    f[i,s_no] := -big[s_no,i];
    exc[i] := f[s_no,i];
  end;
  fillchar(listno,sizeof(listno),0);
  for i:=1 to bign do
  begin
    current[i] := 1;
    for j:=1 to bign do
      if (big[i,j]<>0) or (big[j,i]<>0) then
      begin
        inc(listno[i]);
        lists[i,listno[i]] := j;
      end;
  end;
  for i:=1 to bign do
  begin
    lid[i] := i;
    lin[i] := i+1;
    lip[i] := i-1;
  end;
  lin[bign] := 0;
  lip[1] := 0;
  i := 1;
  liy := 1;
  while i<>0 do
  begin
    oldh := h[i];
    if (i>2) then
      discharge(i);
    if h[i]>oldh then
    begin
      tmp1 := lin[i];
      tmp2 := lip[i];
      if (tmp1<>0) then
        lip[tmp1] := tmp2;
      if (tmp2<>0) then
        lin[tmp2] := tmp1;
      lin[i] := liy;
      lip[i] := 0;
      lip[liy] := i;
      liy := i;
    end;
    i := lin[i];
  end;
end;

procedure Run;
var
  i,j : integer;
begin
  bad := false;
  for i:=1 to m do
  for j:=1 to n do
  begin
    if mat[i,j]=-1 then continue;
    r[i] := r[i] - mat[i,j];
    c[j] := c[j] - mat[i,j];
    if (r[i]<0) or (c[j]<0) then bad:=true;
  end;
  bign := 2+m+n;
  fillchar(big,sizeof(big),0);
  for i:=1 to bign do
  for j:=1 to bign do
  begin
    if i=1 then
      if (j>2) and (j<=m+2) then
        big[i,j] := r[j-2];
    if (i>2) and (i<=m+2) then
      if (j>m+2) and (mat[i-2,j-m-2]=-1) then
        big[i,j] := -1;
    if (i>m+2) then
      if j=2 then
        big[i,j] := c[i-m-2];
  end;
  if not bad then
    Preflow_Do;
  if bad then
    writeln(-1)
  else
    for i:=1 to m do
    begin
      for j:=1 to n do
      begin
        if mat[i,j]=-1 then
          write(f[leftno(i),rightno(j)],' ')
        else
          write(mat[i,j],' ');
      end;
      writeln;
    end;
end;

procedure Outp;
begin
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.
