program SquareRoot;

const
  maxl = 1000;

type
  TLong = array [1..maxl] of Byte;

var
  n : TLong;

procedure ReadLong(var a : tlong);
var
  s : array [1..maxl] of Char;
  l,i : integer;
  c : char;
begin
  fillchar(a,sizeof(a),0);
  l := 0;
  repeat
    read(c);
    if not (c in ['0'..'9']) then
      break;
    inc(l);
    s[l] := c;
  until false;
  for i:=1 to l do
    a[l+1-i] := ord(s[i]) - ord('0');
end;

procedure WriteLong(a : tlong);
var
  l,i : integer;
begin
  for l:=maxl downto 1 do
    if a[l]<>0 then
      break;
  for i:=l downto 1 do
    write(chr(a[i]+ord('0')));
end;

procedure LongMulShort(var a : tlong; b : byte);
var
  ow,tmp : integer;
  i : integer;
begin
  ow := 0;
  for i:=1 to maxl do
  begin
    tmp := ow + a[i] * b;
    ow := tmp div 10;
    a[i] := tmp mod 10;
  end;
end;

function LongDivShort(var a : tlong; b : byte) : byte;
var
  ow,tmp : integer;
  i : integer;
begin
  ow := 0;
  for i:=maxl downto 1 do
  begin
    tmp := ow*10 + a[i];
    ow := tmp mod b;
    a[i] := tmp div b;
  end;
  LongDivShort := ow;
end;

procedure LongIncLong(var a : tlong; b : tlong);
var
  ow,tmp : integer;
  i : integer;
begin
  ow := 0;
  for i:=1 to maxl do
  begin
    tmp := ow + a[i] + b[i];
    ow := tmp div 10;
    a[i] := tmp mod 10;
  end;
end;

procedure LongDecLong(var a : tlong; b : tlong);
var
  ow,tmp : integer;
  i : integer;
begin
  ow := 0;
  for i:=1 to maxl do
  begin
    tmp := a[i] - b[i] - ow;
    if tmp<0 then
      ow := 1
    else
      ow := 0;
    a[i] := tmp + 10*ow;
  end;
end;

function LongCompLong(a,b : tlong) : shortint;
var
  i : integer;
begin
  for i:=maxl downto 1 do
  begin
    if a[i]>b[i] then LongCompLong := 1;
    if a[i]<b[i] then LongCompLong := -1;
    if a[i]<>b[i] then exit;
  end;
  LongCompLong := 0;
end;

procedure Inp;
begin
  assign(input,'square.in'); reset(input);
  assign(output,'square.out'); rewrite(output);
  ReadLong(n);
end;

procedure Run;
var
  cleft,cright,cmed : tlong;
  sqleft,sqright,sqmed : tlong;
  sqdim : tlong;
  count : integer;
  i : integer;
begin
  fillchar(cleft,sizeof(cleft),0);
  fillchar(cright,sizeof(cright),0);
  cright[1] := 1;
  sqleft := cleft;
  sqright := cright;
  for count := 1 to 10000 do
  begin
    longmulshort(cright,2);
    longmulshort(sqright,4);
    if longcomplong(sqright,n)=1 then
      break;
  end;
  sqdim := sqright;
  for i := count downto 1 do
  begin
    cmed := cleft;
    longinclong(cmed,cright);
    longdivshort(cmed,2);
    sqmed := sqleft;
    longinclong(sqmed,sqright);
    longmulshort(sqmed,2);
    longdeclong(sqmed,sqdim);
    longdivshort(sqmed,4);
    if longcomplong(n,sqmed)=1 then
    begin
      cleft := cmed;
      sqleft := sqmed;
    end
    else
    begin
      cright := cmed;
      sqright := sqmed;
    end;
    longdivshort(sqdim,4);
  end;
  if longcomplong(n,sqleft)=0 then
    writelong(cleft)
  else
    if longcomplong(n,sqright)=0 then
      writelong(cright)
    else
      writeln('-1');
end;

procedure Outp;
begin
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.