{$I+,Q-,R-,S+}
program         Template;

type
  TLong         = record
    Len         : Integer;
    Digits      : array[1..150] of Word;
  end;

var
  N             : TLong;

procedure       OpenFiles;
begin
  Assign(Input, 'square.in');
  Reset(Input);
  Assign(Output, 'square.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  Temp          : TLong;
  I, J          : Integer;
  Number        : array[1..500] of Char;
  K             : Word;
begin
  FillChar(N, SizeOf(N), 0);
  while not SeekEoln do begin
    Inc(N.Len);
    Read(Number[N.Len]);
  end;

  if N.Len mod 4 <> 0 then begin
    Move(Number[1], Number[5 - N.Len mod 4], N.Len);
    FillChar(Number[1], 4 - N.Len mod 4, '0');
  end;

  if N.Len mod 4 = 0 then
    N.Len := N.Len div 4
  else
    N.Len := N.Len div 4 + 1;

  for I := 1 to N.Len do
    for J := 1 to 4 do
      N.Digits[N.Len - I + 1] := N.Digits[N.Len - I + 1] * 10 + Ord(Number[(I - 1) * 4 + J]) - 48;
end;

procedure       longAdd(A, B: TLong; var C: TLong);
var
  I             : Integer;
begin
  FillChar(C, SizeOf(C), 0);

  I := 1;
  while (I <= A.Len) or (I <= B.Len) do begin
    C.Digits[I] := C.Digits[I] + A.Digits[I] + B.Digits[I];
    C.Digits[I + 1] := C.Digits[I] div 10000;
    C.Digits[I] := C.Digits[I] mod 10000;

    Inc(I);
  end;

  if C.Digits[I] > 0 then
    C.Len := I
  else
    C.Len := I - 1;
end;

procedure       longMul(A, B: TLong; var C: TLong);
var
  I, J          : Integer;
  Temp          : LongInt;
begin
  FillChar(C, SizeOf(C), 0);
  for I := 1 to A.Len do begin
    for J := 1 to B.Len do begin
      Temp := A.Digits[I] * B.Digits[J];

      C.Digits[I + J] := C.Digits[I + J] + Temp div 10000;
      C.Digits[I + J - 1] := C.Digits[I + J - 1] + Temp mod 10000;
      C.Digits[I + J] := C.Digits[I + J] + C.Digits[I + J - 1] div 10000;
      C.Digits[I + J - 1] := C.Digits[I + J - 1] mod 10000;
    end;
  end;

  if C.Digits[A.Len + B.Len] > 0 then
    C.Len := A.Len + B.Len
  else
    C.Len := A.Len + B.Len - 1;
end;

function        longCompare(A, B: TLong): Integer;
var
  I             : Integer;
begin
  if A.Len > B.Len then begin
    longCompare := 1;
    Exit;
  end;

  if A.Len < B.Len then begin
    longCompare := -1;
    Exit;
  end;

  for I := A.Len downto 1 do begin
    if A.Digits[I] > B.Digits[I] then begin
      longCompare := 1;
      Exit;
    end;
    if A.Digits[I] < B.Digits[I] then begin
      longCompare := -1;
      Exit;
    end;
  end;

  longCompare := 0;
end;

procedure       longDiv2(A: TLong; var B: TLong);
var
  I             : Integer;
begin
  FillChar(B, SizeOf(B), 0);

  for I := A.Len downto 1 do begin
    if I > 1 then
      A.Digits[I - 1] := A.Digits[I - 1] + A.Digits[I] mod 2 * 10000;

    B.Digits[I] := A.Digits[I] div 2;
  end;

  if B.Digits[A.Len] > 0 then
    B.Len := A.Len
  else
    B.Len := A.Len - 1;
end;

procedure       longWrite(A: TLong);
var
  I             : Integer;
  S             : string;
begin
  for I := A.Len downto 1 do begin
    if I = A.Len then
      Write(A.Digits[I])
    else begin
      Str(A.Digits[I], S);
      while Length(S) < 4 do
        S := '0' + S;
      Write(S);
    end;
  end;
end;

procedure       Solve;
var
  Up, Down      : TLong;
  Window        : TLong;
  Current       : TLong;
  Square        : TLong;
  Zero          : TLong;
  One           : TLong;
  I             : Integer;
begin
  FillChar(Down, SizeOf(Down), 0); FillChar(Window, SizeOf(Window), 0);
  FillChar(Zero, SizeOf(Zero), 0); Zero.Len := 1; Zero.Digits[1] := 1;
  FillChar(One, SizeOf(One), 0); One.Len := 1; One.Digits[1] := 1;
  if N.Len > 5 then begin
    Window.Len := N.Len div 2 + 2; Window.Digits[Window.Len] := 1;
    Down.Len := N.Len div 2; Down.Digits[Down.Len] := 1;
  end else
    Window := N;

  Up := Window;
  repeat
    longDiv2(Window, Window);
    longAdd(Down, Window, Current);
    longMul(Current, Current, Square);
    case longCompare(Square, N) of
      -1:
        Down := Current;
      0: begin
        longWrite(Current);
        Exit;
      end;
      1:
        Up := Current;
    end;
  until longCompare(Window, Zero) <= 0;

  if longCompare(Square, N) = 0 then begin
    longWrite(Current);
    Exit;
  end;

  longAdd(Current, One, Current);
  longMul(Current, Current, Square);
  if longCompare(Square, N) = 0 then begin
    longWrite(Current);
    Exit;
  end;

  WriteLn('-1');
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
