{$I+,Q-,R-,S+}
program         Template;

var
  N              : LongInt;
  Perm           : array[1..100000] of LongInt;

procedure       OpenFiles;
begin
  Assign(Input, 'perm.in');
  Reset(Input);
  Assign(Output, 'perm.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : LongInt;
begin
  ReadLn(N);
  for I := 1 to N do
    Read(Perm[I]);
end;

procedure       QSort(L, R: LongInt);
var
  I, J, X, T    : LongInt;
begin
  I := L; J := R; X := Perm[(L + R) div 2];
  repeat
    while Perm[I] < X do
      Inc(I);
    while Perm[J] > X do
      Dec(J);

    if I <= J then begin
      if I < J then begin
        T := Perm[I];
        Perm[I] := Perm[J];
        Perm[J] := T;
      end;

      Inc(I);
      Dec(J);
    end;
  until I > J;

  if I < R then
    QSort(I, R);
  if L < J then
    QSort(L, J);
end;

procedure       Solve;
var
  I, J, K, M    : LongInt;
begin
  I := N;
  while (I > 1) and (Perm[I - 1] > Perm[I]) do
    Dec(I);

  if I = 1 then begin
    for I := 1 to N do
      Perm[I] := I;
  end else begin
    M := MAXLONGINT; K := N;
    for J := I + 1 to N do
      if Perm[J] < M then begin
        K := J;
        M := Perm[J];
      end;

    M := Perm[I - 1];
    Perm[I - 1] := Perm[K];
    Perm[K] := M;

    QSort(I, N);
  end;

  for I := 1 to N do begin
    Write(Perm[I]);
    if I < N then
      Write(' ')
    else
      WriteLn;
  end;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
