const
     FileIn='smooth.in';
     FileOut='smooth.out';
     MaxLevel=512;
type
    TNumber=array [0..MaxLevel] of Byte;
var
   N, Passed: Int64;
   Number: TNumber;
   SkipFunction: array [1..MaxLevel, 0..9] of Int64;
   Level: LongInt;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NDig: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for NDig:=1 to Level
         do Write (F, Number [NDig]);
     Close (F);
end;

procedure CalcSPFor (aLevel, aDigit: LongInt);
var
   SubDigit: LongInt;
begin
     for SubDigit:=aDigit to 9
         do Inc (SkipFunction [aLevel, aDigit], SkipFunction [aLevel-1, SubDigit]);
end;

procedure CalcSkipFunction;
var
   NLevel: LongInt;
   NDigit: LongInt;
begin
     FillChar (SkipFunction, SizeOf (SkipFunction), 0);
     for NDigit:=0 to 9
         do SkipFunction [1, NDigit]:=9-NDigit+1;
     for NLevel:=2 to MaxLevel
         do for NDigit:=0 to 9
                do CalcSPFor (NLevel, NDigit);
end;

function Recursion (aLevel: LongInt): Boolean;
var
   NNumber: LongInt;
begin
     for NNumber:=Number [aLevel-1] to 9
         do if (aLevel<Level) and (Passed+SkipFunction [Level-aLevel, NNumber]<N)
               then Inc (Passed, SkipFunction [Level-aLevel, NNumber])
               else if aLevel<Level
                       then begin
                            Number [aLevel]:=NNumber;
                            if Recursion (aLevel+1)
                               then begin
                                    Recursion:=true;
                                    Exit;
                               end;
                       end
                       else begin
                            Inc (Passed);
                            if Passed=N
                               then begin
                                    Number [aLevel]:=NNumber;
                                    Recursion:=true;
                                    Exit;
                               end;
                       end;
     Recursion:=false;
end;

procedure Solve;
begin
     CalcSkipFunction;
     Passed:=0;
     for Level:=1 to MaxLevel
         do begin
            FillChar (Number, SizeOf (Number), 0);
            Number [0]:=1;
            if Recursion (1)
               then Break;
         end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
