{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P+,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const infile = 'segment.in'; outfile = 'segment.out'; eps = 0.0000001;
type pt = record x,y: extended; end;
     line = record a,b,c: extended; end;
var qa,qb,qc,qd,e: pt;
    l1,l2: line;

function eq(q1,q2: pt): boolean;
begin
     eq:=(abs(q1.x-q2.x)<eps) and (abs(q1.y-q2.y)<eps);
end;

function dist(q1,q2: pt): extended;
begin
     dist:=sqrt((q1.x-q2.x)*(q1.x-q2.x)+(q1.y-q2.y)*(q1.y-q2.y));
end;

function pr(q1,q2,q3: pt): boolean;
begin
     pr:=abs(dist(q1,q3)+dist(q3,q2)-dist(q1,q2))<eps;
end;

procedure point_to_line(t1,t2: pt; var l: line);
begin
     l.a:=t2.y-t1.y;
     l.b:=t1.x-t2.x;
     l.c:=-(t1.x*l.a+t1.y*l.b);
end;

function peres(l1,l2: line; var p: pt): byte;
var dt: extended;
begin
     dt:=l1.a*l2.b-l1.b*l2.a;
     if abs(dt) < eps then begin
        if (abs(l2.a*qa.x+l2.b*qa.y+l2.c) < eps) and
           (abs(l2.a*qb.x+l2.b*qb.y+l2.c) < eps) then peres:=1
                                       else peres:=0;
     end
        else begin
             peres:=2;
             p.x:=-(l1.c*l2.b-l2.c*l1.b)/dt;
             p.y:=(l2.a*l1.c-l1.a*l2.c)/dt;
        end;
end;

procedure swap(var q1,q2: pt);
var tmp: pt;
begin
     tmp:=q1; q1:=q2; q2:=tmp;
end;

procedure peres_otr;
begin
     if qa.x-qb.x > eps then swap(qa,qb);
     if qc.x-qd.x > eps then swap(qc,qd);
     if qa.x-qc.x > eps then begin
        swap(qa,qc); swap(qb,qd); end;
     if pr(qa,qb,qc) then begin
        if pr(qa,qb,qd) then write(qc.x,' ',qc.y,' ',qd.x,' ',qd.y)
           else begin
                if eq(qc,qb) then write(qc.x,' ',qc.y)
                   else write(qc.x,' ',qc.y,' ',qb.x,' ',qb.y);
           end;
     end
        else write('Empty');
end;

begin
     assign(input,infile);
     reset(input);
     read(qa.x,qa.y,qb.x,qb.y,qc.x,qc.y,qd.x,qd.y);
     if eq(qa,qb) then begin e:=qc; qc:=qa; qa:=e;
                             e:=qd; qd:=qb; qb:=e; end;
     close(input);
     assign(output,outfile);
     rewrite(output);
     if eq(qc,qd) then begin
        if pr(qa,qb,qc) then write(qc.x,' ',qc.y)
           else write('Empty');
        close(output);
        exit;
     end;
     point_to_line(qa,qb,l1);
     point_to_line(qc,qd,l2);
     if peres(l1,l2,e) = 2 then begin write(e.x,' ',e.y); close(output); exit; end;
     if peres(l1,l2,e) = 0 then begin write('Empty'); close(output); exit; end;
     peres_otr;
     close(output);
end.

