{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const infile = 'tangent.in'; outfile = 'tangent.out'; eps = 0.0000001;
type tcircle = record a,b,r: extended; end;
     pt = record x,y: extended; end;
     line = record a,b,c: extended; end;
var q1,q2: tcircle;
    k: longint;
    tmp,l1,l2,l3,l4,l5,l6: line;

procedure init;
begin
     assign(input,infile);
     reset(input);
     read(q1.a,q1.b,q1.r);
     read(q2.a,q2.b,q2.r);
     close(input);
end;

procedure rot(q,t: pt; ang: extended; var nn: pt);
var w,nw: pt;
begin
     w.x:=t.x-q.x; w.y:=t.y-q.y;
     nw.x:=w.x*cos(ang)-w.y*sin(ang);
     nw.y:=w.x*sin(ang)+w.y*cos(ang);
     nn.x:=nw.x+q.x; nn.y:=nw.y+q.y;
end;

function arcsin(p: extended): extended;
begin
     arcsin:=ArcTan (p/sqrt (1-sqr (p)));
end;

procedure point_to_line(t1,t2: pt; var l: line);
begin
     l.a:=t2.y-t1.y;
     l.b:=t1.x-t2.x;
     l.c:=-(t1.x*l.a+t1.y*l.b);
end;

procedure par(l1: line; t: pt; var l2: line);
begin
     l2.a:=l1.a; l2.b:=l1.b;
     l2.c:=-(l2.a*t.x+l2.b*t.y);
end;

function ans(q1,q2: tcircle): longint;
var d,p,k: extended;
    p1,p2: pt;
begin
     if abs(q1.a-q2.a) < eps then begin
        if abs(q1.b-q2.b) < eps then begin
           if abs(q1.r-q2.r) < eps then ans:=-1
              else ans:=0;
           exit;
        end;
        p1.y:=(q1.r*q1.r-q2.r*q2.r+q2.b*q2.b-q1.b*q1.b)/(2*(q2.b-q1.b));
        p2.y:=p1.y;
        d:=q1.r*q1.r-(p1.y-q1.b)*(p1.y-q1.b);
        if (d > eps) then begin
           ans:=2;
           p1.x:=q1.a+sqrt(d);
           p2.x:=q1.a-sqrt(d);
        end
           else if (abs(d) < eps) then begin
           ans:=1; p1.x:=q1.a;
        end
           else ans:=0;
     end
        else begin
        p:=(q1.r*q1.r-q2.r*q2.r+q2.b*q2.b+q2.a*q2.a-q1.a*q1.a-q1.b*q1.b)/(2*(q2.a-q1.a));
        k:=(q1.b-q2.b)/(q2.a-q1.a);
        d:=(p*k-q1.a*k-q1.b); d:=d*(p*k-q1.a*k-q1.b);
        d:=d-(k*k+1)*(p*p+q1.a*q1.a+q1.b*q1.b-2*p*q1.a-q1.r*q1.r);
        if d < -eps then begin ans:=0; exit; end;
        if abs(d) < eps then begin
           ans:=1;
           p1.y:=-(p*k-q1.a*k-q1.b)/(k*k+1);
           p1.x:=p1.y*k+p;
           exit;
        end;
        ans:=2;
        p1.y:=(-sqrt(d)-(p*k-q1.a*k-q1.b))/(k*k+1);;
        p2.y:=(sqrt(d)-(p*k-q1.a*k-q1.b))/(k*k+1);;
        p1.x:=p+k*p1.y;
        p2.x:=p+k*p2.y;
     end;
end;

procedure solve;
var ang,rast: extended;
    z1,z2,ss: pt;
    c: tcircle;
begin
     rast:=sqrt(sqr(q1.a-q2.a)+sqr(q1.b-q2.b));
     ang:=arcsin((q1.r+q2.r)/rast);
     z1.x:=q1.a; z1.y:=q1.b;
     z2.x:=q2.a; z2.y:=q2.b;

     rot(z1,z2,ang,ss);
     point_to_line(z1,ss,tmp);
     ss.x:=z2.x+(z1.x-z2.x)*q2.r/(q1.r+q2.r);
     ss.y:=z2.y+(z1.y-z2.y)*q2.r/(q1.r+q2.r);
     par(tmp,ss,l1);

     rot(z1,z2,-ang,ss);
     point_to_line(z1,ss,tmp);
     ss.x:=z2.x+(z1.x-z2.x)*q2.r/(q1.r+q2.r);
     ss.y:=z2.y+(z1.y-z2.y)*q2.r/(q1.r+q2.r);
     par(tmp,ss,l2);

     if q1.r-q2.r > eps then begin
        c:=q1; q1:=q2; q2:=c; end;

     ang:=arcsin((q2.r-q1.r)/rast);
     z1.x:=q1.a; z1.y:=q1.b;
     z2.x:=q2.a; z2.y:=q2.b;

     rot(z1,z2,ang,ss);
     point_to_line(z1,ss,tmp);
     ss.x:=z2.x+(z1.x-z2.x)*q2.r/(q2.r-q1.r);
     ss.y:=z2.y+(z1.y-z2.y)*q2.r/(q2.r-q1.r);
     par(tmp,ss,l3);

     rot(z1,z2,-ang,ss);
     point_to_line(z1,ss,tmp);
     ss.x:=z2.x+(z1.x-z2.x)*q2.r/(q2.r-q1.r);
     ss.y:=z2.y+(z1.y-z2.y)*q2.r/(q2.r-q1.r);
     par(tmp,ss,l4);
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     if ans(q1,q2) = 0 then begin
        writeln(4);
        writeln(l1.a,' ',l1.b,' ',l1.c);
        writeln(l2.a,' ',l2.b,' ',l2.c);
        writeln(l3.a,' ',l3.b,' ',l3.c);
        write(l4.a,' ',l4.b,' ',l4.c);
     end
        else begin
             if ans(q1,q2) = -1 then begin
                write(-1);
                close(output);
                exit;
             end;
             if ans(q1,q2) = 1 then begin
                writeln(3);
        writeln(l1.a,' ',l1.b,' ',l1.c);
        writeln(l2.a,' ',l2.b,' ',l2.c);
        write(l3.a,' ',l3.b,' ',l3.c);
        close(output); exit;
             end;
             writeln(2);
        writeln(l1.a,' ',l1.b,' ',l1.c);
        write(l2.a,' ',l2.b,' ',l2.c);
        end;
     close(output);
end;

begin
     init;
     if (ans(q1,q2) >= 0) then
        solve;
     done;
end.