const eps = 1E-10;

var x1, y1, r1, x2, y2, r2: double;
    k: integer;
    px1, py1, px2, py2: double;


function dist(x1,y1,x2,y2:double):double;
begin
  dist:=sqrt(sqr(x1-x2)+sqr(y1-y2));
end;

function FlCmp(a,b: double):integer; {0: A=B -1: A<B 1:A>B}
begin
  if a-b>eps then FlCmp:=1 else
    if b-a>eps then FlCmp:=-1 else
      FlCmp:=0;
end;

function min(a,b: double):double;
Begin
  if flcmp(a,b)=-1 then min:=a else min:=b;
end;

function max(a,b: double):double;
Begin
  if flcmp(a,b)=1 then max:=a else max:=b;
end;

procedure Solve;
var t,dis: double;
begin
  if (x1=x2) and (y1=y2) and (r1=r2) then begin
    k:=-1;
    exit;
  end;
  dis:=dist(x1,y1,x2,y2);
  if flcmp(dis,r1+r2)=1 then begin
    k:=0;
    exit;
  end;
  if (flcmp(dis+r2,r1)=-1) or (flcmp(dis+r1,r2)=-1) then begin
    k:=0;
    exit;
  end;
  if flcmp(dis,r1+r2)=0 then begin
    k:=1;
    t:=r1/dis;
    px1:=abs(x2-x1)*t+min(x1,x2);
    py1:=abs(y2-y1)*t+min(y1,y2);
    exit;
  end;

end;

procedure Save;
var f: text;
begin
  Assign(f,'circles.out');
  Rewrite(f);
  writeLn(f,k);
  if k=1 then writeLn(f,px1:6:6,' ',py1:6:6);
  if k=2 then begin
    writeLn(f,px1:6:6,' ',py1:6:6);
    writeLn(f,px2:6:6,' ',py2:6:6);
  end;
  Close(f);
end;

procedure Load;
var f: text;
begin
  Assign(f,'circles.in');
  reset(f);
  Read(f,x1,y1,r1,x2,y2,r2);
  Close(f);
end;

Begin
  Load;
  Solve;
  Save;
End.
