#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define eps 1e-9

struct POINT {
  long x,y;
};

struct POINTF {
  double x,y;
};

struct LINE {
  long a,b,c;
};

struct CIRC {
  long x,y,r;
};

FILE *fi, *fo;
CIRC w1,w2;
LINE l;
POINTF pl;
POINTF v;
double d;

void GetLine(POINT a, POINT b, LINE *p)
{
  p->a=b.y-a.y;
  p->b=a.x-b.x;
  p->c=a.y*b.x-a.x*b.y;
}

void GetPoint(POINT *p)
{
  fscanf(fi,"%li%li",&p->x,&p->y);
}

void GetCircl(CIRC *p)
{
  fscanf(fi,"%li%li%li",&p->x,&p->y,&p->r);
}

void GetPointL(LINE l,POINTF *p)
{
  if(l.b!=0)
  {
    p->x=0;
    p->y=-(double)l.c/l.b;
  }
  else
  {
    p->y=0;
    p->x=-(double)l.c/l.a;
  }
}

long ff(LINE l, POINT p)
{
  return l.a*p.x+l.b*p.y+l.c;
}

int cmp(POINT a, POINT b)
{
  if(a.x>b.x) return 1;
  if(b.x>a.x) return -1;
  if(a.y>b.y) return 1;
  if(a.y<b.y) return -1;
  return 0;
}

double ll(double x1,double y1,double x2,double y2)
{
  return sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
}

int main()
{
  double xx,yy;
  double aa,bb,cc;
  double t1,t2;
  POINTF r1,r2;
  fi=fopen("circles.in","rt");
  fo=fopen("circles.out","wt");

  GetCircl(&w1);
  GetCircl(&w2);

  if((w1.x==w2.x)&&(w1.y==w2.y))
  {
    if(w1.r==w2.r)
    {
      fprintf(fo,"-1\n");
    }
    else
    {
      fprintf(fo,"0\n");
    }
    fclose(fi);
    fclose(fo);
    return 0;
  }

  d=ll(w1.x,w1.y,w2.x,w2.y);
  if(d<fabs((double)w2.r-w1.r)-eps)
  {
    fprintf(fo,"0\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(d>fabs((double)w2.r+w1.r)+eps)
  {
    fprintf(fo,"0\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }

  l.a=2*(w2.x-w1.x);
  l.b=2*(w2.y-w1.y);
  l.c=w1.x*w1.x+w1.y*w1.y+w2.r*w2.r-w2.x*w2.x-w2.y*w2.y-w1.r*w1.r;
  GetPointL(l,&pl);
  v.x=-l.b;
  v.y=l.a;

  xx=pl.x-(double)w1.x;
  yy=pl.y-(double)w1.y;
  aa=v.x*v.x+v.y*v.y;
  bb=2.0*(xx*v.x+yy*v.y);
  cc=xx*xx+yy*yy-(double)w1.r*w1.r;

  d=bb*bb-4.0*aa*cc;
  if(d<-eps)
  {
    fprintf(fo,"0\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(d>eps)
  {
    t1=(-bb+sqrt(d))/(2.0*aa);
    t2=(-bb-sqrt(d))/(2.0*aa);
    r1.x=(pl.x+v.x*t1);
    r1.y=(pl.y+v.y*t1);
    r2.x=(pl.x+v.x*t2);
    r2.y=(pl.y+v.y*t2);
    fprintf(fo,"2\n");
    fprintf(fo,"%0.6lf %0.6lf\n",r1.x,r1.y);
    fprintf(fo,"%0.6lf %0.6lf\n",r2.x,r2.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(fabs(d)<eps)
  {
    t1=-bb/(2.0*aa);
    r1.x=(pl.x+v.x*t1);
    r1.y=(pl.y+v.y*t1);
    fprintf(fo,"1\n");
    fprintf(fo,"%0.6lf %0.6lf\n",r1.x,r1.y);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
