const
  eps=10e-8;

type
  tpoint=record
    x,y:extended;
  end;

var
  a,b,c,d:tpoint;

procedure OpenFiles;
begin
  assign(input,'segment.in');
  assign(output,'segment.out');
  reset(input);
  rewrite(output);
end;

procedure CloseFiles;
begin
  close(input);
  close(output);
end;

function f(a,b,c:tpoint):extended;
begin
  f:=(c.x-a.x)*(b.y-a.y)-(b.x-a.x)*(c.y-a.y);
end;

procedure dih;
var
  x,up,down:tpoint;
  k,k1,k2:extended;

begin
  up:=a;
  down:=b;
  k:=f(c,d,up);
  k1:=f(c,d,down);
  x.x:=(up.x+down.x)/2;
  x.y:=(up.y+down.y)/2;
  while abs(f(c,d,x))>eps do
  begin
    k2:=f(c,d,x);
    if k2*k>0 then
    begin
      k:=k2;
      up:=x;
    end
    else
    begin
      k1:=k2;
      down:=x;
    end;
    x.x:=(up.x+down.x)/2;
    x.y:=(up.y+down.y)/2;
  end;
  write(x.x:0:6,' ',x.y:0:6);
end;

function rv(a,b:tpoint):boolean;
begin
  rv:=(a.x=b.x)and(a.y=b.y);
end;

procedure Solve;
var
  k,k1:extended;
  l:boolean;

begin
  read(a.x,a.y,b.x,b.y,c.x,c.y,d.x,d.y);
  k:=f(a,b,c);
  k1:=f(a,b,d);
  if (abs(k)<eps)and(abs(k1)<eps) then
  begin
    l:=true;
    if ((a.x<c.x)and(a.x>d.x))or((a.x>c.x)and(a.x<d.x))or(rv(a,c))or(rv(a,d)) then
    begin
      write(a.x:0:6,' ',a.y:0:6,' ');
      l:=false;
    end;
    if ((b.x<c.x)and(b.x>d.x))or((b.x>c.x)and(b.x<d.x))or(((rv(b,c))or(rv(b,d)))and(not rv(a,b))) then
    begin
      write(b.x:0:6,' ',b.y:0:6,' ');
            l:=false;
    end;
    if ((c.x<a.x)and(c.x>b.x))or((c.x>a.x)and(c.x<b.x)) then
    begin
      write(c.x:0:6,' ',c.y:0:6,' ');
            l:=false;
    end;
    if ((d.x<a.x)and(d.x>b.x))or((d.x>a.x)and(d.x<b.x)) then
    begin
      write(d.x:0:6,' ',d.y:0:6);
            l:=false;
    end;
    if l then
      write('Empty');
    exit;
  end;
  if k*k1>0 then
  begin
    writeln('Empty');
    exit;
  end;
  k:=f(c,d,a);
  k1:=f(c,d,b);
  if k*k1>0 then
  begin
    writeln('Empty');
    exit;
  end;
  dih;
end;

begin
  OpenFiles;
  Solve;
  CloseFiles;
end.
