{$I-,Q-,R-,S-}
const
  inputfile = 'segment.in';
  outputfile = 'segment.out';
  maxn = 101;
  eps = 1e-8;

type
  real = double;
  int = longint;
  bool = boolean;
  tpoint = record
    x, y: real;
  end;
  tline = record
    a, b, c: real;
  end;

var
  i, m, a: int;
  g, t: array[1..4]of tpoint;
  l: array[1..2]of tline;
  lf, r: tpoint;
  d: array[1..4]of bool;

function realeq(a, b: real): bool;
begin
  realeq := abs(a - b) < eps;
end;

function realmore(a, b: real): bool;
begin
  realmore := a - b > eps;
end;

procedure norm(var l: tline);
var
  d: real;
begin
  d := sqrt(sqr(l.a) + sqr(l.b));
  if(realmore(d, 0.0))then begin
    if(realmore(0.0, l.a))then
      d := -d;
    l.a := l.a / d;
    l.b := l.b / d;
    l.c := l.c / d;
  end;
end;

procedure getlinebypoints(var t1, t2: tpoint; var l: tline);
begin
  l.a := t2.y - t1.y;
  l.b := t1.x - t2.x;
  l.c := t2.x * t1.y - t1.x * t2.y;
end;

function getcrosslines(var l1, l2: tline; var t: tpoint): int;
var
  det, detx, dety: real;
begin
  det := l1.a * l2.b - l2.a * l1.b;
  detx := l1.c * l2.b - l2.c * l1.b;
  dety := l1.a * l2.c - l2.a * l1.c;
  if(not realeq(det, 0.0))then begin
    getcrosslines := 0;
    t.x := - detx / det;
    t.y := -dety / det;
  end else begin
    if(realeq(detx, 0.0)or(realeq(dety, 0.0)))then
      getcrosslines := 2
    else
      getcrosslines := 1;
  end;
end;

function pointinotr(var t, tb, te: tpoint): bool;
begin
  pointinotr := false;
  if((tb.x - eps < t.x)and(t.x < te.x + eps))or((te.x - eps < t.x)and(t.x < tb.x + eps))then
    if((tb.y - eps < t.y)and(t.y < te.y + eps))or((te.y - eps < t.y)and(t.y < tb.y + eps))then
      pointinotr := true;
end;

function min(a, b: real): real;
begin
  if(a< b)then
    min := a
  else
    min := b;
end;

function max(a, b: real): real;
begin
  if(a > b)then
    max := a
  else
    max := b;
end;

function pointeq(var t1, t2: tpoint): bool;
begin
  pointeq := realeq(t1.x, t2.x)and realeq(t1.y, t2.y);
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  for i := 1 to 4 do
    read(t[i].x, t[i].y);
  for i := 1 to 2 do begin
    getlinebypoints(t[i * 2 - 1], t[i * 2], l[i]);
    norm(l[i])
  end;


  if(pointeq(t[1], t[2]))and(pointeq(t[3], t[4]))then begin
    if(pointeq(t[1], t[3]))then
      write(t[1].x:0:8, ' ', t[2].y:0:8)
    else
      write('Empty');
    close(output);
    close(input);
    halt(0);
  end;
  if(pointeq(t[1], t[2]))then begin
    if(abs(l[2].a * t[1].x + l[2].b * t[1].y + l[2].c) < eps)then
      if(pointinotr(t[1], t[3], t[4]))then
        write(t[1].x:0:8, ' ', t[1].y:0:8)
      else
        write('Empty')
    else
      write('Empty');
    close(output);
    halt(0);
  end;
  if(pointeq(t[3], t[4]))then begin
    if(abs(l[1].a * t[3].x + l[1].b * t[3].y + l[1].c) < eps)then
      if(pointinotr(t[3], t[1], t[2]))then
        write(t[3].x:0:8, ' ', t[3].y:0:8)
      else
        write('Empty')
    else
      write('Empty');
    close(output);
    halt(0);
  end;

  m := getcrosslines(l[1], l[2], lf);
  case m of
    0: begin
      a := 1;
      if(pointinotr(lf, t[1], t[2]))then
        if(pointinotr(lf, t[3], t[4]))then
          a := 0;
    end;
    1: begin
      a := 1;
    end;
    2: begin
      a := 1;
      d[1] := pointinotr(t[1], t[3], t[4]);
      d[2] := pointinotr(t[2], t[3], t[4]);
      d[3] := pointinotr(t[3], t[1], t[2]);
      d[4] := pointinotr(t[4], t[1], t[2]);

      if(d[1])and(d[2])then begin
        a := 2;
        lf := t[1];
        r := t[2];
      end;
      if(d[3])and(d[4])then begin
        a := 2;
        lf := t[3];
        r := t[4];
      end;
      for i := 1 to 2 do
        if(not d[2 * i - 1])and(d[2 * i])then begin
          d[2 * i - 1] := true;
          t[2 * i - 1] := t[2 * i];
        end;
      if(d[1])then begin
        if(not pointeq(t[1], t[3]))then begin
          a := 2;
          lf := t[1];
          r := t[3];
        end else  begin
          a := 1;
          r := t[1];
        end;
      end;
    end;
  end;
  if(a = 2)then
    if(pointeq(lf, r))then
      a := 0;
  case a of
    0: write(lf.x:0:8, ' ', lf.y:0:8);
    1: write('Empty');
    2: write(lf.x:0:8, ' ', lf.y:0:8, ' ', r.x:0:8, ' ', r.y:0:8);
  end;
  close(output);
  close(input);
end.