{$I-,Q-,R+,S+}
const
     FileIn='chess.in';
     FileOut='chess.out';
     MaxN=12;
     MaxQ=MaxN*MaxN;
     MaxC=MaxN*MaxN;
type
    TPoint=record
                 X, Y: Byte;
           end;
var
   N, Q, C: LongInt;
   Answer: LongInt;
   UsedHs, UsedVs: array [1..MaxN] of Boolean;
   UsedDs, UsedBkDs: array [-MaxN*2..MaxN*2] of Boolean;
   QueensUsed, CastlesUsed: LongInt;
   Poss: array [0..MaxC+MaxQ] of TPoint;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, Q, C);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

procedure RecursionC; forward;

procedure RecursionQ;
var
   X, Y: LongInt;
begin
     Inc (QueensUsed);
     for X:=Poss [QueensUsed+CastlesUsed-1].X to N
         do if not UsedVs [X]
               then for Y:=1 to N
                        do if not (UsedHs [Y] or UsedDs [X-Y] or UsedBkDs [X+Y])
                              then if (CastlesUsed=C) and (QueensUsed=Q)
                                      then Inc (Answer)
                                      else begin
                                           UsedHs [Y]:=true;
                                           UsedVs [X]:=true;
                                           UsedDs [X-Y]:=true;
                                           UsedBkDs [X+Y]:=true;
                                           Poss [QueensUsed+CastlesUsed].X:=X;
                                           Poss [QueensUsed+CastlesUsed].Y:=Y;
                                           if QueensUsed<Q
                                              then RecursionQ;
                                           if CastlesUsed<C
                                              then RecursionC;
                                           UsedHs [Y]:=false;
                                           UsedVs [X]:=false;
                                           UsedDs [X-Y]:=false;
                                           UsedBkDs [X+Y]:=false;
                                      end;
     Dec (QueensUsed);
end;

procedure RecursionC;
var
   X, Y: LongInt;
begin
     Inc (CastlesUsed);
     for X:=Poss [CastlesUsed+QueensUsed-1].X to N
         do if not UsedVs [X]
               then for Y:=1 to N
                        do if not (UsedHs [Y] or UsedDs [X-Y] or UsedBkDs [X+Y])
                              then if (CastlesUsed=C) and (QueensUsed=Q)
                                      then Inc (Answer)
                                      else begin
                                           UsedHs [Y]:=true;
                                           UsedVs [X]:=true;
                                           Poss [CastlesUsed+QueensUsed].X:=X;
                                           Poss [CastlesUsed+QueensUsed].Y:=Y;
                                           if QueensUsed<Q
                                              then RecursionQ;
                                           if CastlesUsed<C
                                              then RecursionC;
                                           UsedHs [Y]:=false;
                                           UsedVs [X]:=false;
                                      end;
     Dec (CastlesUsed);
end;

procedure Solve;
begin
     Answer:=0;
     FillChar (UsedHs, SizeOf (UsedHs), false);
     FillChar (UsedVs, SizeOf (UsedVs), false);
     FillChar (UsedDs, SizeOf (UsedDs), false);
     Poss [0].X:=1;
     Poss [0].Y:=1;
     QueensUsed:=0;
     CastlesUsed:=0;
     if Q+C<=N
        then begin
             if Q>0
                then RecursionQ;
             if C>0
                then RecursionC;
        end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
