{$I-,Q-,R-,S-}
const
  inputfile = 'input.txt';
  outputfile = 'output.txt';
  eps = 1e-7;
  md = 11111;
  maxn = 5101;

type
  real = double;
  int = longint;
  bool = boolean;
  tpoint = record
    x, y: int;
  end;
  pnode = ^tnode;
  tnode = record
    used: bool;
    v: int;
    next, a: pnode;
  end;
  pd = ^td;
  td = record
    n: int;
    next: pd;
  end;

var
  min, j, n, count, i, vb, ve, amount, am, count_of_grp: int;
  t: array[1..maxn * 2]of tpoint;
  g: array[1..maxn * 2]of pnode;
  used, us: array[1..maxn * 2]of bool;
  par, pr, st: array[1..maxn * 2]of int;
  b, e, sum: tpoint;
  s: array[1..maxn * 3]of real;
  th: array[0..md]of pd;

function pointeq(var t1, t2: tpoint): bool;
begin
  pointeq := (abs(t1.x - t2.x) < eps) and (abs(t1.y - t2.y) < eps);
end;

function getnum(p: tpoint): int;
var
  i, y: int;
  d: pd;
begin
  y := (md + ((p.x * 1000 mod md + p.y)mod md)) mod md;
  d := th[y];
  while(d <> nil)do begin
    if(pointeq(t[d^.n], p))then begin
      getnum := d^.n;
      exit;
    end;
    d := d^.next;
  end;
  if(d = nil)then begin
    inc(count);
    getnum := count;
    t[count] := p;
    new(d);
    d^.next := th[y];
    d^.n := count;
    th[y] := d;
  end;
end;

procedure addrebro(a, b: int);
var
  da, db: pnode;
begin
  new(da);
  new(db);

  da^.next := g[a];
  da^.used := false;
  da^.a := db;
  da^.v := b;
  g[a] := da;

  db^.next := g[b];
  db^.used := false;
  db^.a := da;
  db^.v := a;
  g[b] := db;
end;

procedure check(bg, ed: int);
var
  a, b, cnt1, cnt2: int;
  sq: real;
  o1, o2: array[1..maxn * 2]of int;
begin
  a := bg;
  b := ed;
  cnt1 := 0;
  cnt2 := 0;

  sq := 0;
  while(a <> b)and(par[a] <> b)and(par[b] <> a)do begin
    inc(cnt1);
    o1[cnt1] := a;
    inc(cnt2);
    o2[cnt2] := b;
    a := par[a];
    b := par[b];
  end;

  inc(cnt1);
  o1[cnt1] := a;
  if(a <> b)then begin
    inc(cnt2);
    o2[cnt2] := b;
  end;

  for i := 1 to cnt2 do
    o1[cnt1 + i] := o2[cnt2 - i + 1];

  cnt1 := cnt1 + cnt2;
  o1[cnt1 + 1] := o1[1];

  for i := 1 to cnt1 do
    sq := sq + t[o1[i]].x * t[o1[i + 1]].y - t[o1[i]].y * t[o1[i + 1]].x;

  inc(amount);
  s[amount] := abs(sq / 2.0);
end;

procedure deleterebro(var p: pnode);
var
  d: pnode;
begin
  p^.used := true;
  d := p^.a;
  d^.used := true;
end;

procedure wfs;
var
  d: pnode;
  down, up, cur, x: int;
  turn: array[1..maxn * 2]of int;
begin
  for i := 1 to count_of_grp do begin
    down := 1;
    up := 2;
    turn[down] := st[i];
    used[st[i]] := true;
    while(down < up)do begin
      cur := turn[down];
      d := g[cur];
      while(d <> nil)do begin
        if(not d^.used)and(not used[d^.v])then begin
          used[d^.v] := true;
          par[d^.v] := cur;
          deleterebro(d);
          turn[up] := d^.v;
          inc(up);
        end else begin
          if(not d^.used)then begin
            deleterebro(d);
            check(cur, d^.v);
          end;
        end;
        d := d^.next;
      end;
      inc(down);
    end;
  end;
end;

procedure dfs(v: int);
var
  d: pnode;
begin
  inc(am);
  pr[am] := v;
  sum.x := sum.x + t[v].x;
  sum.y := sum.y + t[v].y;
  us[v] := true;
  d := g[v];
  while(d <> nil)do begin
    if(not us[d^.v])then
      dfs(d^.v);
    d := d^.next;
  end;
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);

  read(n);
  for i := 1 to n do begin
    read(b.x, b.y, e.x, e.y);
    vb := getnum(b);
    ve := getnum(e);
    addrebro(vb, ve);
  end;

  for i := 1 to count do begin
    if(not us[i])then begin
      inc(count_of_grp);
      am := 0;
      dfs(i);
      min := 1;
      sum.x := sum.x div am;
      sum.y := sum.y div am;
      for j := 2 to am do
        if(abs(sum.x - t[pr[j]].x) + abs(sum.y - t[pr[j]].y) < abs(sum.x - t[pr[min]].x) + abs(sum.y - t[pr[min]].y))then
          min := j;
    end;
    st[count_of_grp] := pr[min];
  end;

  fillchar(used, sizeof(used), 0);
  wfs;

  writeln(amount);
  for i := 1 to amount do
    writeln(s[i]:0:5);

  close(output);
  close(input);
end.

{
10
9 1 10 2
5 1 8 5
1 1 5 1
9 1 11 1
1 5 5 1
11 1 10 2
1 5 8 5
1 1 1 5
100 100 200 200
200 200 300 300


8
0 0 1 1
1 0 0 0
1 1 1 0
0 2 0 0
0 2 1 1
0 2 -2 2
-2 2 -2 0
-2 0 0 0


3
0 0 1 1
1 1 4 5
3 2 10 1


}