#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

#define EPS ((long double)1e-9)

struct TVertice {
  long m;
  long*e;
  long double*f;
  int*h;
  int c;
  long double a,b;
  int A,B,s;
};
class TGraph {
  private:
    int*b,*c;
    void deeptravel(long);
    void deepsearch(long,long);
  public:
    long n;
    TVertice*a;
    TGraph(void);
    ~TGraph();
    void relay(void);
    void get(FILE*);
    void put(FILE*);
    void process(void);
};

TGraph*g;

int main(void) {
  g=new TGraph;
  fi=fopen("math.in","rt");
  g->get(fi);
  fclose(fi);
  g->process();
  fo=fopen("math.out","wt");
  g->put(fo);
  fclose(fo);
  delete g;
  return(0);
}


void TGraph::deepsearch(long u,long w) {
  long i,v;
  TVertice z;
  b[u]++;
  for (i=0; i<a[u].m; i++) {
    v=a[u].e[i];
    if (b[v]<=0) {
      a[v].c=1;
      if (!a[u].h[i]) {
        a[v].a=a[u].a*a[u].e[i];
        a[v].b=a[u].b*a[u].e[i];
        a[v].A=a[u].A; a[v].B=a[u].B;
        a[v].s=a[u].s;
      } else {
        a[v].a=a[u].b*a[u].e[i];
        a[v].b=a[u].a*a[u].e[i];
        a[v].A=a[u].B; a[v].B=a[u].A;
        a[v].s=!a[u].s;
      }
      deepsearch(v,w);
    } else if (v==w) {
      if (!a[u].h[i]) {
        z.a=a[u].a*a[u].e[i];
        z.b=a[u].b*a[u].e[i];
        z.A=a[u].A; z.B=a[u].B;
        z.s=a[u].s;
      } else {
        z.a=a[u].b*a[u].e[i];
        z.b=a[u].a*a[u].e[i];
        z.A=a[u].B; z.B=a[u].A;
        z.s=!a[u].s;
      }

    }
  }
}
void TGraph::deeptravel(long u) {
  long i,v;
  c[u]++; a[u].c++;
  for (i=0; i<a[u].m; i++) {
    v=a[u].e[i];
    if (c[v]<=0) deeptravel(v);
  }
}

TGraph::TGraph(void) {
  a=0;
  b=c=0;
}
TGraph::~TGraph() {
  relay();
}
void TGraph::relay(void) {
  long i;
  if (a) {
    for (i=0; i<n; i++) {
      if (a[i].e) delete[]a[i].e;
      if (a[i].f) delete[]a[i].f;
      if (a[i].h) delete[]a[i].h;
    } delete[]a; a=0;
  }
  if (b) delete[]b;
  if (c) delete[]c;
}
void TGraph::get(FILE*f) {
  relay();
  long i,j;
  char str[256];
  long double zzz;
  fscanf(f,"%ld",&n);
  a=new TVertice[n];
  for (i=0; i<n; i++) {
    fscanf(f,"%ld",&a[i].m);
    a[i].e=new long[a[i].m];
    a[i].f=new long double[a[i].m];
    a[i].h=new int[a[i].m];
    for (j=0; j<a[i].m; j++) {
      fscanf(f,"%s%Lf%ld",str,&zzz,&a[i].e[j]);
      a[i].e[j]--;
      if (zzz>=0) a[i].h[j]=0; else { a[i].h[j]=1; zzz=-zzz; }
      if (str[0]!='/') a[i].f[j]=zzz; else a[i].f[j]=((long double)1)/zzz;
    }
    a[i].c=0;
  }
  b=new int[n]; c=new int[n];
}
void TGraph::put(FILE*f) {
  long i;
  for (i=0; i<n; i++) if (a[i].c) fprintf(f,"INF\n");
  else fprintf(f,"NONE\n");
}
void TGraph::process(void) {
  long i;
  for (i=1; i<n; i++) a[i].c=0;
  a[0].c=1;
  a[0].a=a[0].b=1;
  a[0].A=a[0].B=a[0].s=0;
  memset(c,0,n*sizeof(int));
  deeptravel(0);
}

