#include <stdio.h>
#include <string.h>

FILE*fi,*fo;


struct TPoint {
  int p;
  int*s;
  int l;
};
struct TRule {
  int*r0,*r1;
  int l0,l1;
};
class TGraph {
  private:
    TPoint*q;
    int*p,*e;
    int l,h;
    void seek(int);
  public:
    int n,m,N,M,c;
    int**a,*b;
    TRule*r;
    TGraph(void);
    ~TGraph();
    void relay(void);
    void get(FILE*);
    void put(FILE*);
    void travel(void);
};

TGraph*g;

int main(void) {
  g=new TGraph;
  fi=fopen("comm.in","rt");
  g->get(fi);
  fclose(fi);
  g->travel();
  fo=fopen("comm.out","wt");
  g->put(fo);
  fclose(fo);
  delete g;
  return(0);
}


void TGraph::seek(int u) {
  int I,i,j,v,w,t,t0,t1,z,y;
  q[l].p=u; q[l].s[0]=u; q[l].l=1; e[u]=l;
  p[(h)%N]=l++;
  for (I=h++; I<h; I++) {
    i=p[I%N];
    v=q[i].p;
    for (w=0; w<n; w++) if (a[v][w]>=0) {
      if (e[w]<0) {
        q[l].p=w;
        memmove(q[l].s,q[i].s,q[i].l*sizeof(int));
        q[l].s[q[i].l]=w;
        q[l].l=q[i].l+1;
        e[w]=l;
        p[(h++)%N]=l++;
      } else {
        j=e[w];
        if (q[i].s[0]!=q[e[w]].s[0]) {
          /*
          q[j].p=w;
          memmove(q[j].s,q[i].s,q[i].l*sizeof(int));
          q[j].s[q[i].l]=w;
          q[j].l=q[i].l+1;
          p[(h++)%N]=j;
          */
        } else {
          q[i].s[q[i].l]=w;
          for (t0=0,t1=0; (t0<q[i].l)&&(t1<q[j].l-1); ) {
            if (a[q[i].s[t0]][q[i].s[t0+1]]!=a[q[j].s[t1]][q[j].s[t1+1]]) break;
            t0++; t1++;
          }
          y=0;
          for (z=0,t=t0; t<q[i].l; t++) {
            r[c].r0[z++]=a[q[i].s[t]][q[i].s[t+1]];
          } r[c].l0=z;
          for (z=0,t=t1; t<q[j].l-1; t++) {
            r[c].r1[z++]=a[q[j].s[t]][q[j].s[t+1]];
          } r[c].l1=z;
          c++;
        }
      }
    }
  }
}

TGraph::TGraph(void) {
  a=0; b=0; r=0;
  q=0; p=0; e=0;
}
TGraph::~TGraph() {
  relay();
}
void TGraph::relay(void) {
  int i;
  if (a) {
    for (i=0; i<n; i++) if (a[i]) delete[]a[i];
    delete[]a; a=0;
  }
  if (b) delete[]b;
  if (r) {
    for (i=0; i<M+2; i++) {
      if (r[i].r0) delete[]r[i].r0;
      if (r[i].r1) delete[]r[i].r1;
    } delete[]r; r=0;
  }
  if (q) {
    for (i=0; i<n+2; i++) if (q[i].s) delete[]q[i].s;
    delete[]q; q=0;
  }
  if (p) delete[]p;
  if (e) delete[]e;
}
void TGraph::get(FILE*f) {
  relay();
  int i,u,v;
  fscanf(f,"%d%d",&n,&m);
  N=n<<1; M=m<<1;
  a=new int*[n]; b=new int[n]; r=new TRule[M+2];
  q=new TPoint[n+2]; p=new int[N]; e=new int[n];
  for (i=0; i<n; i++) {
    a[i]=new int[n];
    memset(a[i],-1,n*sizeof(int));
    b[i]=0;
  }
  for (i=0; i<M+2; i++) { r[i].r0=new int[n+2]; r[i].r1=new int[n+2]; }
  for (i=0; i<n+2; i++) q[i].s=new int[m];
  c=0;
  for (i=0; i<m; i++) {
    fscanf(f,"%d%d",&u,&v);
    u--; v--;
    if (a[u][v]<0) {
      a[u][v]=i;
      b[v]++;
    } else {
      r[c].r0[0]=a[u][v]; r[c].r1[0]=i;
      r[c].l0=r[c].l1=1;
      c++;
    }
  }
}
void TGraph::put(FILE*f) {
  int i,j;
  fprintf(f,"%d\n",c);
  for (i=0; i<c; i++) {
    for (j=0; j<r[i].l0; j++) fprintf(f,"%d ",r[i].r0[j]+1);
    fprintf(f,"=");
    for (j=0; j<r[i].l1; j++) fprintf(f," %d",r[i].r1[j]+1);
    fprintf(f,"\n");
  }
}
void TGraph::travel(void) {
  int i;
  memset(e,-1,n*sizeof(int));
  l=0; h=0;
  for (i=0; i<n; i++) if ((e[i]<0)&&(b[i]<=0)) seek(i);
}


