const
     FileIn='math.in';
     FileOut='math.out';
     MaxN=300;
     atNumber=0;
     atNone=1;
     atInfinite=2;
     MaxFIFOLen=6000;
     Eps=1e-7;
type
    PAction=^TAction;
    TAction=record
                  ActCh: Char;
                  Number: Integer;
                  Page: Integer;
                  Next: PAction;
            end;
    TPage=record
                ActionsCount: LongInt;
                AnswerType: Byte;
                Number: Extended;
                Action, LastAction: PAction;
          end;
var
   N: LongInt;
   Pages: array [1..MaxN] of TPage;
   FIFO: array [1..MaxFIFOLen] of Integer;
   FIFOLen: LongInt;
   InFIFO, WasProcessed: array [1..MaxN] of Boolean;

procedure AddActionToPage (aNPage: LongInt; aAction: PAction);
begin
     if Pages [aNPage].LastAction=nil
        then begin
             Pages [aNPage].Action:=aAction;
             Pages [aNPage].LastAction:=Pages [aNPage].Action;
        end
        else begin
             Pages [aNPage].LastAction^.Next:=aAction;
             Pages [aNPage].LastAction:=Pages [aNPage].LastAction^.Next;
        end;
end;

procedure ReadData;
var
   F: Text;
   NPage: LongInt;
   NAction: LongInt;
   Action: PAction;
begin
     FillChar (Pages, SizeOf (Pages), 0);
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NPage:=1 to N
         do begin
            Readln (F, Pages [NPage].ActionsCount);
            for NAction:=1 to Pages [NPage].ActionsCount
                do begin
                   Action:=New (PAction);
                   Readln (F, Action^.ActCh, Action^.Number, Action^.Page);
                   Action^.Next:=nil;
                   AddActionToPage (NPage, Action);
                end;
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NPage: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for NPage:=1 to N
         do case Pages [NPage].AnswerType of
                 atNumber: Writeln (F, Pages [NPage].Number);
                 atNone: Writeln (F, 'NONE');
                 atInfinite: Writeln (F, 'INF');
         end;
     Close (F);
end;

procedure DeepSearch;
var
   FIFONode: LongInt;
   Action: PAction;
   NewNumber: Extended;
begin
     FIFOLen:=1;
     FIFO [FIFOLen]:=1;
     FIFONode:=1;
     while (FIFONode<=FIFOLen) and (FIFOLen<MaxFIFOLen-N)
           do begin
              InFIFO [FIFO [FIFOLen]]:=false;
              Action:=Pages [FIFO [FIFONode]].Action;
              while Assigned (Action)
                    do begin
                       case Action^.ActCh of
                            '*': NewNumber:=Pages [FIFO [FIFONode]].Number*Action^.Number;
                            '/': NewNumber:=Pages [FIFO [FIFONode]].Number/Action^.Number;
                       end;
                       case Pages [Action^.Page].AnswerType of
                            atNone: if not InFIFO [Action^.Page]
                                       then begin
                                            Pages [Action^.Page].Number:=NewNumber;
                                            Pages [Action^.Page].AnswerType:=atNumber;
                                            Inc (FIFOLen);
                                            FIFO [FIFOLen]:=Action^.Page;
                                            InFIFO [Action^.Page]:=true;
                                       end;
                            atNumber,
                            atInfinite: if NewNumber>Pages [Action^.Page].Number+Eps
                                           then begin
                                                Pages [Action^.Page].Number:=NewNumber;
                                                if (Pages [Action^.Page].AnswerType=atNumber) and (not InFIFO [Action^.Page])
                                                   then begin
                                                        Inc (FIFOLen);
                                                        FIFO [FIFOLen]:=Action^.Page;
                                                        InFIFO [Action^.Page]:=true;
                                                   end;
                                                if WasProcessed [Action^.Page]
                                                   then Pages [Action^.Page].AnswerType:=atInfinite;
                                           end;
                       end;
                       Action:=Action^.Next;
                    end;
              Inc (FIFONode);
              WasProcessed [FIFO [FIFOLen]]:=true;
           end;
end;

procedure Solve;
var
   NPage: LongInt;
begin
     for NPage:=1 to N
         do Pages [NPage].AnswerType:=atNone;
     Pages [1].Number:=1;
     Pages [1].AnswerType:=atNumber;
     FillChar (InFIFO, SizeOf (InFIFO), false);
     DeepSearch;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
