#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define KK 12
#define eps 1e-10
#define eps1 1e-20
#define eps0 1e-5

struct PP {
  double b,e;
  double m[KK];
  int f;
};

FILE *fi, *fo;
double a[KK];
int k;
double n;
double aa,bb;
long res;
PP w[KK+5];

double f(int k, double *a, double x)
{
  int i;
  double s;
  double xx;
  xx=1;
  s=0;
  for(i=0;i<=k;i++)
  {
    s+=a[i]*xx;
    xx*=x;
  }
  return s;
}

double bfind(int k, double *a, double bb, double ee)
{
  double cc;
  while((ee-bb)>eps)
  {
    cc=(ee+bb)/2.0;
    if(f(k,a,bb)*f(k,a,cc)>eps1)
    {
      bb=cc;
    }
    else
    {
      ee=cc;
    }
  }
  return (bb+ee)/2.0;
}

void solv(int k, double *a, double *x, int *n, double aa, double bb)
{
  double d[KK];
  double y[KK];
  double b,c,e;
  int m;
  int i;
  int q;
  if(k>=2)
  {
    for(i=1;i<=k;i++)
    {
      d[i-1]=a[i]*i;
    }
    solv(k-1,d,y,&m,aa,bb);
    q=0;
    if(m==0)
    {
      b=aa;
      e=bb;
      if(f(k,a,b)*f(k,a,e)>eps)
      {
        *n=0;
        return ;
      }
      else
      {
        c=bfind(k,a,b,e);
        x[0]=c;
        *n=1;
      }
    }
    else
    {
      b=aa;
      e=y[0];
      if(f(k,a,b)*f(k,a,e)<eps)
      {
        x[q]=bfind(k,a,b,e);
        q++;
      }
      for(i=1;i<m;i++)
      {
        b=y[i-1];
        e=y[i];
        if(f(k,a,b)*f(k,a,e)<eps)
        {
          x[q]=bfind(k,a,b,e);
          q++;
        }
      }
      b=y[m-1];
      e=bb;
      if(f(k,a,b)*f(k,a,e)<eps)
      {
        x[q]=bfind(k,a,b,e);
        q++;
      }
      *n=q;
      return ;
    }
  }
  else
  {
    if(k<=0)
    {
      *n=0;
      return ;
    }
    if(k==1)
    {
      c=-a[0]/a[1];
      if((c>aa-eps)&&(c<bb+eps))
      {
        x[0]=c;
        *n=1;
        return ;
      }
      else
      {
        *n=0;
        return ;
      }
    }
  }
}

int main()
{
  double x[KK];
  double d[KK];
  double y[KK];
  int m,l;
  int i,j;
  int r,q;
  fi=fopen("function.in","rt");
  fo=fopen("function.out","wt");

  res=0;
  fscanf(fi,"%lf%lf%lf%i",&n,&aa,&bb,&k);
  for(i=k;i>=0;i--)
  {
    fscanf(fi,"%lf",&a[i]);
  }

  solv(k,a,x,&m,aa,bb);
  for(i=1;i<=k;i++)
  {
    d[i-1]=a[i]*i;
  }
  solv(k-1,d,y,&l,aa,bb);

  q=0;
  if(m>0)
  {
    w[0].b=aa;
    w[0].e=x[0];
    w[0].f=0;
    while((y[q]<w[0].e)&&(q<l))
    {
      w[0].m[w[0].f]=y[q];
      q++;
      w[0].f++;
    }
    for(i=1;i<m;i++)
    {
      w[i].b=x[i-1];
      w[i].e=x[i];
      w[i].f=0;
      while((y[q]<w[i].e)&&(q<l))
      {
        w[i].m[w[i].f]=y[q];
        q++;
        w[i].f++;
      }
    }
    w[m].b=x[m-1];
    w[m].e=bb;
    w[m].f=0;
    while((y[q]<w[m].e)&&(q<l))
    {
      w[m].m[w[m].f]=y[q];
      q++;
      w[m].f++;
    }
  }
  else
  {
    w[0].b=aa;
    w[0].e=bb;
    w[0].f=0;
    while((y[q]<w[0].e)&&(q<l))
    {
      w[0].m[w[0].f]=y[q];
      q++;
      w[0].f++;
    }
  }

  for(i=0;i<=k;i++)
  {
    d[i]=a[i];
  }

  y[0]=(1000.0/n);
  r=(int)y[0];

  for(i=1;i<=r;i++)
  {
    for(j=0;j<=m;j++)
    {
      if(w[j].f)
      {
        if(f(k,a,w[j].m[0])>0)
        {
          d[0]=a[0]-n*i;
          solv(k,d,x,&l,w[j].b,w[j].e);
          if(f(k,d,w[j].e)>-eps)
          {
            x[l]=w[j].e;
            l++;
          }
          if(f(k,d,w[j].b)>-eps)
          {
            for(q=l;q>0;q--) x[q]=x[q-1];
            x[0]=w[j].b;
            l++;
          }
          for(q=0;q<l;q+=2)
          {
            y[0]=(x[q+1]-x[q]+eps)/n+eps0;
            res+=(int)y[0];
          }
        }
        else
        {
          d[0]=a[0]+n*i;
          solv(k,d,x,&l,w[j].b,w[j].e);
          if(f(k,d,w[j].e)<eps)
          {
            x[l]=w[j].e;
            l++;
          }
          if(f(k,d,w[j].b)<eps)
          {
            for(q=l;q>0;q--) x[q]=x[q-1];
            x[0]=w[j].b;
            l++;
          }
          for(q=0;q<l;q+=2)
          {
            y[0]=(x[q+1]-x[q]+eps)/n+eps0;
            res+=(int)y[0];
          }
        }
      }
      else
      {
        if((f(k,a,w[j].b)>eps)||(f(k,a,w[j].e)>eps))
        {
          d[0]=a[0]-i*n;
          if((f(k,d,w[j].b)>-eps)&&(f(k,d,w[j].e)>-eps))
          {
            y[0]=(w[j].e-w[j].b+eps)/n+eps0;
            res+=(int)y[0];
          }
          else
          {
            solv(k,d,x,&l,w[j].b,w[j].e);
            if(f(k,d,w[j].e)>-eps)
            {
              x[l]=w[j].e;
              l++;
            }
            if(f(k,d,w[j].b)>-eps)
            {
              for(q=l;q>0;q--) x[q]=x[q-1];
              x[0]=w[j].b;
              l++;
            }
            for(q=0;q<l;q+=2)
            {
              y[0]=(x[q+1]-x[q]+eps)/n+eps0;
              res+=(int)y[0];
            }
          }
        }
        else
        {
          d[0]=a[0]+i*n;
          if((f(k,d,w[j].b)<eps)&&(f(k,d,w[j].e)<eps))
          {
            y[0]=(w[j].e-w[j].b+eps)/n+eps0;
            res+=(int)y[0];
          }
          else
          {
            solv(k,d,x,&l,w[j].b,w[j].e);
            if(f(k,d,w[j].e)<eps)
            {
              x[l]=w[j].e;
              l++;
            }
            if(f(k,d,w[j].b)<eps)
            {
              for(q=l;q>0;q--) x[q]=x[q-1];
              x[0]=w[j].b;
              l++;
            }
            for(q=0;q<l;q+=2)
            {
              y[0]=(x[q+1]-x[q]+eps)/n+eps0;
              res+=(int)y[0];
            }
          }
        }
      }
    }
  }

  fprintf(fo,"%li\n",res);

  fclose(fi);
  fclose(fo);
  return 0;
}
