{$I+,Q-,R-,S+}
program         Template;

uses
  Save;

type
  TDateTime     = Double;

const
  MONTH_NAME    : array[1..12] of string
                = ('January', 'February', 'March', 'April', 'May', 'June',
                   'July', 'August', 'September', 'October', 'November',
                   'December');
  MONTH_SIZE    : array[1..12] of Integer
                = (31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

var
  N, Shift      : LongInt;
  Times         : array[1..100000] of TDateTime;

procedure       ReadData;
begin
  N := GetSlotNumber;
end;

function        ConvertTime(Time: string): TDateTime;
var
  Day, Mon      : string;
  H, M, S       : string;
  DayNumber     : TDateTime;
  HH, MM, SS    : TDateTime;
  I             : Integer;
begin
  Day := Copy(Time, 1, Pos(' ', Time) - 1); Delete(Time, 1, Pos(' ', Time));
  Mon := Copy(Time, 1, Pos(' ', Time) - 1); Delete(Time, 1, Pos(' ', Time));

  H := Copy(Time, 1, Pos(':', Time) - 1); Delete(Time, 1, Pos(':', Time));
  M := Copy(Time, 1, Pos(':', Time) - 1); Delete(Time, 1, Pos(':', Time));
  S := Time;

  Val(Day, DayNumber); I := 1;
  while MONTH_NAME[I] <> Mon do begin
    DayNumber := DayNumber + MONTH_SIZE[I];
    Inc(I);
  end;

  Val(H, HH);
  Val(M, MM);
  Val(S, SS);

  ConvertTime := DayNumber + HH / 24 + MM / 1440 + SS / 86400;
end;

procedure       RequestTime(K: LongInt);
var
  KK            : LongInt;
begin
  if Times[(K - 1) mod N + 1] = 0 then begin
    KK := (K - 1) mod N + 2;
    if KK = N + 1 then
      KK := 1;

    if Times[KK] = ConvertTime('1 January 00:00:00') then begin
      Times[(K - 1) mod N + 1] := 1000.0;
      Exit;
    end;

    KK := (K - 1) mod N;
    if KK = 0 then
      KK := N;

    if Times[KK] = ConvertTime('31 December 23:59:59') then begin
      Times[(K - 1) mod N + 1] := 0.1;
      Exit;
    end;

    Times[(K - 1) mod N + 1] := ConvertTime(LoadGame((K + Shift - 1) mod N + 1));
  end;
end;

procedure       Report(K: LongInt);
begin
  LastGame((K + Shift - 1) mod N + 1);
end;

procedure       Solve;
var
  L, R, F, Q, P : LongInt;
  I, D          : LongInt;
begin
  Shift := 1326; FillChar(Times, SizeOf(Times), 0);

  if N = 1 then
    Report(1);

  L := 1; R := N; RequestTime(L);
  while R - L > 1 do begin
    F := (L + R) div 2; RequestTime(F);

    if Times[F] > Times[L] then
      L := F
    else if Times[F] < Times[R] then
      R := F
    else if Times[F] < Times[L] then
      R := F;
  end;

  //F := F + 1;
  Q := F; RequestTime(Q);

  D := -1;
  if Q > 1 then
    for I := Q downto 1 do
      if (Times[I] < Times[Q]) and (Times[I] <> 0) then begin
        D := 1;
        Break;
      end;

  repeat
    P := Q; Inc(Q, D);
    if Q = 0 then
      Q := N
    else if Q = N + 1 then
      Q := 1;

    RequestTime(Q);

    if D < 0 then begin
      if (Times[Q] > Times[P]) and (Times[P] <> 0) then
        Break;
    end else begin
      if Times[Q] < Times[P] then
        Break;
    end;
  until False;

  if D < 0 then
    Report(Q)
  else
    Report(P);
end;

begin
  ReadData;
  Solve;
end.
