{$N+}
{.$define debug}

program template;
const
 {$ifdef debug}
 h = 100000;
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 h = 100100;
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$endif}
type
 int = longint;
 real = extended;
var
 n,m :int;
 k :real;
 ans :int;
 a,b :array [1..h] of int;
 d :array [1..h] of int;

procedure init;
begin
 ans := 0;
 randseed := 19;
 fillchar (a,sizeof(a),0);
 fillchar (b,sizeof(b),0);
end;

procedure readdata;
var i,j :longint;
begin
 assign (input,cinfile);
 reset (input);
 readln (n);
 for i := 1 to n do
  read (a[i]);
 read (m);
 for i := 1 to m do
  read (b[i]);
 read (k);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 close (output);
end;

procedure swap (var a,b :int);
begin
 a := a xor b;
 b := a xor b;
 a := a xor b;
end;

procedure sort (l,r :int);
var i,j :longint;
    x :int;
begin
 i := l;
 j := r;
 x := d[l + random(r-l+1)];
 repeat
  while d[i] < x do
   inc (i);
  while d[j] > x do
   dec (j);
  if i <= j then
   begin
    if not (i = j) then
     swap (d[i],d[j]);
    inc (i);
    dec (j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if j > l then
  sort (l,j);
end;

function count (d :int):real;
var i :longint;
    res :real;
    l,r :int;
    mid :int;
    t :int;
begin
 res := 0;
 for i := 1 to n do
  begin
   t := d - a[i];
   if t < 0 then
    break;
   l := 1;
   r := m;
   while r-l>1 do
    begin
     mid := (l+r) shr 1;
     if b[mid] > t then
      r := mid
     else
      l := mid;
    end;
   if b[r] <= t then
    res := res + 1.0*r
   else
    if b[l] <= t then
     res := res + 1.0*l;
  end;
 count := res;
end;



procedure solve;
var i,j :longint;
    l,r :int;
    mid :int;
    c :real;
    p :int;
begin
 move (a,d,sizeof(a));
 sort (1,n);
 move (d,a,sizeof(a));
 {====}
 move (b,d,sizeof(b));
 sort (1,m);
 move (d,b,sizeof(b));
 {====}
 l := a[1] + b[1];
 r := a[n] + b[m];
 while r-l > 1 do
  begin
   mid := (l+r) shr 1;
   c := count(mid);
   if c > k then
    r := mid
   else
    l := mid;
  end;
 if count(l) >= k then
  p := l
 else
  if count (r) >= k then
   p := r;

 while count(p) >= k do
  dec (p);
 ans := p+1;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.